/*
 * This file is part of PySide: Python for Qt
 *
 * Copyright (C) 2009-2010 Nokia Corporation and/or its subsidiary(-ies).
 *
 * Contact: PySide team <contact@pyside.org>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * version 2.1 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA
 *
 */


//workaround to access protected functions
#define protected public

// default includes
#include <shiboken.h>
#include <pysidesignal.h>
#include <pysideproperty.h>
#include <pyside.h>
#include <typeresolver.h>
#include <typeinfo>
#include "pyside_qtcore_python.h"

#include "qxmlstreamnotationdeclaration_wrapper.h"

// Extra includes
#include <qxmlstream.h>



// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QXmlStreamNotationDeclaration_Init(PyObject* self, PyObject* args, PyObject* kwds)
{
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType<QXmlStreamNotationDeclaration >()))
        return -1;

    QXmlStreamNotationDeclaration* cptr = 0;
    int overloadId = -1;
    SbkObject* sbkSelf = reinterpret_cast<SbkObject*>(self);


    int numArgs = PyTuple_GET_SIZE(args);
    PyObject* pyargs[] = {0};

    // invalid argument lengths


    if (!PyArg_UnpackTuple(args, "QXmlStreamNotationDeclaration", 0, 1, &(pyargs[0])))
        return -1;

    // Overloaded function decisor
    // 0: QXmlStreamNotationDeclaration()
    // 1: QXmlStreamNotationDeclaration(QXmlStreamNotationDeclaration)
    if (numArgs == 0) {
        overloadId = 0; // QXmlStreamNotationDeclaration()
    } else if (numArgs == 1 && Shiboken::Converter< ::QXmlStreamNotationDeclaration >::isConvertible(pyargs[0])) {
        overloadId = 1; // QXmlStreamNotationDeclaration(QXmlStreamNotationDeclaration)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_QXmlStreamNotationDeclaration_Init_TypeError;

    // Call function/method
    {
        switch (overloadId) {
            case 0: // QXmlStreamNotationDeclaration()
            {

                if(!PyErr_Occurred()) {
                    // QXmlStreamNotationDeclaration()
                    PyThreadState* _save = PyEval_SaveThread(); // Py_BEGIN_ALLOW_THREADS
                    cptr = new QXmlStreamNotationDeclaration();
                    PyEval_RestoreThread(_save); // Py_END_ALLOW_THREADS
                }
                break;
            }
            case 1: // QXmlStreamNotationDeclaration(QXmlStreamNotationDeclaration)
            {
                if (!Shiboken::Object::isValid(pyargs[0]))
                    return -1;
                QXmlStreamNotationDeclaration cppArg0 = Shiboken::Converter<QXmlStreamNotationDeclaration >::toCpp(pyargs[0]);

                if(!PyErr_Occurred()) {
                    // QXmlStreamNotationDeclaration(QXmlStreamNotationDeclaration)
                    PyThreadState* _save = PyEval_SaveThread(); // Py_BEGIN_ALLOW_THREADS
                    cptr = new QXmlStreamNotationDeclaration(cppArg0);
                    PyEval_RestoreThread(_save); // Py_END_ALLOW_THREADS
                }
                break;
            }
        }
    }

    if (PyErr_Occurred() || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType<QXmlStreamNotationDeclaration >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (!cptr) goto Sbk_QXmlStreamNotationDeclaration_Init_TypeError;

    Shiboken::Object::setValidCpp(sbkSelf, true);
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;

    Sbk_QXmlStreamNotationDeclaration_Init_TypeError:
        const char* overloads[] = {"", "PySide.QtCore.QXmlStreamNotationDeclaration", 0};
        Shiboken::setErrorAboutWrongArguments(args, "PySide.QtCore.QXmlStreamNotationDeclaration", overloads);
        return -1;
}

static PyObject* Sbk_QXmlStreamNotationDeclarationFunc_name(PyObject* self)
{
    QXmlStreamNotationDeclaration* cppSelf = 0;
    if (!Shiboken::Object::isValid(self))
        return 0;
    cppSelf = Shiboken::Converter< QXmlStreamNotationDeclaration* >::toCpp(self);

    PyObject* pyResult = 0;

    // Call function/method
    {
        {

            if(!PyErr_Occurred()) {
                // name()const
                PyThreadState* _save = PyEval_SaveThread(); // Py_BEGIN_ALLOW_THREADS
                QStringRef cppResult = cppSelf->name();
                PyEval_RestoreThread(_save); // Py_END_ALLOW_THREADS
                pyResult = Shiboken::Converter< QStringRef >::toPython(cppResult);
            }
        }
    }


    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return 0;
    }
    return pyResult;
}

static PyObject* Sbk_QXmlStreamNotationDeclarationFunc_publicId(PyObject* self)
{
    QXmlStreamNotationDeclaration* cppSelf = 0;
    if (!Shiboken::Object::isValid(self))
        return 0;
    cppSelf = Shiboken::Converter< QXmlStreamNotationDeclaration* >::toCpp(self);

    PyObject* pyResult = 0;

    // Call function/method
    {
        {

            if(!PyErr_Occurred()) {
                // publicId()const
                PyThreadState* _save = PyEval_SaveThread(); // Py_BEGIN_ALLOW_THREADS
                QStringRef cppResult = cppSelf->publicId();
                PyEval_RestoreThread(_save); // Py_END_ALLOW_THREADS
                pyResult = Shiboken::Converter< QStringRef >::toPython(cppResult);
            }
        }
    }


    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return 0;
    }
    return pyResult;
}

static PyObject* Sbk_QXmlStreamNotationDeclarationFunc_systemId(PyObject* self)
{
    QXmlStreamNotationDeclaration* cppSelf = 0;
    if (!Shiboken::Object::isValid(self))
        return 0;
    cppSelf = Shiboken::Converter< QXmlStreamNotationDeclaration* >::toCpp(self);

    PyObject* pyResult = 0;

    // Call function/method
    {
        {

            if(!PyErr_Occurred()) {
                // systemId()const
                PyThreadState* _save = PyEval_SaveThread(); // Py_BEGIN_ALLOW_THREADS
                QStringRef cppResult = cppSelf->systemId();
                PyEval_RestoreThread(_save); // Py_END_ALLOW_THREADS
                pyResult = Shiboken::Converter< QStringRef >::toPython(cppResult);
            }
        }
    }


    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return 0;
    }
    return pyResult;
}

static PyObject *Sbk_QXmlStreamNotationDeclaration___copy__(PyObject *self)
{
        QXmlStreamNotationDeclaration* cppSelf = 0;
        if (!Shiboken::Object::isValid(self))
            return 0;
        cppSelf = Shiboken::Converter<QXmlStreamNotationDeclaration*>::toCpp(self);
        PyObject* pyResult = 0;
        QXmlStreamNotationDeclaration* copy = new QXmlStreamNotationDeclaration(*cppSelf);
        pyResult = Shiboken::Converter<QXmlStreamNotationDeclaration*>::toPython(copy);
        Shiboken::Object::getOwnership(pyResult);

        if (PyErr_Occurred() || !pyResult) {
            Py_XDECREF(pyResult);
            return 0;
        }
        return pyResult;
}

static PyMethodDef Sbk_QXmlStreamNotationDeclaration_methods[] = {
    {"name", (PyCFunction)Sbk_QXmlStreamNotationDeclarationFunc_name, METH_NOARGS},
    {"publicId", (PyCFunction)Sbk_QXmlStreamNotationDeclarationFunc_publicId, METH_NOARGS},
    {"systemId", (PyCFunction)Sbk_QXmlStreamNotationDeclarationFunc_systemId, METH_NOARGS},

    {"__copy__", (PyCFunction)Sbk_QXmlStreamNotationDeclaration___copy__, METH_NOARGS},
    {0} // Sentinel
};

// Rich comparison
static PyObject* Sbk_QXmlStreamNotationDeclaration_richcompare(PyObject* self, PyObject* arg, int op)
{
    PyObject* pyResult = 0;
    QXmlStreamNotationDeclaration& cppSelf = *Shiboken::Converter< QXmlStreamNotationDeclaration* >::toCpp(self);

    switch (op) {
        case Py_NE:
            if (Shiboken::Converter< ::QXmlStreamNotationDeclaration >::isConvertible(arg)) {
                // operator!=(const QXmlStreamNotationDeclaration & other) const
                QXmlStreamNotationDeclaration cppArg0 = Shiboken::Converter< ::QXmlStreamNotationDeclaration >::toCpp(arg);
                pyResult = Shiboken::Converter< bool >::toPython(cppSelf != cppArg0);
            } else goto Sbk_QXmlStreamNotationDeclaration_RichComparison_TypeError;

            break;
        case Py_EQ:
            if (Shiboken::Converter< ::QXmlStreamNotationDeclaration >::isConvertible(arg)) {
                // operator==(const QXmlStreamNotationDeclaration & other) const
                QXmlStreamNotationDeclaration cppArg0 = Shiboken::Converter< ::QXmlStreamNotationDeclaration >::toCpp(arg);
                pyResult = Shiboken::Converter< bool >::toPython(cppSelf == cppArg0);
            } else goto Sbk_QXmlStreamNotationDeclaration_RichComparison_TypeError;

            break;
        default:
            goto Sbk_QXmlStreamNotationDeclaration_RichComparison_TypeError;
    }

    if (pyResult && !PyErr_Occurred())
        return pyResult;
    Sbk_QXmlStreamNotationDeclaration_RichComparison_TypeError:
    PyErr_SetString(PyExc_NotImplementedError, "operator not implemented.");
    return 0;

}

} // extern "C"

// Class Definition -----------------------------------------------
extern "C" {
static SbkObjectType Sbk_QXmlStreamNotationDeclaration_Type = { { {
    PyObject_HEAD_INIT(&SbkObjectType_Type)
    /*ob_size*/             0,
    /*tp_name*/             "PySide.QtCore.QXmlStreamNotationDeclaration",
    /*tp_basicsize*/        sizeof(SbkObject),
    /*tp_itemsize*/         0,
    /*tp_dealloc*/          &SbkDeallocWrapper,
    /*tp_print*/            0,
    /*tp_getattr*/          0,
    /*tp_setattr*/          0,
    /*tp_compare*/          0,
    /*tp_repr*/             0,
    /*tp_as_number*/        0,
    /*tp_as_sequence*/      0,
    /*tp_as_mapping*/       0,
    /*tp_hash*/             0,
    /*tp_call*/             0,
    /*tp_str*/              0,
    /*tp_getattro*/         0,
    /*tp_setattro*/         0,
    /*tp_as_buffer*/        0,
    /*tp_flags*/            Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_CHECKTYPES,
    /*tp_doc*/              0,
    /*tp_traverse*/         0,
    /*tp_clear*/            0,
    /*tp_richcompare*/      Sbk_QXmlStreamNotationDeclaration_richcompare,
    /*tp_weaklistoffset*/   0,
    /*tp_iter*/             0,
    /*tp_iternext*/         0,
    /*tp_methods*/          Sbk_QXmlStreamNotationDeclaration_methods,
    /*tp_members*/          0,
    /*tp_getset*/           0,
    /*tp_base*/             reinterpret_cast<PyTypeObject*>(&SbkObject_Type),
    /*tp_dict*/             0,
    /*tp_descr_get*/        0,
    /*tp_descr_set*/        0,
    /*tp_dictoffset*/       0,
    /*tp_init*/             Sbk_QXmlStreamNotationDeclaration_Init,
    /*tp_alloc*/            0,
    /*tp_new*/              SbkObjectTpNew,
    /*tp_free*/             0,
    /*tp_is_gc*/            0,
    /*tp_bases*/            0,
    /*tp_mro*/              0,
    /*tp_cache*/            0,
    /*tp_subclasses*/       0,
    /*tp_weaklist*/         0
}, },
    /*priv_data*/           0
};
} //extern


void init_QXmlStreamNotationDeclaration(PyObject* module)
{
    SbkPySide_QtCoreTypes[SBK_QXMLSTREAMNOTATIONDECLARATION_IDX] = reinterpret_cast<PyTypeObject*>(&Sbk_QXmlStreamNotationDeclaration_Type);

    Shiboken::ObjectType::initPrivateData(&Sbk_QXmlStreamNotationDeclaration_Type);
    Shiboken::ObjectType::setDestructorFunction(&Sbk_QXmlStreamNotationDeclaration_Type, &Shiboken::callCppDestructor<QXmlStreamNotationDeclaration >);
    if (PyType_Ready((PyTypeObject*)&Sbk_QXmlStreamNotationDeclaration_Type) < 0)
        return;

    Shiboken::ObjectType::setOriginalName(&Sbk_QXmlStreamNotationDeclaration_Type, "QXmlStreamNotationDeclaration");
    PyModule_AddObject(module, "QXmlStreamNotationDeclaration",
        ((PyObject*)&Sbk_QXmlStreamNotationDeclaration_Type));


    Shiboken::TypeResolver::createValueTypeResolver<QXmlStreamNotationDeclaration >("QXmlStreamNotationDeclaration");
    Shiboken::TypeResolver::createObjectTypeResolver<QXmlStreamNotationDeclaration >("QXmlStreamNotationDeclaration*");
    Shiboken::TypeResolver::createValueTypeResolver<QXmlStreamNotationDeclaration >(typeid(QXmlStreamNotationDeclaration).name());
    PySide::initQtMetaType<QXmlStreamNotationDeclaration >();
}

