/*
 * This file is part of PySide: Python for Qt
 *
 * Copyright (C) 2009-2010 Nokia Corporation and/or its subsidiary(-ies).
 *
 * Contact: PySide team <contact@pyside.org>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * version 2.1 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA
 *
 */


//workaround to access protected functions
#define protected public

// default includes
#include <shiboken.h>
#include <pysidesignal.h>
#include <pysideproperty.h>
#include <pyside.h>
#include <typeresolver.h>
#include <typeinfo>
#include "pyside_qtgui_python.h"

#include "qstyleoptionheader_wrapper.h"

// Extra includes
#include <qstyleoption.h>
#include <qwidget.h>



// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QStyleOptionHeader_Init(PyObject* self, PyObject* args, PyObject* kwds)
{
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType<QStyleOptionHeader >()))
        return -1;

    QStyleOptionHeader* cptr = 0;
    int overloadId = -1;
    SbkObject* sbkSelf = reinterpret_cast<SbkObject*>(self);


    int numArgs = PyTuple_GET_SIZE(args);
    PyObject* pyargs[] = {0};

    // invalid argument lengths


    if (!PyArg_UnpackTuple(args, "QStyleOptionHeader", 0, 1, &(pyargs[0])))
        return -1;

    // Overloaded function decisor
    // 0: QStyleOptionHeader()
    // 1: QStyleOptionHeader(QStyleOptionHeader)
    // 2: QStyleOptionHeader(int)
    if (numArgs == 0) {
        overloadId = 0; // QStyleOptionHeader()
    } else if (numArgs == 1 && SbkNumber_Check(pyargs[0])) {
        overloadId = 2; // QStyleOptionHeader(int)
    } else if (numArgs == 1 && Shiboken::Converter< ::QStyleOptionHeader >::isConvertible(pyargs[0])) {
        overloadId = 1; // QStyleOptionHeader(QStyleOptionHeader)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_QStyleOptionHeader_Init_TypeError;

    // Call function/method
    {
        switch (overloadId) {
            case 0: // QStyleOptionHeader()
            {

                if(!PyErr_Occurred()) {
                    // QStyleOptionHeader()
                    PyThreadState* _save = PyEval_SaveThread(); // Py_BEGIN_ALLOW_THREADS
                    cptr = new QStyleOptionHeader();
                    PyEval_RestoreThread(_save); // Py_END_ALLOW_THREADS
                }
                break;
            }
            case 1: // QStyleOptionHeader(QStyleOptionHeader)
            {
                if (!Shiboken::Object::isValid(pyargs[0]))
                    return -1;
                QStyleOptionHeader cppArg0 = Shiboken::Converter<QStyleOptionHeader >::toCpp(pyargs[0]);

                if(!PyErr_Occurred()) {
                    // QStyleOptionHeader(QStyleOptionHeader)
                    PyThreadState* _save = PyEval_SaveThread(); // Py_BEGIN_ALLOW_THREADS
                    cptr = new QStyleOptionHeader(cppArg0);
                    PyEval_RestoreThread(_save); // Py_END_ALLOW_THREADS
                }
                break;
            }
            case 2: // QStyleOptionHeader(int)
            {
                int cppArg0 = Shiboken::Converter<int >::toCpp(pyargs[0]);

                if(!PyErr_Occurred()) {
                    // QStyleOptionHeader(int)
                    PyThreadState* _save = PyEval_SaveThread(); // Py_BEGIN_ALLOW_THREADS
                    cptr = new QStyleOptionHeader(cppArg0);
                    PyEval_RestoreThread(_save); // Py_END_ALLOW_THREADS
                }
                break;
            }
        }
    }

    if (PyErr_Occurred() || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType<QStyleOptionHeader >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (!cptr) goto Sbk_QStyleOptionHeader_Init_TypeError;

    Shiboken::Object::setValidCpp(sbkSelf, true);
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;

    Sbk_QStyleOptionHeader_Init_TypeError:
        const char* overloads[] = {"", "PySide.QtGui.QStyleOptionHeader", "int", 0};
        Shiboken::setErrorAboutWrongArguments(args, "PySide.QtGui.QStyleOptionHeader", overloads);
        return -1;
}

static PyObject *Sbk_QStyleOptionHeader___copy__(PyObject *self)
{
        QStyleOptionHeader* cppSelf = 0;
        if (!Shiboken::Object::isValid(self))
            return 0;
        cppSelf = Shiboken::Converter<QStyleOptionHeader*>::toCpp(self);
        PyObject* pyResult = 0;
        QStyleOptionHeader* copy = new QStyleOptionHeader(*cppSelf);
        pyResult = Shiboken::Converter<QStyleOptionHeader*>::toPython(copy);
        Shiboken::Object::getOwnership(pyResult);

        if (PyErr_Occurred() || !pyResult) {
            Py_XDECREF(pyResult);
            return 0;
        }
        return pyResult;
}

static PyMethodDef Sbk_QStyleOptionHeader_methods[] = {

    {"__copy__", (PyCFunction)Sbk_QStyleOptionHeader___copy__, METH_NOARGS},
    {0} // Sentinel
};

static PyObject* Sbk_QStyleOptionHeader_get_section(PyObject* self, void*)
{
    PyObject* val = Shiboken::Converter< int >::toPython( Shiboken::Converter< QStyleOptionHeader* >::toCpp(self)->section);
    return val;

}
static int Sbk_QStyleOptionHeader_set_section(PyObject* self, PyObject* value, void*)
{
    if (value == 0) {
        PyErr_SetString(PyExc_TypeError, "'section' may not be deleted");
        return -1;
    }
    if (!SbkNumber_Check(value)) {
        PyErr_SetString(PyExc_TypeError, "wrong type attributed to 'section', 'int' or convertible type expected");
        return -1;
    }

    Shiboken::Converter< QStyleOptionHeader* >::toCpp(self)->section = Shiboken::Converter< int >::toCpp(value);

    return 0;
}

static PyObject* Sbk_QStyleOptionHeader_get_sortIndicator(PyObject* self, void*)
{
    PyObject* val = Shiboken::Converter< ::QStyleOptionHeader::SortIndicator >::toPython( Shiboken::Converter< QStyleOptionHeader* >::toCpp(self)->sortIndicator);
    return val;

}
static int Sbk_QStyleOptionHeader_set_sortIndicator(PyObject* self, PyObject* value, void*)
{
    if (value == 0) {
        PyErr_SetString(PyExc_TypeError, "'sortIndicator' may not be deleted");
        return -1;
    }
    if (!Shiboken::Converter< ::QStyleOptionHeader::SortIndicator >::isConvertible(value)) {
        PyErr_SetString(PyExc_TypeError, "wrong type attributed to 'sortIndicator', 'SortIndicator' or convertible type expected");
        return -1;
    }

    Shiboken::Converter< QStyleOptionHeader* >::toCpp(self)->sortIndicator = Shiboken::Converter< ::QStyleOptionHeader::SortIndicator >::toCpp(value);

    return 0;
}

static PyObject* Sbk_QStyleOptionHeader_get_position(PyObject* self, void*)
{
    PyObject* val = Shiboken::Converter< ::QStyleOptionHeader::SectionPosition >::toPython( Shiboken::Converter< QStyleOptionHeader* >::toCpp(self)->position);
    return val;

}
static int Sbk_QStyleOptionHeader_set_position(PyObject* self, PyObject* value, void*)
{
    if (value == 0) {
        PyErr_SetString(PyExc_TypeError, "'position' may not be deleted");
        return -1;
    }
    if (!Shiboken::Converter< ::QStyleOptionHeader::SectionPosition >::isConvertible(value)) {
        PyErr_SetString(PyExc_TypeError, "wrong type attributed to 'position', 'SectionPosition' or convertible type expected");
        return -1;
    }

    Shiboken::Converter< QStyleOptionHeader* >::toCpp(self)->position = Shiboken::Converter< ::QStyleOptionHeader::SectionPosition >::toCpp(value);

    return 0;
}

static PyObject* Sbk_QStyleOptionHeader_get_icon(PyObject* self, void*)
{
    PyObject* val =     Shiboken::createWrapper(&Shiboken::Converter< QStyleOptionHeader* >::toCpp(self)->icon);
    Shiboken::Object::releaseOwnership(val);
    return val;

}
static int Sbk_QStyleOptionHeader_set_icon(PyObject* self, PyObject* value, void*)
{
    if (value == 0) {
        PyErr_SetString(PyExc_TypeError, "'icon' may not be deleted");
        return -1;
    }
    if (!Shiboken::Converter< ::QIcon >::isConvertible(value)) {
        PyErr_SetString(PyExc_TypeError, "wrong type attributed to 'icon', 'QIcon' or convertible type expected");
        return -1;
    }

    Shiboken::Converter< QStyleOptionHeader* >::toCpp(self)->icon = Shiboken::Converter< ::QIcon >::toCpp(value);

    return 0;
}

static PyObject* Sbk_QStyleOptionHeader_get_textAlignment(PyObject* self, void*)
{
    PyObject* val =     Shiboken::createWrapper(&Shiboken::Converter< QStyleOptionHeader* >::toCpp(self)->textAlignment);
    Shiboken::Object::releaseOwnership(val);
    return val;

}
static int Sbk_QStyleOptionHeader_set_textAlignment(PyObject* self, PyObject* value, void*)
{
    if (value == 0) {
        PyErr_SetString(PyExc_TypeError, "'textAlignment' may not be deleted");
        return -1;
    }
    if (!Shiboken::Converter< ::QFlags<Qt::AlignmentFlag> >::isConvertible(value)) {
        PyErr_SetString(PyExc_TypeError, "wrong type attributed to 'textAlignment', 'Alignment' or convertible type expected");
        return -1;
    }

    Shiboken::Converter< QStyleOptionHeader* >::toCpp(self)->textAlignment = Shiboken::Converter< ::QFlags<Qt::AlignmentFlag> >::toCpp(value);

    return 0;
}

static PyObject* Sbk_QStyleOptionHeader_get_text(PyObject* self, void*)
{
    PyObject* val = Shiboken::Converter< QString >::toPython( Shiboken::Converter< QStyleOptionHeader* >::toCpp(self)->text);
    return val;

}
static int Sbk_QStyleOptionHeader_set_text(PyObject* self, PyObject* value, void*)
{
    if (value == 0) {
        PyErr_SetString(PyExc_TypeError, "'text' may not be deleted");
        return -1;
    }
    if (!Shiboken::Converter< QString >::isConvertible(value)) {
        PyErr_SetString(PyExc_TypeError, "wrong type attributed to 'text', 'QString' or convertible type expected");
        return -1;
    }

    Shiboken::Converter< QStyleOptionHeader* >::toCpp(self)->text = Shiboken::Converter< QString >::toCpp(value);

    return 0;
}

static PyObject* Sbk_QStyleOptionHeader_get_selectedPosition(PyObject* self, void*)
{
    PyObject* val = Shiboken::Converter< ::QStyleOptionHeader::SelectedPosition >::toPython( Shiboken::Converter< QStyleOptionHeader* >::toCpp(self)->selectedPosition);
    return val;

}
static int Sbk_QStyleOptionHeader_set_selectedPosition(PyObject* self, PyObject* value, void*)
{
    if (value == 0) {
        PyErr_SetString(PyExc_TypeError, "'selectedPosition' may not be deleted");
        return -1;
    }
    if (!Shiboken::Converter< ::QStyleOptionHeader::SelectedPosition >::isConvertible(value)) {
        PyErr_SetString(PyExc_TypeError, "wrong type attributed to 'selectedPosition', 'SelectedPosition' or convertible type expected");
        return -1;
    }

    Shiboken::Converter< QStyleOptionHeader* >::toCpp(self)->selectedPosition = Shiboken::Converter< ::QStyleOptionHeader::SelectedPosition >::toCpp(value);

    return 0;
}

static PyObject* Sbk_QStyleOptionHeader_get_iconAlignment(PyObject* self, void*)
{
    PyObject* val =     Shiboken::createWrapper(&Shiboken::Converter< QStyleOptionHeader* >::toCpp(self)->iconAlignment);
    Shiboken::Object::releaseOwnership(val);
    return val;

}
static int Sbk_QStyleOptionHeader_set_iconAlignment(PyObject* self, PyObject* value, void*)
{
    if (value == 0) {
        PyErr_SetString(PyExc_TypeError, "'iconAlignment' may not be deleted");
        return -1;
    }
    if (!Shiboken::Converter< ::QFlags<Qt::AlignmentFlag> >::isConvertible(value)) {
        PyErr_SetString(PyExc_TypeError, "wrong type attributed to 'iconAlignment', 'Alignment' or convertible type expected");
        return -1;
    }

    Shiboken::Converter< QStyleOptionHeader* >::toCpp(self)->iconAlignment = Shiboken::Converter< ::QFlags<Qt::AlignmentFlag> >::toCpp(value);

    return 0;
}

static PyObject* Sbk_QStyleOptionHeader_get_orientation(PyObject* self, void*)
{
    PyObject* val = Shiboken::Converter< ::Qt::Orientation >::toPython( Shiboken::Converter< QStyleOptionHeader* >::toCpp(self)->orientation);
    return val;

}
static int Sbk_QStyleOptionHeader_set_orientation(PyObject* self, PyObject* value, void*)
{
    if (value == 0) {
        PyErr_SetString(PyExc_TypeError, "'orientation' may not be deleted");
        return -1;
    }
    if (!Shiboken::Converter< ::Qt::Orientation >::isConvertible(value)) {
        PyErr_SetString(PyExc_TypeError, "wrong type attributed to 'orientation', 'Orientation' or convertible type expected");
        return -1;
    }

    Shiboken::Converter< QStyleOptionHeader* >::toCpp(self)->orientation = Shiboken::Converter< ::Qt::Orientation >::toCpp(value);

    return 0;
}

// Getters and Setters for QStyleOptionHeader
static PyGetSetDef Sbk_QStyleOptionHeader_getsetlist[] = {
    {const_cast<char*>("section"), Sbk_QStyleOptionHeader_get_section, Sbk_QStyleOptionHeader_set_section},
    {const_cast<char*>("sortIndicator"), Sbk_QStyleOptionHeader_get_sortIndicator, Sbk_QStyleOptionHeader_set_sortIndicator},
    {const_cast<char*>("position"), Sbk_QStyleOptionHeader_get_position, Sbk_QStyleOptionHeader_set_position},
    {const_cast<char*>("icon"), Sbk_QStyleOptionHeader_get_icon, Sbk_QStyleOptionHeader_set_icon},
    {const_cast<char*>("textAlignment"), Sbk_QStyleOptionHeader_get_textAlignment, Sbk_QStyleOptionHeader_set_textAlignment},
    {const_cast<char*>("text"), Sbk_QStyleOptionHeader_get_text, Sbk_QStyleOptionHeader_set_text},
    {const_cast<char*>("selectedPosition"), Sbk_QStyleOptionHeader_get_selectedPosition, Sbk_QStyleOptionHeader_set_selectedPosition},
    {const_cast<char*>("iconAlignment"), Sbk_QStyleOptionHeader_get_iconAlignment, Sbk_QStyleOptionHeader_set_iconAlignment},
    {const_cast<char*>("orientation"), Sbk_QStyleOptionHeader_get_orientation, Sbk_QStyleOptionHeader_set_orientation},
    {0}  // Sentinel
};

} // extern "C"

// Class Definition -----------------------------------------------
extern "C" {
static SbkObjectType Sbk_QStyleOptionHeader_Type = { { {
    PyObject_HEAD_INIT(&SbkObjectType_Type)
    /*ob_size*/             0,
    /*tp_name*/             "PySide.QtGui.QStyleOptionHeader",
    /*tp_basicsize*/        sizeof(SbkObject),
    /*tp_itemsize*/         0,
    /*tp_dealloc*/          &SbkDeallocWrapper,
    /*tp_print*/            0,
    /*tp_getattr*/          0,
    /*tp_setattr*/          0,
    /*tp_compare*/          0,
    /*tp_repr*/             0,
    /*tp_as_number*/        0,
    /*tp_as_sequence*/      0,
    /*tp_as_mapping*/       0,
    /*tp_hash*/             0,
    /*tp_call*/             0,
    /*tp_str*/              0,
    /*tp_getattro*/         0,
    /*tp_setattro*/         0,
    /*tp_as_buffer*/        0,
    /*tp_flags*/            Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_CHECKTYPES,
    /*tp_doc*/              0,
    /*tp_traverse*/         0,
    /*tp_clear*/            0,
    /*tp_richcompare*/      0,
    /*tp_weaklistoffset*/   0,
    /*tp_iter*/             0,
    /*tp_iternext*/         0,
    /*tp_methods*/          Sbk_QStyleOptionHeader_methods,
    /*tp_members*/          0,
    /*tp_getset*/           Sbk_QStyleOptionHeader_getsetlist,
    /*tp_base*/             0,
    /*tp_dict*/             0,
    /*tp_descr_get*/        0,
    /*tp_descr_set*/        0,
    /*tp_dictoffset*/       0,
    /*tp_init*/             Sbk_QStyleOptionHeader_Init,
    /*tp_alloc*/            0,
    /*tp_new*/              SbkObjectTpNew,
    /*tp_free*/             0,
    /*tp_is_gc*/            0,
    /*tp_bases*/            0,
    /*tp_mro*/              0,
    /*tp_cache*/            0,
    /*tp_subclasses*/       0,
    /*tp_weaklist*/         0
}, },
    /*priv_data*/           0
};
} //extern


void init_QStyleOptionHeader(PyObject* module)
{
    SbkPySide_QtGuiTypes[SBK_QSTYLEOPTIONHEADER_IDX] = reinterpret_cast<PyTypeObject*>(&Sbk_QStyleOptionHeader_Type);

    Shiboken::ObjectType::initPrivateData(&Sbk_QStyleOptionHeader_Type);
    Sbk_QStyleOptionHeader_Type.super.ht_type.tp_base = SbkPySide_QtGuiTypes[SBK_QSTYLEOPTION_IDX];
    Shiboken::ObjectType::setDestructorFunction(&Sbk_QStyleOptionHeader_Type, &Shiboken::callCppDestructor<QStyleOptionHeader >);
    if (PyType_Ready((PyTypeObject*)&Sbk_QStyleOptionHeader_Type) < 0)
        return;

    Shiboken::ObjectType::setOriginalName(&Sbk_QStyleOptionHeader_Type, "QStyleOptionHeader");
    PyModule_AddObject(module, "QStyleOptionHeader",
        ((PyObject*)&Sbk_QStyleOptionHeader_Type));

    // Initialize enums
    PyObject* enumItem;

    // init enum: StyleOptionVersion
    PyTypeObject* SbkPySide_QtGui_QStyleOptionHeader_StyleOptionVersion = Shiboken::Enum::newType("StyleOptionVersion");
    SbkPySide_QtGuiTypes[SBK_QSTYLEOPTIONHEADER_STYLEOPTIONVERSION_IDX] = SbkPySide_QtGui_QStyleOptionHeader_StyleOptionVersion;
    if (PyType_Ready(SbkPySide_QtGui_QStyleOptionHeader_StyleOptionVersion) < 0)
        return;
    PyDict_SetItemString(Sbk_QStyleOptionHeader_Type.super.ht_type.tp_dict,
            "StyleOptionVersion",((PyObject*)SbkPySide_QtGui_QStyleOptionHeader_StyleOptionVersion));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtGui_QStyleOptionHeader_StyleOptionVersion,(long) QStyleOptionHeader::Version, "Version");
    PyDict_SetItemString(Sbk_QStyleOptionHeader_Type.super.ht_type.tp_dict,"Version", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtGui_QStyleOptionHeader_StyleOptionVersion->tp_dict,"Version", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("QStyleOptionHeader::StyleOptionVersion");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::StyleOptionVersion");
    // end of enum StyleOptionVersion

    // init enum: SectionPosition
    PyTypeObject* SbkPySide_QtGui_QStyleOptionHeader_SectionPosition = Shiboken::Enum::newType("SectionPosition");
    SbkPySide_QtGuiTypes[SBK_QSTYLEOPTIONHEADER_SECTIONPOSITION_IDX] = SbkPySide_QtGui_QStyleOptionHeader_SectionPosition;
    if (PyType_Ready(SbkPySide_QtGui_QStyleOptionHeader_SectionPosition) < 0)
        return;
    PyDict_SetItemString(Sbk_QStyleOptionHeader_Type.super.ht_type.tp_dict,
            "SectionPosition",((PyObject*)SbkPySide_QtGui_QStyleOptionHeader_SectionPosition));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtGui_QStyleOptionHeader_SectionPosition,(long) QStyleOptionHeader::Beginning, "Beginning");
    PyDict_SetItemString(Sbk_QStyleOptionHeader_Type.super.ht_type.tp_dict,"Beginning", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtGui_QStyleOptionHeader_SectionPosition->tp_dict,"Beginning", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtGui_QStyleOptionHeader_SectionPosition,(long) QStyleOptionHeader::Middle, "Middle");
    PyDict_SetItemString(Sbk_QStyleOptionHeader_Type.super.ht_type.tp_dict,"Middle", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtGui_QStyleOptionHeader_SectionPosition->tp_dict,"Middle", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtGui_QStyleOptionHeader_SectionPosition,(long) QStyleOptionHeader::End, "End");
    PyDict_SetItemString(Sbk_QStyleOptionHeader_Type.super.ht_type.tp_dict,"End", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtGui_QStyleOptionHeader_SectionPosition->tp_dict,"End", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtGui_QStyleOptionHeader_SectionPosition,(long) QStyleOptionHeader::OnlyOneSection, "OnlyOneSection");
    PyDict_SetItemString(Sbk_QStyleOptionHeader_Type.super.ht_type.tp_dict,"OnlyOneSection", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtGui_QStyleOptionHeader_SectionPosition->tp_dict,"OnlyOneSection", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("QStyleOptionHeader::SectionPosition");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::SectionPosition");
    // end of enum SectionPosition

    // init enum: SelectedPosition
    PyTypeObject* SbkPySide_QtGui_QStyleOptionHeader_SelectedPosition = Shiboken::Enum::newType("SelectedPosition");
    SbkPySide_QtGuiTypes[SBK_QSTYLEOPTIONHEADER_SELECTEDPOSITION_IDX] = SbkPySide_QtGui_QStyleOptionHeader_SelectedPosition;
    if (PyType_Ready(SbkPySide_QtGui_QStyleOptionHeader_SelectedPosition) < 0)
        return;
    PyDict_SetItemString(Sbk_QStyleOptionHeader_Type.super.ht_type.tp_dict,
            "SelectedPosition",((PyObject*)SbkPySide_QtGui_QStyleOptionHeader_SelectedPosition));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtGui_QStyleOptionHeader_SelectedPosition,(long) QStyleOptionHeader::NotAdjacent, "NotAdjacent");
    PyDict_SetItemString(Sbk_QStyleOptionHeader_Type.super.ht_type.tp_dict,"NotAdjacent", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtGui_QStyleOptionHeader_SelectedPosition->tp_dict,"NotAdjacent", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtGui_QStyleOptionHeader_SelectedPosition,(long) QStyleOptionHeader::NextIsSelected, "NextIsSelected");
    PyDict_SetItemString(Sbk_QStyleOptionHeader_Type.super.ht_type.tp_dict,"NextIsSelected", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtGui_QStyleOptionHeader_SelectedPosition->tp_dict,"NextIsSelected", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtGui_QStyleOptionHeader_SelectedPosition,(long) QStyleOptionHeader::PreviousIsSelected, "PreviousIsSelected");
    PyDict_SetItemString(Sbk_QStyleOptionHeader_Type.super.ht_type.tp_dict,"PreviousIsSelected", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtGui_QStyleOptionHeader_SelectedPosition->tp_dict,"PreviousIsSelected", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtGui_QStyleOptionHeader_SelectedPosition,(long) QStyleOptionHeader::NextAndPreviousAreSelected, "NextAndPreviousAreSelected");
    PyDict_SetItemString(Sbk_QStyleOptionHeader_Type.super.ht_type.tp_dict,"NextAndPreviousAreSelected", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtGui_QStyleOptionHeader_SelectedPosition->tp_dict,"NextAndPreviousAreSelected", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("QStyleOptionHeader::SelectedPosition");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::SelectedPosition");
    // end of enum SelectedPosition

    // init enum: StyleOptionType
    PyTypeObject* SbkPySide_QtGui_QStyleOptionHeader_StyleOptionType = Shiboken::Enum::newType("StyleOptionType");
    SbkPySide_QtGuiTypes[SBK_QSTYLEOPTIONHEADER_STYLEOPTIONTYPE_IDX] = SbkPySide_QtGui_QStyleOptionHeader_StyleOptionType;
    if (PyType_Ready(SbkPySide_QtGui_QStyleOptionHeader_StyleOptionType) < 0)
        return;
    PyDict_SetItemString(Sbk_QStyleOptionHeader_Type.super.ht_type.tp_dict,
            "StyleOptionType",((PyObject*)SbkPySide_QtGui_QStyleOptionHeader_StyleOptionType));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtGui_QStyleOptionHeader_StyleOptionType,(long) QStyleOptionHeader::Type, "Type");
    PyDict_SetItemString(Sbk_QStyleOptionHeader_Type.super.ht_type.tp_dict,"Type", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtGui_QStyleOptionHeader_StyleOptionType->tp_dict,"Type", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("QStyleOptionHeader::StyleOptionType");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::StyleOptionType");
    // end of enum StyleOptionType

    // init enum: SortIndicator
    PyTypeObject* SbkPySide_QtGui_QStyleOptionHeader_SortIndicator = Shiboken::Enum::newType("SortIndicator");
    SbkPySide_QtGuiTypes[SBK_QSTYLEOPTIONHEADER_SORTINDICATOR_IDX] = SbkPySide_QtGui_QStyleOptionHeader_SortIndicator;
    if (PyType_Ready(SbkPySide_QtGui_QStyleOptionHeader_SortIndicator) < 0)
        return;
    PyDict_SetItemString(Sbk_QStyleOptionHeader_Type.super.ht_type.tp_dict,
            "SortIndicator",((PyObject*)SbkPySide_QtGui_QStyleOptionHeader_SortIndicator));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtGui_QStyleOptionHeader_SortIndicator,(long) QStyleOptionHeader::None, "None");
    PyDict_SetItemString(Sbk_QStyleOptionHeader_Type.super.ht_type.tp_dict,"None", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtGui_QStyleOptionHeader_SortIndicator->tp_dict,"None", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtGui_QStyleOptionHeader_SortIndicator,(long) QStyleOptionHeader::SortUp, "SortUp");
    PyDict_SetItemString(Sbk_QStyleOptionHeader_Type.super.ht_type.tp_dict,"SortUp", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtGui_QStyleOptionHeader_SortIndicator->tp_dict,"SortUp", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtGui_QStyleOptionHeader_SortIndicator,(long) QStyleOptionHeader::SortDown, "SortDown");
    PyDict_SetItemString(Sbk_QStyleOptionHeader_Type.super.ht_type.tp_dict,"SortDown", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtGui_QStyleOptionHeader_SortIndicator->tp_dict,"SortDown", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("QStyleOptionHeader::SortIndicator");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::SortIndicator");
    // end of enum SortIndicator


    Shiboken::TypeResolver::createValueTypeResolver<QStyleOptionHeader >("QStyleOptionHeader");
    Shiboken::TypeResolver::createObjectTypeResolver<QStyleOptionHeader >("QStyleOptionHeader*");
    Shiboken::TypeResolver::createValueTypeResolver<QStyleOptionHeader >(typeid(QStyleOptionHeader).name());
    PySide::initQtMetaType<QStyleOptionHeader >();
}

