/*
 * This file is part of PySide: Python for Qt
 *
 * Copyright (C) 2009-2010 Nokia Corporation and/or its subsidiary(-ies).
 *
 * Contact: PySide team <contact@pyside.org>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * version 2.1 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA
 *
 */


//workaround to access protected functions
#define protected public

// default includes
#include <shiboken.h>
#include <pysidesignal.h>
#include <pysideproperty.h>
#include <pyside.h>
#include <typeresolver.h>
#include <typeinfo>
#include "pyside_qtgui_python.h"

#include "qstyleoptiontabwidgetframe_wrapper.h"

// Extra includes
#include <qstyleoption.h>
#include <qwidget.h>



// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QStyleOptionTabWidgetFrame_Init(PyObject* self, PyObject* args, PyObject* kwds)
{
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType<QStyleOptionTabWidgetFrame >()))
        return -1;

    QStyleOptionTabWidgetFrame* cptr = 0;
    int overloadId = -1;
    SbkObject* sbkSelf = reinterpret_cast<SbkObject*>(self);


    int numArgs = PyTuple_GET_SIZE(args);
    PyObject* pyargs[] = {0};

    // invalid argument lengths


    if (!PyArg_UnpackTuple(args, "QStyleOptionTabWidgetFrame", 0, 1, &(pyargs[0])))
        return -1;

    // Overloaded function decisor
    // 0: QStyleOptionTabWidgetFrame()
    // 1: QStyleOptionTabWidgetFrame(QStyleOptionTabWidgetFrame)
    // 2: QStyleOptionTabWidgetFrame(int)
    if (numArgs == 0) {
        overloadId = 0; // QStyleOptionTabWidgetFrame()
    } else if (numArgs == 1 && SbkNumber_Check(pyargs[0])) {
        overloadId = 2; // QStyleOptionTabWidgetFrame(int)
    } else if (numArgs == 1 && Shiboken::Converter< ::QStyleOptionTabWidgetFrame >::isConvertible(pyargs[0])) {
        overloadId = 1; // QStyleOptionTabWidgetFrame(QStyleOptionTabWidgetFrame)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_QStyleOptionTabWidgetFrame_Init_TypeError;

    // Call function/method
    {
        switch (overloadId) {
            case 0: // QStyleOptionTabWidgetFrame()
            {

                if(!PyErr_Occurred()) {
                    // QStyleOptionTabWidgetFrame()
                    PyThreadState* _save = PyEval_SaveThread(); // Py_BEGIN_ALLOW_THREADS
                    cptr = new QStyleOptionTabWidgetFrame();
                    PyEval_RestoreThread(_save); // Py_END_ALLOW_THREADS
                }
                break;
            }
            case 1: // QStyleOptionTabWidgetFrame(QStyleOptionTabWidgetFrame)
            {
                if (!Shiboken::Object::isValid(pyargs[0]))
                    return -1;
                QStyleOptionTabWidgetFrame cppArg0 = Shiboken::Converter<QStyleOptionTabWidgetFrame >::toCpp(pyargs[0]);

                if(!PyErr_Occurred()) {
                    // QStyleOptionTabWidgetFrame(QStyleOptionTabWidgetFrame)
                    PyThreadState* _save = PyEval_SaveThread(); // Py_BEGIN_ALLOW_THREADS
                    cptr = new QStyleOptionTabWidgetFrame(cppArg0);
                    PyEval_RestoreThread(_save); // Py_END_ALLOW_THREADS
                }
                break;
            }
            case 2: // QStyleOptionTabWidgetFrame(int)
            {
                int cppArg0 = Shiboken::Converter<int >::toCpp(pyargs[0]);

                if(!PyErr_Occurred()) {
                    // QStyleOptionTabWidgetFrame(int)
                    PyThreadState* _save = PyEval_SaveThread(); // Py_BEGIN_ALLOW_THREADS
                    cptr = new QStyleOptionTabWidgetFrame(cppArg0);
                    PyEval_RestoreThread(_save); // Py_END_ALLOW_THREADS
                }
                break;
            }
        }
    }

    if (PyErr_Occurred() || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType<QStyleOptionTabWidgetFrame >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (!cptr) goto Sbk_QStyleOptionTabWidgetFrame_Init_TypeError;

    Shiboken::Object::setValidCpp(sbkSelf, true);
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;

    Sbk_QStyleOptionTabWidgetFrame_Init_TypeError:
        const char* overloads[] = {"", "PySide.QtGui.QStyleOptionTabWidgetFrame", "int", 0};
        Shiboken::setErrorAboutWrongArguments(args, "PySide.QtGui.QStyleOptionTabWidgetFrame", overloads);
        return -1;
}

static PyObject *Sbk_QStyleOptionTabWidgetFrame___copy__(PyObject *self)
{
        QStyleOptionTabWidgetFrame* cppSelf = 0;
        if (!Shiboken::Object::isValid(self))
            return 0;
        cppSelf = Shiboken::Converter<QStyleOptionTabWidgetFrame*>::toCpp(self);
        PyObject* pyResult = 0;
        QStyleOptionTabWidgetFrame* copy = new QStyleOptionTabWidgetFrame(*cppSelf);
        pyResult = Shiboken::Converter<QStyleOptionTabWidgetFrame*>::toPython(copy);
        Shiboken::Object::getOwnership(pyResult);

        if (PyErr_Occurred() || !pyResult) {
            Py_XDECREF(pyResult);
            return 0;
        }
        return pyResult;
}

static PyMethodDef Sbk_QStyleOptionTabWidgetFrame_methods[] = {

    {"__copy__", (PyCFunction)Sbk_QStyleOptionTabWidgetFrame___copy__, METH_NOARGS},
    {0} // Sentinel
};

static PyObject* Sbk_QStyleOptionTabWidgetFrame_get_lineWidth(PyObject* self, void*)
{
    PyObject* val = Shiboken::Converter< int >::toPython( Shiboken::Converter< QStyleOptionTabWidgetFrame* >::toCpp(self)->lineWidth);
    return val;

}
static int Sbk_QStyleOptionTabWidgetFrame_set_lineWidth(PyObject* self, PyObject* value, void*)
{
    if (value == 0) {
        PyErr_SetString(PyExc_TypeError, "'lineWidth' may not be deleted");
        return -1;
    }
    if (!SbkNumber_Check(value)) {
        PyErr_SetString(PyExc_TypeError, "wrong type attributed to 'lineWidth', 'int' or convertible type expected");
        return -1;
    }

    Shiboken::Converter< QStyleOptionTabWidgetFrame* >::toCpp(self)->lineWidth = Shiboken::Converter< int >::toCpp(value);

    return 0;
}

static PyObject* Sbk_QStyleOptionTabWidgetFrame_get_rightCornerWidgetSize(PyObject* self, void*)
{
    PyObject* val =     Shiboken::createWrapper(&Shiboken::Converter< QStyleOptionTabWidgetFrame* >::toCpp(self)->rightCornerWidgetSize);
    Shiboken::Object::releaseOwnership(val);
    return val;

}
static int Sbk_QStyleOptionTabWidgetFrame_set_rightCornerWidgetSize(PyObject* self, PyObject* value, void*)
{
    if (value == 0) {
        PyErr_SetString(PyExc_TypeError, "'rightCornerWidgetSize' may not be deleted");
        return -1;
    }
    if (!Shiboken::Converter< ::QSize >::isConvertible(value)) {
        PyErr_SetString(PyExc_TypeError, "wrong type attributed to 'rightCornerWidgetSize', 'QSize' or convertible type expected");
        return -1;
    }

    Shiboken::Converter< QStyleOptionTabWidgetFrame* >::toCpp(self)->rightCornerWidgetSize = Shiboken::Converter< ::QSize >::toCpp(value);

    return 0;
}

static PyObject* Sbk_QStyleOptionTabWidgetFrame_get_tabBarSize(PyObject* self, void*)
{
    PyObject* val =     Shiboken::createWrapper(&Shiboken::Converter< QStyleOptionTabWidgetFrame* >::toCpp(self)->tabBarSize);
    Shiboken::Object::releaseOwnership(val);
    return val;

}
static int Sbk_QStyleOptionTabWidgetFrame_set_tabBarSize(PyObject* self, PyObject* value, void*)
{
    if (value == 0) {
        PyErr_SetString(PyExc_TypeError, "'tabBarSize' may not be deleted");
        return -1;
    }
    if (!Shiboken::Converter< ::QSize >::isConvertible(value)) {
        PyErr_SetString(PyExc_TypeError, "wrong type attributed to 'tabBarSize', 'QSize' or convertible type expected");
        return -1;
    }

    Shiboken::Converter< QStyleOptionTabWidgetFrame* >::toCpp(self)->tabBarSize = Shiboken::Converter< ::QSize >::toCpp(value);

    return 0;
}

static PyObject* Sbk_QStyleOptionTabWidgetFrame_get_shape(PyObject* self, void*)
{
    PyObject* val = Shiboken::Converter< ::QTabBar::Shape >::toPython( Shiboken::Converter< QStyleOptionTabWidgetFrame* >::toCpp(self)->shape);
    return val;

}
static int Sbk_QStyleOptionTabWidgetFrame_set_shape(PyObject* self, PyObject* value, void*)
{
    if (value == 0) {
        PyErr_SetString(PyExc_TypeError, "'shape' may not be deleted");
        return -1;
    }
    if (!Shiboken::Converter< ::QTabBar::Shape >::isConvertible(value)) {
        PyErr_SetString(PyExc_TypeError, "wrong type attributed to 'shape', 'Shape' or convertible type expected");
        return -1;
    }

    Shiboken::Converter< QStyleOptionTabWidgetFrame* >::toCpp(self)->shape = Shiboken::Converter< ::QTabBar::Shape >::toCpp(value);

    return 0;
}

static PyObject* Sbk_QStyleOptionTabWidgetFrame_get_midLineWidth(PyObject* self, void*)
{
    PyObject* val = Shiboken::Converter< int >::toPython( Shiboken::Converter< QStyleOptionTabWidgetFrame* >::toCpp(self)->midLineWidth);
    return val;

}
static int Sbk_QStyleOptionTabWidgetFrame_set_midLineWidth(PyObject* self, PyObject* value, void*)
{
    if (value == 0) {
        PyErr_SetString(PyExc_TypeError, "'midLineWidth' may not be deleted");
        return -1;
    }
    if (!SbkNumber_Check(value)) {
        PyErr_SetString(PyExc_TypeError, "wrong type attributed to 'midLineWidth', 'int' or convertible type expected");
        return -1;
    }

    Shiboken::Converter< QStyleOptionTabWidgetFrame* >::toCpp(self)->midLineWidth = Shiboken::Converter< int >::toCpp(value);

    return 0;
}

static PyObject* Sbk_QStyleOptionTabWidgetFrame_get_leftCornerWidgetSize(PyObject* self, void*)
{
    PyObject* val =     Shiboken::createWrapper(&Shiboken::Converter< QStyleOptionTabWidgetFrame* >::toCpp(self)->leftCornerWidgetSize);
    Shiboken::Object::releaseOwnership(val);
    return val;

}
static int Sbk_QStyleOptionTabWidgetFrame_set_leftCornerWidgetSize(PyObject* self, PyObject* value, void*)
{
    if (value == 0) {
        PyErr_SetString(PyExc_TypeError, "'leftCornerWidgetSize' may not be deleted");
        return -1;
    }
    if (!Shiboken::Converter< ::QSize >::isConvertible(value)) {
        PyErr_SetString(PyExc_TypeError, "wrong type attributed to 'leftCornerWidgetSize', 'QSize' or convertible type expected");
        return -1;
    }

    Shiboken::Converter< QStyleOptionTabWidgetFrame* >::toCpp(self)->leftCornerWidgetSize = Shiboken::Converter< ::QSize >::toCpp(value);

    return 0;
}

// Getters and Setters for QStyleOptionTabWidgetFrame
static PyGetSetDef Sbk_QStyleOptionTabWidgetFrame_getsetlist[] = {
    {const_cast<char*>("lineWidth"), Sbk_QStyleOptionTabWidgetFrame_get_lineWidth, Sbk_QStyleOptionTabWidgetFrame_set_lineWidth},
    {const_cast<char*>("rightCornerWidgetSize"), Sbk_QStyleOptionTabWidgetFrame_get_rightCornerWidgetSize, Sbk_QStyleOptionTabWidgetFrame_set_rightCornerWidgetSize},
    {const_cast<char*>("tabBarSize"), Sbk_QStyleOptionTabWidgetFrame_get_tabBarSize, Sbk_QStyleOptionTabWidgetFrame_set_tabBarSize},
    {const_cast<char*>("shape"), Sbk_QStyleOptionTabWidgetFrame_get_shape, Sbk_QStyleOptionTabWidgetFrame_set_shape},
    {const_cast<char*>("midLineWidth"), Sbk_QStyleOptionTabWidgetFrame_get_midLineWidth, Sbk_QStyleOptionTabWidgetFrame_set_midLineWidth},
    {const_cast<char*>("leftCornerWidgetSize"), Sbk_QStyleOptionTabWidgetFrame_get_leftCornerWidgetSize, Sbk_QStyleOptionTabWidgetFrame_set_leftCornerWidgetSize},
    {0}  // Sentinel
};

} // extern "C"

// Class Definition -----------------------------------------------
extern "C" {
static SbkObjectType Sbk_QStyleOptionTabWidgetFrame_Type = { { {
    PyObject_HEAD_INIT(&SbkObjectType_Type)
    /*ob_size*/             0,
    /*tp_name*/             "PySide.QtGui.QStyleOptionTabWidgetFrame",
    /*tp_basicsize*/        sizeof(SbkObject),
    /*tp_itemsize*/         0,
    /*tp_dealloc*/          &SbkDeallocWrapper,
    /*tp_print*/            0,
    /*tp_getattr*/          0,
    /*tp_setattr*/          0,
    /*tp_compare*/          0,
    /*tp_repr*/             0,
    /*tp_as_number*/        0,
    /*tp_as_sequence*/      0,
    /*tp_as_mapping*/       0,
    /*tp_hash*/             0,
    /*tp_call*/             0,
    /*tp_str*/              0,
    /*tp_getattro*/         0,
    /*tp_setattro*/         0,
    /*tp_as_buffer*/        0,
    /*tp_flags*/            Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_CHECKTYPES,
    /*tp_doc*/              0,
    /*tp_traverse*/         0,
    /*tp_clear*/            0,
    /*tp_richcompare*/      0,
    /*tp_weaklistoffset*/   0,
    /*tp_iter*/             0,
    /*tp_iternext*/         0,
    /*tp_methods*/          Sbk_QStyleOptionTabWidgetFrame_methods,
    /*tp_members*/          0,
    /*tp_getset*/           Sbk_QStyleOptionTabWidgetFrame_getsetlist,
    /*tp_base*/             0,
    /*tp_dict*/             0,
    /*tp_descr_get*/        0,
    /*tp_descr_set*/        0,
    /*tp_dictoffset*/       0,
    /*tp_init*/             Sbk_QStyleOptionTabWidgetFrame_Init,
    /*tp_alloc*/            0,
    /*tp_new*/              SbkObjectTpNew,
    /*tp_free*/             0,
    /*tp_is_gc*/            0,
    /*tp_bases*/            0,
    /*tp_mro*/              0,
    /*tp_cache*/            0,
    /*tp_subclasses*/       0,
    /*tp_weaklist*/         0
}, },
    /*priv_data*/           0
};
} //extern


void init_QStyleOptionTabWidgetFrame(PyObject* module)
{
    SbkPySide_QtGuiTypes[SBK_QSTYLEOPTIONTABWIDGETFRAME_IDX] = reinterpret_cast<PyTypeObject*>(&Sbk_QStyleOptionTabWidgetFrame_Type);

    Shiboken::ObjectType::initPrivateData(&Sbk_QStyleOptionTabWidgetFrame_Type);
    Sbk_QStyleOptionTabWidgetFrame_Type.super.ht_type.tp_base = SbkPySide_QtGuiTypes[SBK_QSTYLEOPTION_IDX];
    Shiboken::ObjectType::setDestructorFunction(&Sbk_QStyleOptionTabWidgetFrame_Type, &Shiboken::callCppDestructor<QStyleOptionTabWidgetFrame >);
    if (PyType_Ready((PyTypeObject*)&Sbk_QStyleOptionTabWidgetFrame_Type) < 0)
        return;

    Shiboken::ObjectType::setOriginalName(&Sbk_QStyleOptionTabWidgetFrame_Type, "QStyleOptionTabWidgetFrame");
    PyModule_AddObject(module, "QStyleOptionTabWidgetFrame",
        ((PyObject*)&Sbk_QStyleOptionTabWidgetFrame_Type));

    // Initialize enums
    PyObject* enumItem;

    // init enum: StyleOptionVersion
    PyTypeObject* SbkPySide_QtGui_QStyleOptionTabWidgetFrame_StyleOptionVersion = Shiboken::Enum::newType("StyleOptionVersion");
    SbkPySide_QtGuiTypes[SBK_QSTYLEOPTIONTABWIDGETFRAME_STYLEOPTIONVERSION_IDX] = SbkPySide_QtGui_QStyleOptionTabWidgetFrame_StyleOptionVersion;
    if (PyType_Ready(SbkPySide_QtGui_QStyleOptionTabWidgetFrame_StyleOptionVersion) < 0)
        return;
    PyDict_SetItemString(Sbk_QStyleOptionTabWidgetFrame_Type.super.ht_type.tp_dict,
            "StyleOptionVersion",((PyObject*)SbkPySide_QtGui_QStyleOptionTabWidgetFrame_StyleOptionVersion));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtGui_QStyleOptionTabWidgetFrame_StyleOptionVersion,(long) QStyleOptionTabWidgetFrame::Version, "Version");
    PyDict_SetItemString(Sbk_QStyleOptionTabWidgetFrame_Type.super.ht_type.tp_dict,"Version", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtGui_QStyleOptionTabWidgetFrame_StyleOptionVersion->tp_dict,"Version", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("QStyleOptionTabWidgetFrame::StyleOptionVersion");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::StyleOptionVersion");
    // end of enum StyleOptionVersion

    // init enum: StyleOptionType
    PyTypeObject* SbkPySide_QtGui_QStyleOptionTabWidgetFrame_StyleOptionType = Shiboken::Enum::newType("StyleOptionType");
    SbkPySide_QtGuiTypes[SBK_QSTYLEOPTIONTABWIDGETFRAME_STYLEOPTIONTYPE_IDX] = SbkPySide_QtGui_QStyleOptionTabWidgetFrame_StyleOptionType;
    if (PyType_Ready(SbkPySide_QtGui_QStyleOptionTabWidgetFrame_StyleOptionType) < 0)
        return;
    PyDict_SetItemString(Sbk_QStyleOptionTabWidgetFrame_Type.super.ht_type.tp_dict,
            "StyleOptionType",((PyObject*)SbkPySide_QtGui_QStyleOptionTabWidgetFrame_StyleOptionType));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtGui_QStyleOptionTabWidgetFrame_StyleOptionType,(long) QStyleOptionTabWidgetFrame::Type, "Type");
    PyDict_SetItemString(Sbk_QStyleOptionTabWidgetFrame_Type.super.ht_type.tp_dict,"Type", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtGui_QStyleOptionTabWidgetFrame_StyleOptionType->tp_dict,"Type", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("QStyleOptionTabWidgetFrame::StyleOptionType");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::StyleOptionType");
    // end of enum StyleOptionType


    Shiboken::TypeResolver::createValueTypeResolver<QStyleOptionTabWidgetFrame >("QStyleOptionTabWidgetFrame");
    Shiboken::TypeResolver::createObjectTypeResolver<QStyleOptionTabWidgetFrame >("QStyleOptionTabWidgetFrame*");
    Shiboken::TypeResolver::createValueTypeResolver<QStyleOptionTabWidgetFrame >(typeid(QStyleOptionTabWidgetFrame).name());
    PySide::initQtMetaType<QStyleOptionTabWidgetFrame >();
}

