/*
 * This file is part of PySide: Python for Qt
 *
 * Copyright (C) 2009-2010 Nokia Corporation and/or its subsidiary(-ies).
 *
 * Contact: PySide team <contact@pyside.org>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * version 2.1 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA
 *
 */


// default includes
#include <shiboken.h>
#include <pysidesignal.h>
#include <pysideproperty.h>
#include <pyside.h>
#include <typeresolver.h>
#include <typeinfo>
#include "pyside_qtcore_python.h"

#include "qt_wrapper.h"

// Extra includes
#include <QTextDocument>



// Target ---------------------------------------------------------

extern "C" {
static PyMethodDef Sbk_Qt_methods[] = {

    {0} // Sentinel
};

} // extern "C"

// Class Definition -----------------------------------------------
extern "C" {
static SbkObjectType Sbk_Qt_Type = { { {
    PyObject_HEAD_INIT(&SbkObjectType_Type)
    /*ob_size*/             0,
    /*tp_name*/             "PySide.QtCore.Qt",
    /*tp_basicsize*/        sizeof(SbkObject),
    /*tp_itemsize*/         0,
    /*tp_dealloc*/          0,
    /*tp_print*/            0,
    /*tp_getattr*/          0,
    /*tp_setattr*/          0,
    /*tp_compare*/          0,
    /*tp_repr*/             0,
    /*tp_as_number*/        0,
    /*tp_as_sequence*/      0,
    /*tp_as_mapping*/       0,
    /*tp_hash*/             0,
    /*tp_call*/             0,
    /*tp_str*/              0,
    /*tp_getattro*/         0,
    /*tp_setattro*/         0,
    /*tp_as_buffer*/        0,
    /*tp_flags*/            Py_TPFLAGS_DEFAULT|Py_TPFLAGS_CHECKTYPES,
    /*tp_doc*/              0,
    /*tp_traverse*/         0,
    /*tp_clear*/            0,
    /*tp_richcompare*/      0,
    /*tp_weaklistoffset*/   0,
    /*tp_iter*/             0,
    /*tp_iternext*/         0,
    /*tp_methods*/          Sbk_Qt_methods,
    /*tp_members*/          0,
    /*tp_getset*/           0,
    /*tp_base*/             reinterpret_cast<PyTypeObject*>(&SbkObject_Type),
    /*tp_dict*/             0,
    /*tp_descr_get*/        0,
    /*tp_descr_set*/        0,
    /*tp_dictoffset*/       0,
    /*tp_init*/             0,
    /*tp_alloc*/            0,
    /*tp_new*/              0,
    /*tp_free*/             0,
    /*tp_is_gc*/            0,
    /*tp_bases*/            0,
    /*tp_mro*/              0,
    /*tp_cache*/            0,
    /*tp_subclasses*/       0,
    /*tp_weaklist*/         0
}, },
    /*priv_data*/           0
};
} //extern

PyObject* SbkPySide_QtCore_Qt_DropAction___and__(PyObject* self, PyObject* arg)
{
    return Shiboken::Converter< Qt::DropActions >::toPython(
        Shiboken::Converter<Qt::DropActions>::toCpp(self)
        & Shiboken::Converter< Qt::DropActions >::toCpp(arg)
    );
}

PyObject* SbkPySide_QtCore_Qt_DropAction___or__(PyObject* self, PyObject* arg)
{
    return Shiboken::Converter< Qt::DropActions >::toPython(
        Shiboken::Converter<Qt::DropActions>::toCpp(self)
        | Shiboken::Converter< Qt::DropActions >::toCpp(arg)
    );
}

PyObject* SbkPySide_QtCore_Qt_DropAction___xor__(PyObject* self, PyObject* arg)
{
    return Shiboken::Converter< Qt::DropActions >::toPython(
        Shiboken::Converter<Qt::DropActions>::toCpp(self)
        ^ Shiboken::Converter< Qt::DropActions >::toCpp(arg)
    );
}

PyObject* SbkPySide_QtCore_Qt_DropAction___invert__(PyObject* self, PyObject* arg)
{
    return Shiboken::Converter< Qt::DropActions >::toPython(
        ~Shiboken::Converter<Qt::DropActions >::toCpp(self)
    );
}


static PyNumberMethods SbkPySide_QtCore_Qt_DropAction_as_number = {
    /*nb_add*/                  0,
    /*nb_subtract*/             0,
    /*nb_multiply*/             0,
    /*nb_divide*/               0,
    /*nb_remainder*/            0,
    /*nb_divmod*/               0,
    /*nb_power*/                0,
    /*nb_negative*/             0,
    /*nb_positive*/             0,
    /*nb_absolute*/             0,
    /*nb_nonzero*/              0,
    /*nb_invert*/               (unaryfunc)SbkPySide_QtCore_Qt_DropAction___invert__,
    /*nb_lshift*/               0,
    /*nb_rshift*/               0,
    /*nb_and*/                  (binaryfunc)SbkPySide_QtCore_Qt_DropAction___and__,
    /*nb_xor*/                  (binaryfunc)SbkPySide_QtCore_Qt_DropAction___xor__,
    /*nb_or*/                   (binaryfunc)SbkPySide_QtCore_Qt_DropAction___or__,
    /*nb_coerce*/               0,
    /*nb_int*/                  0,
    /*nb_long*/                 0,
    /*nb_float*/                0,
    /*nb_oct*/                  0,
    /*nb_hex*/                  0,
    /*nb_inplace_add*/          0,
    /*nb_inplace_subtract*/     0,
    /*nb_inplace_multiply*/     0,
    /*nb_inplace_divide*/       0,
    /*nb_inplace_remainder*/    0,
    /*nb_inplace_power*/        0,
    /*nb_inplace_lshift*/       0,
    /*nb_inplace_rshift*/       0,
    /*nb_inplace_and*/          0,
    /*nb_inplace_xor*/          0,
    /*nb_inplace_or*/           0,
    /*nb_floor_divide*/         0,
    /*nb_true_divide*/          0,
    /*nb_inplace_floor_divide*/ 0,
    /*nb_inplace_true_divide*/  0,
    /*nb_index*/                0
};


// forward declaration of new function
static PyTypeObject SbkPySide_QtCore_Qt_DropActions_Type = {
    PyObject_HEAD_INIT(&PyType_Type)
    /*ob_size*/             0,
    /*tp_name*/             "DropActions",
    /*tp_basicsize*/        0,
    /*tp_itemsize*/         0,
    /*tp_dealloc*/          0,
    /*tp_print*/            0,
    /*tp_getattr*/          0,
    /*tp_setattr*/          0,
    /*tp_compare*/          0,
    /*tp_repr*/             0,
    /*tp_as_number*/        &SbkPySide_QtCore_Qt_DropAction_as_number,
    /*tp_as_sequence*/      0,
    /*tp_as_mapping*/       0,
    /*tp_hash*/             0,
    /*tp_call*/             0,
    /*tp_str*/              0,
    /*tp_getattro*/         0,
    /*tp_setattro*/         0,
    /*tp_as_buffer*/        0,
    /*tp_flags*/            Py_TPFLAGS_DEFAULT | Py_TPFLAGS_CHECKTYPES,
    /*tp_doc*/              0,
    /*tp_traverse*/         0,
    /*tp_clear*/            0,
    /*tp_richcompare*/      0,
    /*tp_weaklistoffset*/   0,
    /*tp_iter*/             0,
    /*tp_iternext*/         0,
    /*tp_methods*/          0,
    /*tp_members*/          0,
    /*tp_getset*/           0,
    /*tp_base*/             &PyInt_Type,
    /*tp_dict*/             0,
    /*tp_descr_get*/        0,
    /*tp_descr_set*/        0,
    /*tp_dictoffset*/       0,
    /*tp_init*/             0,
    /*tp_alloc*/            0,
    /*tp_new*/              PyInt_Type.tp_new,
    /*tp_free*/             0,
    /*tp_is_gc*/            0,
    /*tp_bases*/            0,
    /*tp_mro*/              0,
    /*tp_cache*/            0,
    /*tp_subclasses*/       0,
    /*tp_weaklist*/         0
};


PyObject* SbkPySide_QtCore_Qt_WindowType___and__(PyObject* self, PyObject* arg)
{
    return Shiboken::Converter< Qt::WindowFlags >::toPython(
        Shiboken::Converter<Qt::WindowFlags>::toCpp(self)
        & Shiboken::Converter< Qt::WindowFlags >::toCpp(arg)
    );
}

PyObject* SbkPySide_QtCore_Qt_WindowType___or__(PyObject* self, PyObject* arg)
{
    return Shiboken::Converter< Qt::WindowFlags >::toPython(
        Shiboken::Converter<Qt::WindowFlags>::toCpp(self)
        | Shiboken::Converter< Qt::WindowFlags >::toCpp(arg)
    );
}

PyObject* SbkPySide_QtCore_Qt_WindowType___xor__(PyObject* self, PyObject* arg)
{
    return Shiboken::Converter< Qt::WindowFlags >::toPython(
        Shiboken::Converter<Qt::WindowFlags>::toCpp(self)
        ^ Shiboken::Converter< Qt::WindowFlags >::toCpp(arg)
    );
}

PyObject* SbkPySide_QtCore_Qt_WindowType___invert__(PyObject* self, PyObject* arg)
{
    return Shiboken::Converter< Qt::WindowFlags >::toPython(
        ~Shiboken::Converter<Qt::WindowFlags >::toCpp(self)
    );
}


static PyNumberMethods SbkPySide_QtCore_Qt_WindowType_as_number = {
    /*nb_add*/                  0,
    /*nb_subtract*/             0,
    /*nb_multiply*/             0,
    /*nb_divide*/               0,
    /*nb_remainder*/            0,
    /*nb_divmod*/               0,
    /*nb_power*/                0,
    /*nb_negative*/             0,
    /*nb_positive*/             0,
    /*nb_absolute*/             0,
    /*nb_nonzero*/              0,
    /*nb_invert*/               (unaryfunc)SbkPySide_QtCore_Qt_WindowType___invert__,
    /*nb_lshift*/               0,
    /*nb_rshift*/               0,
    /*nb_and*/                  (binaryfunc)SbkPySide_QtCore_Qt_WindowType___and__,
    /*nb_xor*/                  (binaryfunc)SbkPySide_QtCore_Qt_WindowType___xor__,
    /*nb_or*/                   (binaryfunc)SbkPySide_QtCore_Qt_WindowType___or__,
    /*nb_coerce*/               0,
    /*nb_int*/                  0,
    /*nb_long*/                 0,
    /*nb_float*/                0,
    /*nb_oct*/                  0,
    /*nb_hex*/                  0,
    /*nb_inplace_add*/          0,
    /*nb_inplace_subtract*/     0,
    /*nb_inplace_multiply*/     0,
    /*nb_inplace_divide*/       0,
    /*nb_inplace_remainder*/    0,
    /*nb_inplace_power*/        0,
    /*nb_inplace_lshift*/       0,
    /*nb_inplace_rshift*/       0,
    /*nb_inplace_and*/          0,
    /*nb_inplace_xor*/          0,
    /*nb_inplace_or*/           0,
    /*nb_floor_divide*/         0,
    /*nb_true_divide*/          0,
    /*nb_inplace_floor_divide*/ 0,
    /*nb_inplace_true_divide*/  0,
    /*nb_index*/                0
};


// forward declaration of new function
static PyTypeObject SbkPySide_QtCore_Qt_WindowFlags_Type = {
    PyObject_HEAD_INIT(&PyType_Type)
    /*ob_size*/             0,
    /*tp_name*/             "WindowFlags",
    /*tp_basicsize*/        0,
    /*tp_itemsize*/         0,
    /*tp_dealloc*/          0,
    /*tp_print*/            0,
    /*tp_getattr*/          0,
    /*tp_setattr*/          0,
    /*tp_compare*/          0,
    /*tp_repr*/             0,
    /*tp_as_number*/        &SbkPySide_QtCore_Qt_WindowType_as_number,
    /*tp_as_sequence*/      0,
    /*tp_as_mapping*/       0,
    /*tp_hash*/             0,
    /*tp_call*/             0,
    /*tp_str*/              0,
    /*tp_getattro*/         0,
    /*tp_setattro*/         0,
    /*tp_as_buffer*/        0,
    /*tp_flags*/            Py_TPFLAGS_DEFAULT | Py_TPFLAGS_CHECKTYPES,
    /*tp_doc*/              0,
    /*tp_traverse*/         0,
    /*tp_clear*/            0,
    /*tp_richcompare*/      0,
    /*tp_weaklistoffset*/   0,
    /*tp_iter*/             0,
    /*tp_iternext*/         0,
    /*tp_methods*/          0,
    /*tp_members*/          0,
    /*tp_getset*/           0,
    /*tp_base*/             &PyInt_Type,
    /*tp_dict*/             0,
    /*tp_descr_get*/        0,
    /*tp_descr_set*/        0,
    /*tp_dictoffset*/       0,
    /*tp_init*/             0,
    /*tp_alloc*/            0,
    /*tp_new*/              PyInt_Type.tp_new,
    /*tp_free*/             0,
    /*tp_is_gc*/            0,
    /*tp_bases*/            0,
    /*tp_mro*/              0,
    /*tp_cache*/            0,
    /*tp_subclasses*/       0,
    /*tp_weaklist*/         0
};


PyObject* SbkPySide_QtCore_Qt_GestureFlag___and__(PyObject* self, PyObject* arg)
{
    return Shiboken::Converter< Qt::GestureFlags >::toPython(
        Shiboken::Converter<Qt::GestureFlags>::toCpp(self)
        & Shiboken::Converter< Qt::GestureFlags >::toCpp(arg)
    );
}

PyObject* SbkPySide_QtCore_Qt_GestureFlag___or__(PyObject* self, PyObject* arg)
{
    return Shiboken::Converter< Qt::GestureFlags >::toPython(
        Shiboken::Converter<Qt::GestureFlags>::toCpp(self)
        | Shiboken::Converter< Qt::GestureFlags >::toCpp(arg)
    );
}

PyObject* SbkPySide_QtCore_Qt_GestureFlag___xor__(PyObject* self, PyObject* arg)
{
    return Shiboken::Converter< Qt::GestureFlags >::toPython(
        Shiboken::Converter<Qt::GestureFlags>::toCpp(self)
        ^ Shiboken::Converter< Qt::GestureFlags >::toCpp(arg)
    );
}

PyObject* SbkPySide_QtCore_Qt_GestureFlag___invert__(PyObject* self, PyObject* arg)
{
    return Shiboken::Converter< Qt::GestureFlags >::toPython(
        ~Shiboken::Converter<Qt::GestureFlags >::toCpp(self)
    );
}


static PyNumberMethods SbkPySide_QtCore_Qt_GestureFlag_as_number = {
    /*nb_add*/                  0,
    /*nb_subtract*/             0,
    /*nb_multiply*/             0,
    /*nb_divide*/               0,
    /*nb_remainder*/            0,
    /*nb_divmod*/               0,
    /*nb_power*/                0,
    /*nb_negative*/             0,
    /*nb_positive*/             0,
    /*nb_absolute*/             0,
    /*nb_nonzero*/              0,
    /*nb_invert*/               (unaryfunc)SbkPySide_QtCore_Qt_GestureFlag___invert__,
    /*nb_lshift*/               0,
    /*nb_rshift*/               0,
    /*nb_and*/                  (binaryfunc)SbkPySide_QtCore_Qt_GestureFlag___and__,
    /*nb_xor*/                  (binaryfunc)SbkPySide_QtCore_Qt_GestureFlag___xor__,
    /*nb_or*/                   (binaryfunc)SbkPySide_QtCore_Qt_GestureFlag___or__,
    /*nb_coerce*/               0,
    /*nb_int*/                  0,
    /*nb_long*/                 0,
    /*nb_float*/                0,
    /*nb_oct*/                  0,
    /*nb_hex*/                  0,
    /*nb_inplace_add*/          0,
    /*nb_inplace_subtract*/     0,
    /*nb_inplace_multiply*/     0,
    /*nb_inplace_divide*/       0,
    /*nb_inplace_remainder*/    0,
    /*nb_inplace_power*/        0,
    /*nb_inplace_lshift*/       0,
    /*nb_inplace_rshift*/       0,
    /*nb_inplace_and*/          0,
    /*nb_inplace_xor*/          0,
    /*nb_inplace_or*/           0,
    /*nb_floor_divide*/         0,
    /*nb_true_divide*/          0,
    /*nb_inplace_floor_divide*/ 0,
    /*nb_inplace_true_divide*/  0,
    /*nb_index*/                0
};


// forward declaration of new function
static PyTypeObject SbkPySide_QtCore_Qt_GestureFlags_Type = {
    PyObject_HEAD_INIT(&PyType_Type)
    /*ob_size*/             0,
    /*tp_name*/             "GestureFlags",
    /*tp_basicsize*/        0,
    /*tp_itemsize*/         0,
    /*tp_dealloc*/          0,
    /*tp_print*/            0,
    /*tp_getattr*/          0,
    /*tp_setattr*/          0,
    /*tp_compare*/          0,
    /*tp_repr*/             0,
    /*tp_as_number*/        &SbkPySide_QtCore_Qt_GestureFlag_as_number,
    /*tp_as_sequence*/      0,
    /*tp_as_mapping*/       0,
    /*tp_hash*/             0,
    /*tp_call*/             0,
    /*tp_str*/              0,
    /*tp_getattro*/         0,
    /*tp_setattro*/         0,
    /*tp_as_buffer*/        0,
    /*tp_flags*/            Py_TPFLAGS_DEFAULT | Py_TPFLAGS_CHECKTYPES,
    /*tp_doc*/              0,
    /*tp_traverse*/         0,
    /*tp_clear*/            0,
    /*tp_richcompare*/      0,
    /*tp_weaklistoffset*/   0,
    /*tp_iter*/             0,
    /*tp_iternext*/         0,
    /*tp_methods*/          0,
    /*tp_members*/          0,
    /*tp_getset*/           0,
    /*tp_base*/             &PyInt_Type,
    /*tp_dict*/             0,
    /*tp_descr_get*/        0,
    /*tp_descr_set*/        0,
    /*tp_dictoffset*/       0,
    /*tp_init*/             0,
    /*tp_alloc*/            0,
    /*tp_new*/              PyInt_Type.tp_new,
    /*tp_free*/             0,
    /*tp_is_gc*/            0,
    /*tp_bases*/            0,
    /*tp_mro*/              0,
    /*tp_cache*/            0,
    /*tp_subclasses*/       0,
    /*tp_weaklist*/         0
};


PyObject* SbkPySide_QtCore_Qt_ImageConversionFlag___and__(PyObject* self, PyObject* arg)
{
    return Shiboken::Converter< Qt::ImageConversionFlags >::toPython(
        Shiboken::Converter<Qt::ImageConversionFlags>::toCpp(self)
        & Shiboken::Converter< Qt::ImageConversionFlags >::toCpp(arg)
    );
}

PyObject* SbkPySide_QtCore_Qt_ImageConversionFlag___or__(PyObject* self, PyObject* arg)
{
    return Shiboken::Converter< Qt::ImageConversionFlags >::toPython(
        Shiboken::Converter<Qt::ImageConversionFlags>::toCpp(self)
        | Shiboken::Converter< Qt::ImageConversionFlags >::toCpp(arg)
    );
}

PyObject* SbkPySide_QtCore_Qt_ImageConversionFlag___xor__(PyObject* self, PyObject* arg)
{
    return Shiboken::Converter< Qt::ImageConversionFlags >::toPython(
        Shiboken::Converter<Qt::ImageConversionFlags>::toCpp(self)
        ^ Shiboken::Converter< Qt::ImageConversionFlags >::toCpp(arg)
    );
}

PyObject* SbkPySide_QtCore_Qt_ImageConversionFlag___invert__(PyObject* self, PyObject* arg)
{
    return Shiboken::Converter< Qt::ImageConversionFlags >::toPython(
        ~Shiboken::Converter<Qt::ImageConversionFlags >::toCpp(self)
    );
}


static PyNumberMethods SbkPySide_QtCore_Qt_ImageConversionFlag_as_number = {
    /*nb_add*/                  0,
    /*nb_subtract*/             0,
    /*nb_multiply*/             0,
    /*nb_divide*/               0,
    /*nb_remainder*/            0,
    /*nb_divmod*/               0,
    /*nb_power*/                0,
    /*nb_negative*/             0,
    /*nb_positive*/             0,
    /*nb_absolute*/             0,
    /*nb_nonzero*/              0,
    /*nb_invert*/               (unaryfunc)SbkPySide_QtCore_Qt_ImageConversionFlag___invert__,
    /*nb_lshift*/               0,
    /*nb_rshift*/               0,
    /*nb_and*/                  (binaryfunc)SbkPySide_QtCore_Qt_ImageConversionFlag___and__,
    /*nb_xor*/                  (binaryfunc)SbkPySide_QtCore_Qt_ImageConversionFlag___xor__,
    /*nb_or*/                   (binaryfunc)SbkPySide_QtCore_Qt_ImageConversionFlag___or__,
    /*nb_coerce*/               0,
    /*nb_int*/                  0,
    /*nb_long*/                 0,
    /*nb_float*/                0,
    /*nb_oct*/                  0,
    /*nb_hex*/                  0,
    /*nb_inplace_add*/          0,
    /*nb_inplace_subtract*/     0,
    /*nb_inplace_multiply*/     0,
    /*nb_inplace_divide*/       0,
    /*nb_inplace_remainder*/    0,
    /*nb_inplace_power*/        0,
    /*nb_inplace_lshift*/       0,
    /*nb_inplace_rshift*/       0,
    /*nb_inplace_and*/          0,
    /*nb_inplace_xor*/          0,
    /*nb_inplace_or*/           0,
    /*nb_floor_divide*/         0,
    /*nb_true_divide*/          0,
    /*nb_inplace_floor_divide*/ 0,
    /*nb_inplace_true_divide*/  0,
    /*nb_index*/                0
};


// forward declaration of new function
static PyTypeObject SbkPySide_QtCore_Qt_ImageConversionFlags_Type = {
    PyObject_HEAD_INIT(&PyType_Type)
    /*ob_size*/             0,
    /*tp_name*/             "ImageConversionFlags",
    /*tp_basicsize*/        0,
    /*tp_itemsize*/         0,
    /*tp_dealloc*/          0,
    /*tp_print*/            0,
    /*tp_getattr*/          0,
    /*tp_setattr*/          0,
    /*tp_compare*/          0,
    /*tp_repr*/             0,
    /*tp_as_number*/        &SbkPySide_QtCore_Qt_ImageConversionFlag_as_number,
    /*tp_as_sequence*/      0,
    /*tp_as_mapping*/       0,
    /*tp_hash*/             0,
    /*tp_call*/             0,
    /*tp_str*/              0,
    /*tp_getattro*/         0,
    /*tp_setattro*/         0,
    /*tp_as_buffer*/        0,
    /*tp_flags*/            Py_TPFLAGS_DEFAULT | Py_TPFLAGS_CHECKTYPES,
    /*tp_doc*/              0,
    /*tp_traverse*/         0,
    /*tp_clear*/            0,
    /*tp_richcompare*/      0,
    /*tp_weaklistoffset*/   0,
    /*tp_iter*/             0,
    /*tp_iternext*/         0,
    /*tp_methods*/          0,
    /*tp_members*/          0,
    /*tp_getset*/           0,
    /*tp_base*/             &PyInt_Type,
    /*tp_dict*/             0,
    /*tp_descr_get*/        0,
    /*tp_descr_set*/        0,
    /*tp_dictoffset*/       0,
    /*tp_init*/             0,
    /*tp_alloc*/            0,
    /*tp_new*/              PyInt_Type.tp_new,
    /*tp_free*/             0,
    /*tp_is_gc*/            0,
    /*tp_bases*/            0,
    /*tp_mro*/              0,
    /*tp_cache*/            0,
    /*tp_subclasses*/       0,
    /*tp_weaklist*/         0
};


PyObject* SbkPySide_QtCore_Qt_ToolBarArea___and__(PyObject* self, PyObject* arg)
{
    return Shiboken::Converter< Qt::ToolBarAreas >::toPython(
        Shiboken::Converter<Qt::ToolBarAreas>::toCpp(self)
        & Shiboken::Converter< Qt::ToolBarAreas >::toCpp(arg)
    );
}

PyObject* SbkPySide_QtCore_Qt_ToolBarArea___or__(PyObject* self, PyObject* arg)
{
    return Shiboken::Converter< Qt::ToolBarAreas >::toPython(
        Shiboken::Converter<Qt::ToolBarAreas>::toCpp(self)
        | Shiboken::Converter< Qt::ToolBarAreas >::toCpp(arg)
    );
}

PyObject* SbkPySide_QtCore_Qt_ToolBarArea___xor__(PyObject* self, PyObject* arg)
{
    return Shiboken::Converter< Qt::ToolBarAreas >::toPython(
        Shiboken::Converter<Qt::ToolBarAreas>::toCpp(self)
        ^ Shiboken::Converter< Qt::ToolBarAreas >::toCpp(arg)
    );
}

PyObject* SbkPySide_QtCore_Qt_ToolBarArea___invert__(PyObject* self, PyObject* arg)
{
    return Shiboken::Converter< Qt::ToolBarAreas >::toPython(
        ~Shiboken::Converter<Qt::ToolBarAreas >::toCpp(self)
    );
}


static PyNumberMethods SbkPySide_QtCore_Qt_ToolBarArea_as_number = {
    /*nb_add*/                  0,
    /*nb_subtract*/             0,
    /*nb_multiply*/             0,
    /*nb_divide*/               0,
    /*nb_remainder*/            0,
    /*nb_divmod*/               0,
    /*nb_power*/                0,
    /*nb_negative*/             0,
    /*nb_positive*/             0,
    /*nb_absolute*/             0,
    /*nb_nonzero*/              0,
    /*nb_invert*/               (unaryfunc)SbkPySide_QtCore_Qt_ToolBarArea___invert__,
    /*nb_lshift*/               0,
    /*nb_rshift*/               0,
    /*nb_and*/                  (binaryfunc)SbkPySide_QtCore_Qt_ToolBarArea___and__,
    /*nb_xor*/                  (binaryfunc)SbkPySide_QtCore_Qt_ToolBarArea___xor__,
    /*nb_or*/                   (binaryfunc)SbkPySide_QtCore_Qt_ToolBarArea___or__,
    /*nb_coerce*/               0,
    /*nb_int*/                  0,
    /*nb_long*/                 0,
    /*nb_float*/                0,
    /*nb_oct*/                  0,
    /*nb_hex*/                  0,
    /*nb_inplace_add*/          0,
    /*nb_inplace_subtract*/     0,
    /*nb_inplace_multiply*/     0,
    /*nb_inplace_divide*/       0,
    /*nb_inplace_remainder*/    0,
    /*nb_inplace_power*/        0,
    /*nb_inplace_lshift*/       0,
    /*nb_inplace_rshift*/       0,
    /*nb_inplace_and*/          0,
    /*nb_inplace_xor*/          0,
    /*nb_inplace_or*/           0,
    /*nb_floor_divide*/         0,
    /*nb_true_divide*/          0,
    /*nb_inplace_floor_divide*/ 0,
    /*nb_inplace_true_divide*/  0,
    /*nb_index*/                0
};


// forward declaration of new function
static PyTypeObject SbkPySide_QtCore_Qt_ToolBarAreas_Type = {
    PyObject_HEAD_INIT(&PyType_Type)
    /*ob_size*/             0,
    /*tp_name*/             "ToolBarAreas",
    /*tp_basicsize*/        0,
    /*tp_itemsize*/         0,
    /*tp_dealloc*/          0,
    /*tp_print*/            0,
    /*tp_getattr*/          0,
    /*tp_setattr*/          0,
    /*tp_compare*/          0,
    /*tp_repr*/             0,
    /*tp_as_number*/        &SbkPySide_QtCore_Qt_ToolBarArea_as_number,
    /*tp_as_sequence*/      0,
    /*tp_as_mapping*/       0,
    /*tp_hash*/             0,
    /*tp_call*/             0,
    /*tp_str*/              0,
    /*tp_getattro*/         0,
    /*tp_setattro*/         0,
    /*tp_as_buffer*/        0,
    /*tp_flags*/            Py_TPFLAGS_DEFAULT | Py_TPFLAGS_CHECKTYPES,
    /*tp_doc*/              0,
    /*tp_traverse*/         0,
    /*tp_clear*/            0,
    /*tp_richcompare*/      0,
    /*tp_weaklistoffset*/   0,
    /*tp_iter*/             0,
    /*tp_iternext*/         0,
    /*tp_methods*/          0,
    /*tp_members*/          0,
    /*tp_getset*/           0,
    /*tp_base*/             &PyInt_Type,
    /*tp_dict*/             0,
    /*tp_descr_get*/        0,
    /*tp_descr_set*/        0,
    /*tp_dictoffset*/       0,
    /*tp_init*/             0,
    /*tp_alloc*/            0,
    /*tp_new*/              PyInt_Type.tp_new,
    /*tp_free*/             0,
    /*tp_is_gc*/            0,
    /*tp_bases*/            0,
    /*tp_mro*/              0,
    /*tp_cache*/            0,
    /*tp_subclasses*/       0,
    /*tp_weaklist*/         0
};


PyObject* SbkPySide_QtCore_Qt_AlignmentFlag___and__(PyObject* self, PyObject* arg)
{
    return Shiboken::Converter< Qt::Alignment >::toPython(
        Shiboken::Converter<Qt::Alignment>::toCpp(self)
        & Shiboken::Converter< Qt::Alignment >::toCpp(arg)
    );
}

PyObject* SbkPySide_QtCore_Qt_AlignmentFlag___or__(PyObject* self, PyObject* arg)
{
    return Shiboken::Converter< Qt::Alignment >::toPython(
        Shiboken::Converter<Qt::Alignment>::toCpp(self)
        | Shiboken::Converter< Qt::Alignment >::toCpp(arg)
    );
}

PyObject* SbkPySide_QtCore_Qt_AlignmentFlag___xor__(PyObject* self, PyObject* arg)
{
    return Shiboken::Converter< Qt::Alignment >::toPython(
        Shiboken::Converter<Qt::Alignment>::toCpp(self)
        ^ Shiboken::Converter< Qt::Alignment >::toCpp(arg)
    );
}

PyObject* SbkPySide_QtCore_Qt_AlignmentFlag___invert__(PyObject* self, PyObject* arg)
{
    return Shiboken::Converter< Qt::Alignment >::toPython(
        ~Shiboken::Converter<Qt::Alignment >::toCpp(self)
    );
}


static PyNumberMethods SbkPySide_QtCore_Qt_AlignmentFlag_as_number = {
    /*nb_add*/                  0,
    /*nb_subtract*/             0,
    /*nb_multiply*/             0,
    /*nb_divide*/               0,
    /*nb_remainder*/            0,
    /*nb_divmod*/               0,
    /*nb_power*/                0,
    /*nb_negative*/             0,
    /*nb_positive*/             0,
    /*nb_absolute*/             0,
    /*nb_nonzero*/              0,
    /*nb_invert*/               (unaryfunc)SbkPySide_QtCore_Qt_AlignmentFlag___invert__,
    /*nb_lshift*/               0,
    /*nb_rshift*/               0,
    /*nb_and*/                  (binaryfunc)SbkPySide_QtCore_Qt_AlignmentFlag___and__,
    /*nb_xor*/                  (binaryfunc)SbkPySide_QtCore_Qt_AlignmentFlag___xor__,
    /*nb_or*/                   (binaryfunc)SbkPySide_QtCore_Qt_AlignmentFlag___or__,
    /*nb_coerce*/               0,
    /*nb_int*/                  0,
    /*nb_long*/                 0,
    /*nb_float*/                0,
    /*nb_oct*/                  0,
    /*nb_hex*/                  0,
    /*nb_inplace_add*/          0,
    /*nb_inplace_subtract*/     0,
    /*nb_inplace_multiply*/     0,
    /*nb_inplace_divide*/       0,
    /*nb_inplace_remainder*/    0,
    /*nb_inplace_power*/        0,
    /*nb_inplace_lshift*/       0,
    /*nb_inplace_rshift*/       0,
    /*nb_inplace_and*/          0,
    /*nb_inplace_xor*/          0,
    /*nb_inplace_or*/           0,
    /*nb_floor_divide*/         0,
    /*nb_true_divide*/          0,
    /*nb_inplace_floor_divide*/ 0,
    /*nb_inplace_true_divide*/  0,
    /*nb_index*/                0
};


// forward declaration of new function
static PyTypeObject SbkPySide_QtCore_Qt_Alignment_Type = {
    PyObject_HEAD_INIT(&PyType_Type)
    /*ob_size*/             0,
    /*tp_name*/             "Alignment",
    /*tp_basicsize*/        0,
    /*tp_itemsize*/         0,
    /*tp_dealloc*/          0,
    /*tp_print*/            0,
    /*tp_getattr*/          0,
    /*tp_setattr*/          0,
    /*tp_compare*/          0,
    /*tp_repr*/             0,
    /*tp_as_number*/        &SbkPySide_QtCore_Qt_AlignmentFlag_as_number,
    /*tp_as_sequence*/      0,
    /*tp_as_mapping*/       0,
    /*tp_hash*/             0,
    /*tp_call*/             0,
    /*tp_str*/              0,
    /*tp_getattro*/         0,
    /*tp_setattro*/         0,
    /*tp_as_buffer*/        0,
    /*tp_flags*/            Py_TPFLAGS_DEFAULT | Py_TPFLAGS_CHECKTYPES,
    /*tp_doc*/              0,
    /*tp_traverse*/         0,
    /*tp_clear*/            0,
    /*tp_richcompare*/      0,
    /*tp_weaklistoffset*/   0,
    /*tp_iter*/             0,
    /*tp_iternext*/         0,
    /*tp_methods*/          0,
    /*tp_members*/          0,
    /*tp_getset*/           0,
    /*tp_base*/             &PyInt_Type,
    /*tp_dict*/             0,
    /*tp_descr_get*/        0,
    /*tp_descr_set*/        0,
    /*tp_dictoffset*/       0,
    /*tp_init*/             0,
    /*tp_alloc*/            0,
    /*tp_new*/              PyInt_Type.tp_new,
    /*tp_free*/             0,
    /*tp_is_gc*/            0,
    /*tp_bases*/            0,
    /*tp_mro*/              0,
    /*tp_cache*/            0,
    /*tp_subclasses*/       0,
    /*tp_weaklist*/         0
};


PyObject* SbkPySide_QtCore_Qt_DockWidgetArea___and__(PyObject* self, PyObject* arg)
{
    return Shiboken::Converter< Qt::DockWidgetAreas >::toPython(
        Shiboken::Converter<Qt::DockWidgetAreas>::toCpp(self)
        & Shiboken::Converter< Qt::DockWidgetAreas >::toCpp(arg)
    );
}

PyObject* SbkPySide_QtCore_Qt_DockWidgetArea___or__(PyObject* self, PyObject* arg)
{
    return Shiboken::Converter< Qt::DockWidgetAreas >::toPython(
        Shiboken::Converter<Qt::DockWidgetAreas>::toCpp(self)
        | Shiboken::Converter< Qt::DockWidgetAreas >::toCpp(arg)
    );
}

PyObject* SbkPySide_QtCore_Qt_DockWidgetArea___xor__(PyObject* self, PyObject* arg)
{
    return Shiboken::Converter< Qt::DockWidgetAreas >::toPython(
        Shiboken::Converter<Qt::DockWidgetAreas>::toCpp(self)
        ^ Shiboken::Converter< Qt::DockWidgetAreas >::toCpp(arg)
    );
}

PyObject* SbkPySide_QtCore_Qt_DockWidgetArea___invert__(PyObject* self, PyObject* arg)
{
    return Shiboken::Converter< Qt::DockWidgetAreas >::toPython(
        ~Shiboken::Converter<Qt::DockWidgetAreas >::toCpp(self)
    );
}


static PyNumberMethods SbkPySide_QtCore_Qt_DockWidgetArea_as_number = {
    /*nb_add*/                  0,
    /*nb_subtract*/             0,
    /*nb_multiply*/             0,
    /*nb_divide*/               0,
    /*nb_remainder*/            0,
    /*nb_divmod*/               0,
    /*nb_power*/                0,
    /*nb_negative*/             0,
    /*nb_positive*/             0,
    /*nb_absolute*/             0,
    /*nb_nonzero*/              0,
    /*nb_invert*/               (unaryfunc)SbkPySide_QtCore_Qt_DockWidgetArea___invert__,
    /*nb_lshift*/               0,
    /*nb_rshift*/               0,
    /*nb_and*/                  (binaryfunc)SbkPySide_QtCore_Qt_DockWidgetArea___and__,
    /*nb_xor*/                  (binaryfunc)SbkPySide_QtCore_Qt_DockWidgetArea___xor__,
    /*nb_or*/                   (binaryfunc)SbkPySide_QtCore_Qt_DockWidgetArea___or__,
    /*nb_coerce*/               0,
    /*nb_int*/                  0,
    /*nb_long*/                 0,
    /*nb_float*/                0,
    /*nb_oct*/                  0,
    /*nb_hex*/                  0,
    /*nb_inplace_add*/          0,
    /*nb_inplace_subtract*/     0,
    /*nb_inplace_multiply*/     0,
    /*nb_inplace_divide*/       0,
    /*nb_inplace_remainder*/    0,
    /*nb_inplace_power*/        0,
    /*nb_inplace_lshift*/       0,
    /*nb_inplace_rshift*/       0,
    /*nb_inplace_and*/          0,
    /*nb_inplace_xor*/          0,
    /*nb_inplace_or*/           0,
    /*nb_floor_divide*/         0,
    /*nb_true_divide*/          0,
    /*nb_inplace_floor_divide*/ 0,
    /*nb_inplace_true_divide*/  0,
    /*nb_index*/                0
};


// forward declaration of new function
static PyTypeObject SbkPySide_QtCore_Qt_DockWidgetAreas_Type = {
    PyObject_HEAD_INIT(&PyType_Type)
    /*ob_size*/             0,
    /*tp_name*/             "DockWidgetAreas",
    /*tp_basicsize*/        0,
    /*tp_itemsize*/         0,
    /*tp_dealloc*/          0,
    /*tp_print*/            0,
    /*tp_getattr*/          0,
    /*tp_setattr*/          0,
    /*tp_compare*/          0,
    /*tp_repr*/             0,
    /*tp_as_number*/        &SbkPySide_QtCore_Qt_DockWidgetArea_as_number,
    /*tp_as_sequence*/      0,
    /*tp_as_mapping*/       0,
    /*tp_hash*/             0,
    /*tp_call*/             0,
    /*tp_str*/              0,
    /*tp_getattro*/         0,
    /*tp_setattro*/         0,
    /*tp_as_buffer*/        0,
    /*tp_flags*/            Py_TPFLAGS_DEFAULT | Py_TPFLAGS_CHECKTYPES,
    /*tp_doc*/              0,
    /*tp_traverse*/         0,
    /*tp_clear*/            0,
    /*tp_richcompare*/      0,
    /*tp_weaklistoffset*/   0,
    /*tp_iter*/             0,
    /*tp_iternext*/         0,
    /*tp_methods*/          0,
    /*tp_members*/          0,
    /*tp_getset*/           0,
    /*tp_base*/             &PyInt_Type,
    /*tp_dict*/             0,
    /*tp_descr_get*/        0,
    /*tp_descr_set*/        0,
    /*tp_dictoffset*/       0,
    /*tp_init*/             0,
    /*tp_alloc*/            0,
    /*tp_new*/              PyInt_Type.tp_new,
    /*tp_free*/             0,
    /*tp_is_gc*/            0,
    /*tp_bases*/            0,
    /*tp_mro*/              0,
    /*tp_cache*/            0,
    /*tp_subclasses*/       0,
    /*tp_weaklist*/         0
};


PyObject* SbkPySide_QtCore_Qt_KeyboardModifier___and__(PyObject* self, PyObject* arg)
{
    return Shiboken::Converter< Qt::KeyboardModifiers >::toPython(
        Shiboken::Converter<Qt::KeyboardModifiers>::toCpp(self)
        & Shiboken::Converter< Qt::KeyboardModifiers >::toCpp(arg)
    );
}

PyObject* SbkPySide_QtCore_Qt_KeyboardModifier___or__(PyObject* self, PyObject* arg)
{
    return Shiboken::Converter< Qt::KeyboardModifiers >::toPython(
        Shiboken::Converter<Qt::KeyboardModifiers>::toCpp(self)
        | Shiboken::Converter< Qt::KeyboardModifiers >::toCpp(arg)
    );
}

PyObject* SbkPySide_QtCore_Qt_KeyboardModifier___xor__(PyObject* self, PyObject* arg)
{
    return Shiboken::Converter< Qt::KeyboardModifiers >::toPython(
        Shiboken::Converter<Qt::KeyboardModifiers>::toCpp(self)
        ^ Shiboken::Converter< Qt::KeyboardModifiers >::toCpp(arg)
    );
}

PyObject* SbkPySide_QtCore_Qt_KeyboardModifier___invert__(PyObject* self, PyObject* arg)
{
    return Shiboken::Converter< Qt::KeyboardModifiers >::toPython(
        ~Shiboken::Converter<Qt::KeyboardModifiers >::toCpp(self)
    );
}


static PyNumberMethods SbkPySide_QtCore_Qt_KeyboardModifier_as_number = {
    /*nb_add*/                  0,
    /*nb_subtract*/             0,
    /*nb_multiply*/             0,
    /*nb_divide*/               0,
    /*nb_remainder*/            0,
    /*nb_divmod*/               0,
    /*nb_power*/                0,
    /*nb_negative*/             0,
    /*nb_positive*/             0,
    /*nb_absolute*/             0,
    /*nb_nonzero*/              0,
    /*nb_invert*/               (unaryfunc)SbkPySide_QtCore_Qt_KeyboardModifier___invert__,
    /*nb_lshift*/               0,
    /*nb_rshift*/               0,
    /*nb_and*/                  (binaryfunc)SbkPySide_QtCore_Qt_KeyboardModifier___and__,
    /*nb_xor*/                  (binaryfunc)SbkPySide_QtCore_Qt_KeyboardModifier___xor__,
    /*nb_or*/                   (binaryfunc)SbkPySide_QtCore_Qt_KeyboardModifier___or__,
    /*nb_coerce*/               0,
    /*nb_int*/                  0,
    /*nb_long*/                 0,
    /*nb_float*/                0,
    /*nb_oct*/                  0,
    /*nb_hex*/                  0,
    /*nb_inplace_add*/          0,
    /*nb_inplace_subtract*/     0,
    /*nb_inplace_multiply*/     0,
    /*nb_inplace_divide*/       0,
    /*nb_inplace_remainder*/    0,
    /*nb_inplace_power*/        0,
    /*nb_inplace_lshift*/       0,
    /*nb_inplace_rshift*/       0,
    /*nb_inplace_and*/          0,
    /*nb_inplace_xor*/          0,
    /*nb_inplace_or*/           0,
    /*nb_floor_divide*/         0,
    /*nb_true_divide*/          0,
    /*nb_inplace_floor_divide*/ 0,
    /*nb_inplace_true_divide*/  0,
    /*nb_index*/                0
};


// forward declaration of new function
static PyTypeObject SbkPySide_QtCore_Qt_KeyboardModifiers_Type = {
    PyObject_HEAD_INIT(&PyType_Type)
    /*ob_size*/             0,
    /*tp_name*/             "KeyboardModifiers",
    /*tp_basicsize*/        0,
    /*tp_itemsize*/         0,
    /*tp_dealloc*/          0,
    /*tp_print*/            0,
    /*tp_getattr*/          0,
    /*tp_setattr*/          0,
    /*tp_compare*/          0,
    /*tp_repr*/             0,
    /*tp_as_number*/        &SbkPySide_QtCore_Qt_KeyboardModifier_as_number,
    /*tp_as_sequence*/      0,
    /*tp_as_mapping*/       0,
    /*tp_hash*/             0,
    /*tp_call*/             0,
    /*tp_str*/              0,
    /*tp_getattro*/         0,
    /*tp_setattro*/         0,
    /*tp_as_buffer*/        0,
    /*tp_flags*/            Py_TPFLAGS_DEFAULT | Py_TPFLAGS_CHECKTYPES,
    /*tp_doc*/              0,
    /*tp_traverse*/         0,
    /*tp_clear*/            0,
    /*tp_richcompare*/      0,
    /*tp_weaklistoffset*/   0,
    /*tp_iter*/             0,
    /*tp_iternext*/         0,
    /*tp_methods*/          0,
    /*tp_members*/          0,
    /*tp_getset*/           0,
    /*tp_base*/             &PyInt_Type,
    /*tp_dict*/             0,
    /*tp_descr_get*/        0,
    /*tp_descr_set*/        0,
    /*tp_dictoffset*/       0,
    /*tp_init*/             0,
    /*tp_alloc*/            0,
    /*tp_new*/              PyInt_Type.tp_new,
    /*tp_free*/             0,
    /*tp_is_gc*/            0,
    /*tp_bases*/            0,
    /*tp_mro*/              0,
    /*tp_cache*/            0,
    /*tp_subclasses*/       0,
    /*tp_weaklist*/         0
};


PyObject* SbkPySide_QtCore_Qt_InputMethodHint___and__(PyObject* self, PyObject* arg)
{
    return Shiboken::Converter< Qt::InputMethodHints >::toPython(
        Shiboken::Converter<Qt::InputMethodHints>::toCpp(self)
        & Shiboken::Converter< Qt::InputMethodHints >::toCpp(arg)
    );
}

PyObject* SbkPySide_QtCore_Qt_InputMethodHint___or__(PyObject* self, PyObject* arg)
{
    return Shiboken::Converter< Qt::InputMethodHints >::toPython(
        Shiboken::Converter<Qt::InputMethodHints>::toCpp(self)
        | Shiboken::Converter< Qt::InputMethodHints >::toCpp(arg)
    );
}

PyObject* SbkPySide_QtCore_Qt_InputMethodHint___xor__(PyObject* self, PyObject* arg)
{
    return Shiboken::Converter< Qt::InputMethodHints >::toPython(
        Shiboken::Converter<Qt::InputMethodHints>::toCpp(self)
        ^ Shiboken::Converter< Qt::InputMethodHints >::toCpp(arg)
    );
}

PyObject* SbkPySide_QtCore_Qt_InputMethodHint___invert__(PyObject* self, PyObject* arg)
{
    return Shiboken::Converter< Qt::InputMethodHints >::toPython(
        ~Shiboken::Converter<Qt::InputMethodHints >::toCpp(self)
    );
}


static PyNumberMethods SbkPySide_QtCore_Qt_InputMethodHint_as_number = {
    /*nb_add*/                  0,
    /*nb_subtract*/             0,
    /*nb_multiply*/             0,
    /*nb_divide*/               0,
    /*nb_remainder*/            0,
    /*nb_divmod*/               0,
    /*nb_power*/                0,
    /*nb_negative*/             0,
    /*nb_positive*/             0,
    /*nb_absolute*/             0,
    /*nb_nonzero*/              0,
    /*nb_invert*/               (unaryfunc)SbkPySide_QtCore_Qt_InputMethodHint___invert__,
    /*nb_lshift*/               0,
    /*nb_rshift*/               0,
    /*nb_and*/                  (binaryfunc)SbkPySide_QtCore_Qt_InputMethodHint___and__,
    /*nb_xor*/                  (binaryfunc)SbkPySide_QtCore_Qt_InputMethodHint___xor__,
    /*nb_or*/                   (binaryfunc)SbkPySide_QtCore_Qt_InputMethodHint___or__,
    /*nb_coerce*/               0,
    /*nb_int*/                  0,
    /*nb_long*/                 0,
    /*nb_float*/                0,
    /*nb_oct*/                  0,
    /*nb_hex*/                  0,
    /*nb_inplace_add*/          0,
    /*nb_inplace_subtract*/     0,
    /*nb_inplace_multiply*/     0,
    /*nb_inplace_divide*/       0,
    /*nb_inplace_remainder*/    0,
    /*nb_inplace_power*/        0,
    /*nb_inplace_lshift*/       0,
    /*nb_inplace_rshift*/       0,
    /*nb_inplace_and*/          0,
    /*nb_inplace_xor*/          0,
    /*nb_inplace_or*/           0,
    /*nb_floor_divide*/         0,
    /*nb_true_divide*/          0,
    /*nb_inplace_floor_divide*/ 0,
    /*nb_inplace_true_divide*/  0,
    /*nb_index*/                0
};


// forward declaration of new function
static PyTypeObject SbkPySide_QtCore_Qt_InputMethodHints_Type = {
    PyObject_HEAD_INIT(&PyType_Type)
    /*ob_size*/             0,
    /*tp_name*/             "InputMethodHints",
    /*tp_basicsize*/        0,
    /*tp_itemsize*/         0,
    /*tp_dealloc*/          0,
    /*tp_print*/            0,
    /*tp_getattr*/          0,
    /*tp_setattr*/          0,
    /*tp_compare*/          0,
    /*tp_repr*/             0,
    /*tp_as_number*/        &SbkPySide_QtCore_Qt_InputMethodHint_as_number,
    /*tp_as_sequence*/      0,
    /*tp_as_mapping*/       0,
    /*tp_hash*/             0,
    /*tp_call*/             0,
    /*tp_str*/              0,
    /*tp_getattro*/         0,
    /*tp_setattro*/         0,
    /*tp_as_buffer*/        0,
    /*tp_flags*/            Py_TPFLAGS_DEFAULT | Py_TPFLAGS_CHECKTYPES,
    /*tp_doc*/              0,
    /*tp_traverse*/         0,
    /*tp_clear*/            0,
    /*tp_richcompare*/      0,
    /*tp_weaklistoffset*/   0,
    /*tp_iter*/             0,
    /*tp_iternext*/         0,
    /*tp_methods*/          0,
    /*tp_members*/          0,
    /*tp_getset*/           0,
    /*tp_base*/             &PyInt_Type,
    /*tp_dict*/             0,
    /*tp_descr_get*/        0,
    /*tp_descr_set*/        0,
    /*tp_dictoffset*/       0,
    /*tp_init*/             0,
    /*tp_alloc*/            0,
    /*tp_new*/              PyInt_Type.tp_new,
    /*tp_free*/             0,
    /*tp_is_gc*/            0,
    /*tp_bases*/            0,
    /*tp_mro*/              0,
    /*tp_cache*/            0,
    /*tp_subclasses*/       0,
    /*tp_weaklist*/         0
};


PyObject* SbkPySide_QtCore_Qt_ItemFlag___and__(PyObject* self, PyObject* arg)
{
    return Shiboken::Converter< Qt::ItemFlags >::toPython(
        Shiboken::Converter<Qt::ItemFlags>::toCpp(self)
        & Shiboken::Converter< Qt::ItemFlags >::toCpp(arg)
    );
}

PyObject* SbkPySide_QtCore_Qt_ItemFlag___or__(PyObject* self, PyObject* arg)
{
    return Shiboken::Converter< Qt::ItemFlags >::toPython(
        Shiboken::Converter<Qt::ItemFlags>::toCpp(self)
        | Shiboken::Converter< Qt::ItemFlags >::toCpp(arg)
    );
}

PyObject* SbkPySide_QtCore_Qt_ItemFlag___xor__(PyObject* self, PyObject* arg)
{
    return Shiboken::Converter< Qt::ItemFlags >::toPython(
        Shiboken::Converter<Qt::ItemFlags>::toCpp(self)
        ^ Shiboken::Converter< Qt::ItemFlags >::toCpp(arg)
    );
}

PyObject* SbkPySide_QtCore_Qt_ItemFlag___invert__(PyObject* self, PyObject* arg)
{
    return Shiboken::Converter< Qt::ItemFlags >::toPython(
        ~Shiboken::Converter<Qt::ItemFlags >::toCpp(self)
    );
}


static PyNumberMethods SbkPySide_QtCore_Qt_ItemFlag_as_number = {
    /*nb_add*/                  0,
    /*nb_subtract*/             0,
    /*nb_multiply*/             0,
    /*nb_divide*/               0,
    /*nb_remainder*/            0,
    /*nb_divmod*/               0,
    /*nb_power*/                0,
    /*nb_negative*/             0,
    /*nb_positive*/             0,
    /*nb_absolute*/             0,
    /*nb_nonzero*/              0,
    /*nb_invert*/               (unaryfunc)SbkPySide_QtCore_Qt_ItemFlag___invert__,
    /*nb_lshift*/               0,
    /*nb_rshift*/               0,
    /*nb_and*/                  (binaryfunc)SbkPySide_QtCore_Qt_ItemFlag___and__,
    /*nb_xor*/                  (binaryfunc)SbkPySide_QtCore_Qt_ItemFlag___xor__,
    /*nb_or*/                   (binaryfunc)SbkPySide_QtCore_Qt_ItemFlag___or__,
    /*nb_coerce*/               0,
    /*nb_int*/                  0,
    /*nb_long*/                 0,
    /*nb_float*/                0,
    /*nb_oct*/                  0,
    /*nb_hex*/                  0,
    /*nb_inplace_add*/          0,
    /*nb_inplace_subtract*/     0,
    /*nb_inplace_multiply*/     0,
    /*nb_inplace_divide*/       0,
    /*nb_inplace_remainder*/    0,
    /*nb_inplace_power*/        0,
    /*nb_inplace_lshift*/       0,
    /*nb_inplace_rshift*/       0,
    /*nb_inplace_and*/          0,
    /*nb_inplace_xor*/          0,
    /*nb_inplace_or*/           0,
    /*nb_floor_divide*/         0,
    /*nb_true_divide*/          0,
    /*nb_inplace_floor_divide*/ 0,
    /*nb_inplace_true_divide*/  0,
    /*nb_index*/                0
};


// forward declaration of new function
static PyTypeObject SbkPySide_QtCore_Qt_ItemFlags_Type = {
    PyObject_HEAD_INIT(&PyType_Type)
    /*ob_size*/             0,
    /*tp_name*/             "ItemFlags",
    /*tp_basicsize*/        0,
    /*tp_itemsize*/         0,
    /*tp_dealloc*/          0,
    /*tp_print*/            0,
    /*tp_getattr*/          0,
    /*tp_setattr*/          0,
    /*tp_compare*/          0,
    /*tp_repr*/             0,
    /*tp_as_number*/        &SbkPySide_QtCore_Qt_ItemFlag_as_number,
    /*tp_as_sequence*/      0,
    /*tp_as_mapping*/       0,
    /*tp_hash*/             0,
    /*tp_call*/             0,
    /*tp_str*/              0,
    /*tp_getattro*/         0,
    /*tp_setattro*/         0,
    /*tp_as_buffer*/        0,
    /*tp_flags*/            Py_TPFLAGS_DEFAULT | Py_TPFLAGS_CHECKTYPES,
    /*tp_doc*/              0,
    /*tp_traverse*/         0,
    /*tp_clear*/            0,
    /*tp_richcompare*/      0,
    /*tp_weaklistoffset*/   0,
    /*tp_iter*/             0,
    /*tp_iternext*/         0,
    /*tp_methods*/          0,
    /*tp_members*/          0,
    /*tp_getset*/           0,
    /*tp_base*/             &PyInt_Type,
    /*tp_dict*/             0,
    /*tp_descr_get*/        0,
    /*tp_descr_set*/        0,
    /*tp_dictoffset*/       0,
    /*tp_init*/             0,
    /*tp_alloc*/            0,
    /*tp_new*/              PyInt_Type.tp_new,
    /*tp_free*/             0,
    /*tp_is_gc*/            0,
    /*tp_bases*/            0,
    /*tp_mro*/              0,
    /*tp_cache*/            0,
    /*tp_subclasses*/       0,
    /*tp_weaklist*/         0
};


PyObject* SbkPySide_QtCore_Qt_Orientation___and__(PyObject* self, PyObject* arg)
{
    return Shiboken::Converter< Qt::Orientations >::toPython(
        Shiboken::Converter<Qt::Orientations>::toCpp(self)
        & Shiboken::Converter< Qt::Orientations >::toCpp(arg)
    );
}

PyObject* SbkPySide_QtCore_Qt_Orientation___or__(PyObject* self, PyObject* arg)
{
    return Shiboken::Converter< Qt::Orientations >::toPython(
        Shiboken::Converter<Qt::Orientations>::toCpp(self)
        | Shiboken::Converter< Qt::Orientations >::toCpp(arg)
    );
}

PyObject* SbkPySide_QtCore_Qt_Orientation___xor__(PyObject* self, PyObject* arg)
{
    return Shiboken::Converter< Qt::Orientations >::toPython(
        Shiboken::Converter<Qt::Orientations>::toCpp(self)
        ^ Shiboken::Converter< Qt::Orientations >::toCpp(arg)
    );
}

PyObject* SbkPySide_QtCore_Qt_Orientation___invert__(PyObject* self, PyObject* arg)
{
    return Shiboken::Converter< Qt::Orientations >::toPython(
        ~Shiboken::Converter<Qt::Orientations >::toCpp(self)
    );
}


static PyNumberMethods SbkPySide_QtCore_Qt_Orientation_as_number = {
    /*nb_add*/                  0,
    /*nb_subtract*/             0,
    /*nb_multiply*/             0,
    /*nb_divide*/               0,
    /*nb_remainder*/            0,
    /*nb_divmod*/               0,
    /*nb_power*/                0,
    /*nb_negative*/             0,
    /*nb_positive*/             0,
    /*nb_absolute*/             0,
    /*nb_nonzero*/              0,
    /*nb_invert*/               (unaryfunc)SbkPySide_QtCore_Qt_Orientation___invert__,
    /*nb_lshift*/               0,
    /*nb_rshift*/               0,
    /*nb_and*/                  (binaryfunc)SbkPySide_QtCore_Qt_Orientation___and__,
    /*nb_xor*/                  (binaryfunc)SbkPySide_QtCore_Qt_Orientation___xor__,
    /*nb_or*/                   (binaryfunc)SbkPySide_QtCore_Qt_Orientation___or__,
    /*nb_coerce*/               0,
    /*nb_int*/                  0,
    /*nb_long*/                 0,
    /*nb_float*/                0,
    /*nb_oct*/                  0,
    /*nb_hex*/                  0,
    /*nb_inplace_add*/          0,
    /*nb_inplace_subtract*/     0,
    /*nb_inplace_multiply*/     0,
    /*nb_inplace_divide*/       0,
    /*nb_inplace_remainder*/    0,
    /*nb_inplace_power*/        0,
    /*nb_inplace_lshift*/       0,
    /*nb_inplace_rshift*/       0,
    /*nb_inplace_and*/          0,
    /*nb_inplace_xor*/          0,
    /*nb_inplace_or*/           0,
    /*nb_floor_divide*/         0,
    /*nb_true_divide*/          0,
    /*nb_inplace_floor_divide*/ 0,
    /*nb_inplace_true_divide*/  0,
    /*nb_index*/                0
};


// forward declaration of new function
static PyTypeObject SbkPySide_QtCore_Qt_Orientations_Type = {
    PyObject_HEAD_INIT(&PyType_Type)
    /*ob_size*/             0,
    /*tp_name*/             "Orientations",
    /*tp_basicsize*/        0,
    /*tp_itemsize*/         0,
    /*tp_dealloc*/          0,
    /*tp_print*/            0,
    /*tp_getattr*/          0,
    /*tp_setattr*/          0,
    /*tp_compare*/          0,
    /*tp_repr*/             0,
    /*tp_as_number*/        &SbkPySide_QtCore_Qt_Orientation_as_number,
    /*tp_as_sequence*/      0,
    /*tp_as_mapping*/       0,
    /*tp_hash*/             0,
    /*tp_call*/             0,
    /*tp_str*/              0,
    /*tp_getattro*/         0,
    /*tp_setattro*/         0,
    /*tp_as_buffer*/        0,
    /*tp_flags*/            Py_TPFLAGS_DEFAULT | Py_TPFLAGS_CHECKTYPES,
    /*tp_doc*/              0,
    /*tp_traverse*/         0,
    /*tp_clear*/            0,
    /*tp_richcompare*/      0,
    /*tp_weaklistoffset*/   0,
    /*tp_iter*/             0,
    /*tp_iternext*/         0,
    /*tp_methods*/          0,
    /*tp_members*/          0,
    /*tp_getset*/           0,
    /*tp_base*/             &PyInt_Type,
    /*tp_dict*/             0,
    /*tp_descr_get*/        0,
    /*tp_descr_set*/        0,
    /*tp_dictoffset*/       0,
    /*tp_init*/             0,
    /*tp_alloc*/            0,
    /*tp_new*/              PyInt_Type.tp_new,
    /*tp_free*/             0,
    /*tp_is_gc*/            0,
    /*tp_bases*/            0,
    /*tp_mro*/              0,
    /*tp_cache*/            0,
    /*tp_subclasses*/       0,
    /*tp_weaklist*/         0
};


PyObject* SbkPySide_QtCore_Qt_WindowState___and__(PyObject* self, PyObject* arg)
{
    return Shiboken::Converter< Qt::WindowStates >::toPython(
        Shiboken::Converter<Qt::WindowStates>::toCpp(self)
        & Shiboken::Converter< Qt::WindowStates >::toCpp(arg)
    );
}

PyObject* SbkPySide_QtCore_Qt_WindowState___or__(PyObject* self, PyObject* arg)
{
    return Shiboken::Converter< Qt::WindowStates >::toPython(
        Shiboken::Converter<Qt::WindowStates>::toCpp(self)
        | Shiboken::Converter< Qt::WindowStates >::toCpp(arg)
    );
}

PyObject* SbkPySide_QtCore_Qt_WindowState___xor__(PyObject* self, PyObject* arg)
{
    return Shiboken::Converter< Qt::WindowStates >::toPython(
        Shiboken::Converter<Qt::WindowStates>::toCpp(self)
        ^ Shiboken::Converter< Qt::WindowStates >::toCpp(arg)
    );
}

PyObject* SbkPySide_QtCore_Qt_WindowState___invert__(PyObject* self, PyObject* arg)
{
    return Shiboken::Converter< Qt::WindowStates >::toPython(
        ~Shiboken::Converter<Qt::WindowStates >::toCpp(self)
    );
}


static PyNumberMethods SbkPySide_QtCore_Qt_WindowState_as_number = {
    /*nb_add*/                  0,
    /*nb_subtract*/             0,
    /*nb_multiply*/             0,
    /*nb_divide*/               0,
    /*nb_remainder*/            0,
    /*nb_divmod*/               0,
    /*nb_power*/                0,
    /*nb_negative*/             0,
    /*nb_positive*/             0,
    /*nb_absolute*/             0,
    /*nb_nonzero*/              0,
    /*nb_invert*/               (unaryfunc)SbkPySide_QtCore_Qt_WindowState___invert__,
    /*nb_lshift*/               0,
    /*nb_rshift*/               0,
    /*nb_and*/                  (binaryfunc)SbkPySide_QtCore_Qt_WindowState___and__,
    /*nb_xor*/                  (binaryfunc)SbkPySide_QtCore_Qt_WindowState___xor__,
    /*nb_or*/                   (binaryfunc)SbkPySide_QtCore_Qt_WindowState___or__,
    /*nb_coerce*/               0,
    /*nb_int*/                  0,
    /*nb_long*/                 0,
    /*nb_float*/                0,
    /*nb_oct*/                  0,
    /*nb_hex*/                  0,
    /*nb_inplace_add*/          0,
    /*nb_inplace_subtract*/     0,
    /*nb_inplace_multiply*/     0,
    /*nb_inplace_divide*/       0,
    /*nb_inplace_remainder*/    0,
    /*nb_inplace_power*/        0,
    /*nb_inplace_lshift*/       0,
    /*nb_inplace_rshift*/       0,
    /*nb_inplace_and*/          0,
    /*nb_inplace_xor*/          0,
    /*nb_inplace_or*/           0,
    /*nb_floor_divide*/         0,
    /*nb_true_divide*/          0,
    /*nb_inplace_floor_divide*/ 0,
    /*nb_inplace_true_divide*/  0,
    /*nb_index*/                0
};


// forward declaration of new function
static PyTypeObject SbkPySide_QtCore_Qt_WindowStates_Type = {
    PyObject_HEAD_INIT(&PyType_Type)
    /*ob_size*/             0,
    /*tp_name*/             "WindowStates",
    /*tp_basicsize*/        0,
    /*tp_itemsize*/         0,
    /*tp_dealloc*/          0,
    /*tp_print*/            0,
    /*tp_getattr*/          0,
    /*tp_setattr*/          0,
    /*tp_compare*/          0,
    /*tp_repr*/             0,
    /*tp_as_number*/        &SbkPySide_QtCore_Qt_WindowState_as_number,
    /*tp_as_sequence*/      0,
    /*tp_as_mapping*/       0,
    /*tp_hash*/             0,
    /*tp_call*/             0,
    /*tp_str*/              0,
    /*tp_getattro*/         0,
    /*tp_setattro*/         0,
    /*tp_as_buffer*/        0,
    /*tp_flags*/            Py_TPFLAGS_DEFAULT | Py_TPFLAGS_CHECKTYPES,
    /*tp_doc*/              0,
    /*tp_traverse*/         0,
    /*tp_clear*/            0,
    /*tp_richcompare*/      0,
    /*tp_weaklistoffset*/   0,
    /*tp_iter*/             0,
    /*tp_iternext*/         0,
    /*tp_methods*/          0,
    /*tp_members*/          0,
    /*tp_getset*/           0,
    /*tp_base*/             &PyInt_Type,
    /*tp_dict*/             0,
    /*tp_descr_get*/        0,
    /*tp_descr_set*/        0,
    /*tp_dictoffset*/       0,
    /*tp_init*/             0,
    /*tp_alloc*/            0,
    /*tp_new*/              PyInt_Type.tp_new,
    /*tp_free*/             0,
    /*tp_is_gc*/            0,
    /*tp_bases*/            0,
    /*tp_mro*/              0,
    /*tp_cache*/            0,
    /*tp_subclasses*/       0,
    /*tp_weaklist*/         0
};


PyObject* SbkPySide_QtCore_Qt_TextInteractionFlag___and__(PyObject* self, PyObject* arg)
{
    return Shiboken::Converter< Qt::TextInteractionFlags >::toPython(
        Shiboken::Converter<Qt::TextInteractionFlags>::toCpp(self)
        & Shiboken::Converter< Qt::TextInteractionFlags >::toCpp(arg)
    );
}

PyObject* SbkPySide_QtCore_Qt_TextInteractionFlag___or__(PyObject* self, PyObject* arg)
{
    return Shiboken::Converter< Qt::TextInteractionFlags >::toPython(
        Shiboken::Converter<Qt::TextInteractionFlags>::toCpp(self)
        | Shiboken::Converter< Qt::TextInteractionFlags >::toCpp(arg)
    );
}

PyObject* SbkPySide_QtCore_Qt_TextInteractionFlag___xor__(PyObject* self, PyObject* arg)
{
    return Shiboken::Converter< Qt::TextInteractionFlags >::toPython(
        Shiboken::Converter<Qt::TextInteractionFlags>::toCpp(self)
        ^ Shiboken::Converter< Qt::TextInteractionFlags >::toCpp(arg)
    );
}

PyObject* SbkPySide_QtCore_Qt_TextInteractionFlag___invert__(PyObject* self, PyObject* arg)
{
    return Shiboken::Converter< Qt::TextInteractionFlags >::toPython(
        ~Shiboken::Converter<Qt::TextInteractionFlags >::toCpp(self)
    );
}


static PyNumberMethods SbkPySide_QtCore_Qt_TextInteractionFlag_as_number = {
    /*nb_add*/                  0,
    /*nb_subtract*/             0,
    /*nb_multiply*/             0,
    /*nb_divide*/               0,
    /*nb_remainder*/            0,
    /*nb_divmod*/               0,
    /*nb_power*/                0,
    /*nb_negative*/             0,
    /*nb_positive*/             0,
    /*nb_absolute*/             0,
    /*nb_nonzero*/              0,
    /*nb_invert*/               (unaryfunc)SbkPySide_QtCore_Qt_TextInteractionFlag___invert__,
    /*nb_lshift*/               0,
    /*nb_rshift*/               0,
    /*nb_and*/                  (binaryfunc)SbkPySide_QtCore_Qt_TextInteractionFlag___and__,
    /*nb_xor*/                  (binaryfunc)SbkPySide_QtCore_Qt_TextInteractionFlag___xor__,
    /*nb_or*/                   (binaryfunc)SbkPySide_QtCore_Qt_TextInteractionFlag___or__,
    /*nb_coerce*/               0,
    /*nb_int*/                  0,
    /*nb_long*/                 0,
    /*nb_float*/                0,
    /*nb_oct*/                  0,
    /*nb_hex*/                  0,
    /*nb_inplace_add*/          0,
    /*nb_inplace_subtract*/     0,
    /*nb_inplace_multiply*/     0,
    /*nb_inplace_divide*/       0,
    /*nb_inplace_remainder*/    0,
    /*nb_inplace_power*/        0,
    /*nb_inplace_lshift*/       0,
    /*nb_inplace_rshift*/       0,
    /*nb_inplace_and*/          0,
    /*nb_inplace_xor*/          0,
    /*nb_inplace_or*/           0,
    /*nb_floor_divide*/         0,
    /*nb_true_divide*/          0,
    /*nb_inplace_floor_divide*/ 0,
    /*nb_inplace_true_divide*/  0,
    /*nb_index*/                0
};


// forward declaration of new function
static PyTypeObject SbkPySide_QtCore_Qt_TextInteractionFlags_Type = {
    PyObject_HEAD_INIT(&PyType_Type)
    /*ob_size*/             0,
    /*tp_name*/             "TextInteractionFlags",
    /*tp_basicsize*/        0,
    /*tp_itemsize*/         0,
    /*tp_dealloc*/          0,
    /*tp_print*/            0,
    /*tp_getattr*/          0,
    /*tp_setattr*/          0,
    /*tp_compare*/          0,
    /*tp_repr*/             0,
    /*tp_as_number*/        &SbkPySide_QtCore_Qt_TextInteractionFlag_as_number,
    /*tp_as_sequence*/      0,
    /*tp_as_mapping*/       0,
    /*tp_hash*/             0,
    /*tp_call*/             0,
    /*tp_str*/              0,
    /*tp_getattro*/         0,
    /*tp_setattro*/         0,
    /*tp_as_buffer*/        0,
    /*tp_flags*/            Py_TPFLAGS_DEFAULT | Py_TPFLAGS_CHECKTYPES,
    /*tp_doc*/              0,
    /*tp_traverse*/         0,
    /*tp_clear*/            0,
    /*tp_richcompare*/      0,
    /*tp_weaklistoffset*/   0,
    /*tp_iter*/             0,
    /*tp_iternext*/         0,
    /*tp_methods*/          0,
    /*tp_members*/          0,
    /*tp_getset*/           0,
    /*tp_base*/             &PyInt_Type,
    /*tp_dict*/             0,
    /*tp_descr_get*/        0,
    /*tp_descr_set*/        0,
    /*tp_dictoffset*/       0,
    /*tp_init*/             0,
    /*tp_alloc*/            0,
    /*tp_new*/              PyInt_Type.tp_new,
    /*tp_free*/             0,
    /*tp_is_gc*/            0,
    /*tp_bases*/            0,
    /*tp_mro*/              0,
    /*tp_cache*/            0,
    /*tp_subclasses*/       0,
    /*tp_weaklist*/         0
};


PyObject* SbkPySide_QtCore_Qt_MouseButton___and__(PyObject* self, PyObject* arg)
{
    return Shiboken::Converter< Qt::MouseButtons >::toPython(
        Shiboken::Converter<Qt::MouseButtons>::toCpp(self)
        & Shiboken::Converter< Qt::MouseButtons >::toCpp(arg)
    );
}

PyObject* SbkPySide_QtCore_Qt_MouseButton___or__(PyObject* self, PyObject* arg)
{
    return Shiboken::Converter< Qt::MouseButtons >::toPython(
        Shiboken::Converter<Qt::MouseButtons>::toCpp(self)
        | Shiboken::Converter< Qt::MouseButtons >::toCpp(arg)
    );
}

PyObject* SbkPySide_QtCore_Qt_MouseButton___xor__(PyObject* self, PyObject* arg)
{
    return Shiboken::Converter< Qt::MouseButtons >::toPython(
        Shiboken::Converter<Qt::MouseButtons>::toCpp(self)
        ^ Shiboken::Converter< Qt::MouseButtons >::toCpp(arg)
    );
}

PyObject* SbkPySide_QtCore_Qt_MouseButton___invert__(PyObject* self, PyObject* arg)
{
    return Shiboken::Converter< Qt::MouseButtons >::toPython(
        ~Shiboken::Converter<Qt::MouseButtons >::toCpp(self)
    );
}


static PyNumberMethods SbkPySide_QtCore_Qt_MouseButton_as_number = {
    /*nb_add*/                  0,
    /*nb_subtract*/             0,
    /*nb_multiply*/             0,
    /*nb_divide*/               0,
    /*nb_remainder*/            0,
    /*nb_divmod*/               0,
    /*nb_power*/                0,
    /*nb_negative*/             0,
    /*nb_positive*/             0,
    /*nb_absolute*/             0,
    /*nb_nonzero*/              0,
    /*nb_invert*/               (unaryfunc)SbkPySide_QtCore_Qt_MouseButton___invert__,
    /*nb_lshift*/               0,
    /*nb_rshift*/               0,
    /*nb_and*/                  (binaryfunc)SbkPySide_QtCore_Qt_MouseButton___and__,
    /*nb_xor*/                  (binaryfunc)SbkPySide_QtCore_Qt_MouseButton___xor__,
    /*nb_or*/                   (binaryfunc)SbkPySide_QtCore_Qt_MouseButton___or__,
    /*nb_coerce*/               0,
    /*nb_int*/                  0,
    /*nb_long*/                 0,
    /*nb_float*/                0,
    /*nb_oct*/                  0,
    /*nb_hex*/                  0,
    /*nb_inplace_add*/          0,
    /*nb_inplace_subtract*/     0,
    /*nb_inplace_multiply*/     0,
    /*nb_inplace_divide*/       0,
    /*nb_inplace_remainder*/    0,
    /*nb_inplace_power*/        0,
    /*nb_inplace_lshift*/       0,
    /*nb_inplace_rshift*/       0,
    /*nb_inplace_and*/          0,
    /*nb_inplace_xor*/          0,
    /*nb_inplace_or*/           0,
    /*nb_floor_divide*/         0,
    /*nb_true_divide*/          0,
    /*nb_inplace_floor_divide*/ 0,
    /*nb_inplace_true_divide*/  0,
    /*nb_index*/                0
};


// forward declaration of new function
static PyTypeObject SbkPySide_QtCore_Qt_MouseButtons_Type = {
    PyObject_HEAD_INIT(&PyType_Type)
    /*ob_size*/             0,
    /*tp_name*/             "MouseButtons",
    /*tp_basicsize*/        0,
    /*tp_itemsize*/         0,
    /*tp_dealloc*/          0,
    /*tp_print*/            0,
    /*tp_getattr*/          0,
    /*tp_setattr*/          0,
    /*tp_compare*/          0,
    /*tp_repr*/             0,
    /*tp_as_number*/        &SbkPySide_QtCore_Qt_MouseButton_as_number,
    /*tp_as_sequence*/      0,
    /*tp_as_mapping*/       0,
    /*tp_hash*/             0,
    /*tp_call*/             0,
    /*tp_str*/              0,
    /*tp_getattro*/         0,
    /*tp_setattro*/         0,
    /*tp_as_buffer*/        0,
    /*tp_flags*/            Py_TPFLAGS_DEFAULT | Py_TPFLAGS_CHECKTYPES,
    /*tp_doc*/              0,
    /*tp_traverse*/         0,
    /*tp_clear*/            0,
    /*tp_richcompare*/      0,
    /*tp_weaklistoffset*/   0,
    /*tp_iter*/             0,
    /*tp_iternext*/         0,
    /*tp_methods*/          0,
    /*tp_members*/          0,
    /*tp_getset*/           0,
    /*tp_base*/             &PyInt_Type,
    /*tp_dict*/             0,
    /*tp_descr_get*/        0,
    /*tp_descr_set*/        0,
    /*tp_dictoffset*/       0,
    /*tp_init*/             0,
    /*tp_alloc*/            0,
    /*tp_new*/              PyInt_Type.tp_new,
    /*tp_free*/             0,
    /*tp_is_gc*/            0,
    /*tp_bases*/            0,
    /*tp_mro*/              0,
    /*tp_cache*/            0,
    /*tp_subclasses*/       0,
    /*tp_weaklist*/         0
};


PyObject* SbkPySide_QtCore_Qt_MatchFlag___and__(PyObject* self, PyObject* arg)
{
    return Shiboken::Converter< Qt::MatchFlags >::toPython(
        Shiboken::Converter<Qt::MatchFlags>::toCpp(self)
        & Shiboken::Converter< Qt::MatchFlags >::toCpp(arg)
    );
}

PyObject* SbkPySide_QtCore_Qt_MatchFlag___or__(PyObject* self, PyObject* arg)
{
    return Shiboken::Converter< Qt::MatchFlags >::toPython(
        Shiboken::Converter<Qt::MatchFlags>::toCpp(self)
        | Shiboken::Converter< Qt::MatchFlags >::toCpp(arg)
    );
}

PyObject* SbkPySide_QtCore_Qt_MatchFlag___xor__(PyObject* self, PyObject* arg)
{
    return Shiboken::Converter< Qt::MatchFlags >::toPython(
        Shiboken::Converter<Qt::MatchFlags>::toCpp(self)
        ^ Shiboken::Converter< Qt::MatchFlags >::toCpp(arg)
    );
}

PyObject* SbkPySide_QtCore_Qt_MatchFlag___invert__(PyObject* self, PyObject* arg)
{
    return Shiboken::Converter< Qt::MatchFlags >::toPython(
        ~Shiboken::Converter<Qt::MatchFlags >::toCpp(self)
    );
}


static PyNumberMethods SbkPySide_QtCore_Qt_MatchFlag_as_number = {
    /*nb_add*/                  0,
    /*nb_subtract*/             0,
    /*nb_multiply*/             0,
    /*nb_divide*/               0,
    /*nb_remainder*/            0,
    /*nb_divmod*/               0,
    /*nb_power*/                0,
    /*nb_negative*/             0,
    /*nb_positive*/             0,
    /*nb_absolute*/             0,
    /*nb_nonzero*/              0,
    /*nb_invert*/               (unaryfunc)SbkPySide_QtCore_Qt_MatchFlag___invert__,
    /*nb_lshift*/               0,
    /*nb_rshift*/               0,
    /*nb_and*/                  (binaryfunc)SbkPySide_QtCore_Qt_MatchFlag___and__,
    /*nb_xor*/                  (binaryfunc)SbkPySide_QtCore_Qt_MatchFlag___xor__,
    /*nb_or*/                   (binaryfunc)SbkPySide_QtCore_Qt_MatchFlag___or__,
    /*nb_coerce*/               0,
    /*nb_int*/                  0,
    /*nb_long*/                 0,
    /*nb_float*/                0,
    /*nb_oct*/                  0,
    /*nb_hex*/                  0,
    /*nb_inplace_add*/          0,
    /*nb_inplace_subtract*/     0,
    /*nb_inplace_multiply*/     0,
    /*nb_inplace_divide*/       0,
    /*nb_inplace_remainder*/    0,
    /*nb_inplace_power*/        0,
    /*nb_inplace_lshift*/       0,
    /*nb_inplace_rshift*/       0,
    /*nb_inplace_and*/          0,
    /*nb_inplace_xor*/          0,
    /*nb_inplace_or*/           0,
    /*nb_floor_divide*/         0,
    /*nb_true_divide*/          0,
    /*nb_inplace_floor_divide*/ 0,
    /*nb_inplace_true_divide*/  0,
    /*nb_index*/                0
};


// forward declaration of new function
static PyTypeObject SbkPySide_QtCore_Qt_MatchFlags_Type = {
    PyObject_HEAD_INIT(&PyType_Type)
    /*ob_size*/             0,
    /*tp_name*/             "MatchFlags",
    /*tp_basicsize*/        0,
    /*tp_itemsize*/         0,
    /*tp_dealloc*/          0,
    /*tp_print*/            0,
    /*tp_getattr*/          0,
    /*tp_setattr*/          0,
    /*tp_compare*/          0,
    /*tp_repr*/             0,
    /*tp_as_number*/        &SbkPySide_QtCore_Qt_MatchFlag_as_number,
    /*tp_as_sequence*/      0,
    /*tp_as_mapping*/       0,
    /*tp_hash*/             0,
    /*tp_call*/             0,
    /*tp_str*/              0,
    /*tp_getattro*/         0,
    /*tp_setattro*/         0,
    /*tp_as_buffer*/        0,
    /*tp_flags*/            Py_TPFLAGS_DEFAULT | Py_TPFLAGS_CHECKTYPES,
    /*tp_doc*/              0,
    /*tp_traverse*/         0,
    /*tp_clear*/            0,
    /*tp_richcompare*/      0,
    /*tp_weaklistoffset*/   0,
    /*tp_iter*/             0,
    /*tp_iternext*/         0,
    /*tp_methods*/          0,
    /*tp_members*/          0,
    /*tp_getset*/           0,
    /*tp_base*/             &PyInt_Type,
    /*tp_dict*/             0,
    /*tp_descr_get*/        0,
    /*tp_descr_set*/        0,
    /*tp_dictoffset*/       0,
    /*tp_init*/             0,
    /*tp_alloc*/            0,
    /*tp_new*/              PyInt_Type.tp_new,
    /*tp_free*/             0,
    /*tp_is_gc*/            0,
    /*tp_bases*/            0,
    /*tp_mro*/              0,
    /*tp_cache*/            0,
    /*tp_subclasses*/       0,
    /*tp_weaklist*/         0
};



void init_Qt(PyObject* module)
{
    SbkPySide_QtCoreTypes[SBK_QT_IDX] = reinterpret_cast<PyTypeObject*>(&Sbk_Qt_Type);

    Shiboken::ObjectType::initPrivateData(&Sbk_Qt_Type);
    if (PyType_Ready((PyTypeObject*)&Sbk_Qt_Type) < 0)
        return;

    Shiboken::ObjectType::setOriginalName(&Sbk_Qt_Type, "Qt");
    PyModule_AddObject(module, "Qt",
        ((PyObject*)&Sbk_Qt_Type));

    // Initialize enums
    PyObject* enumItem;

    // init enum: ShortcutContext
    PyTypeObject* SbkPySide_QtCore_Qt_ShortcutContext = Shiboken::Enum::newType("ShortcutContext");
    SbkPySide_QtCoreTypes[SBK_QT_SHORTCUTCONTEXT_IDX] = SbkPySide_QtCore_Qt_ShortcutContext;
    if (PyType_Ready(SbkPySide_QtCore_Qt_ShortcutContext) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "ShortcutContext",((PyObject*)SbkPySide_QtCore_Qt_ShortcutContext));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ShortcutContext,(long) Qt::WidgetShortcut, "WidgetShortcut");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WidgetShortcut", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ShortcutContext->tp_dict,"WidgetShortcut", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ShortcutContext,(long) Qt::WindowShortcut, "WindowShortcut");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WindowShortcut", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ShortcutContext->tp_dict,"WindowShortcut", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ShortcutContext,(long) Qt::ApplicationShortcut, "ApplicationShortcut");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"ApplicationShortcut", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ShortcutContext->tp_dict,"ApplicationShortcut", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ShortcutContext,(long) Qt::WidgetWithChildrenShortcut, "WidgetWithChildrenShortcut");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WidgetWithChildrenShortcut", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ShortcutContext->tp_dict,"WidgetWithChildrenShortcut", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("Qt::ShortcutContext");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::ShortcutContext");
    // end of enum ShortcutContext

    // init enum: CheckState
    PyTypeObject* SbkPySide_QtCore_Qt_CheckState = Shiboken::Enum::newType("CheckState");
    SbkPySide_QtCoreTypes[SBK_QT_CHECKSTATE_IDX] = SbkPySide_QtCore_Qt_CheckState;
    if (PyType_Ready(SbkPySide_QtCore_Qt_CheckState) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "CheckState",((PyObject*)SbkPySide_QtCore_Qt_CheckState));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_CheckState,(long) Qt::Unchecked, "Unchecked");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Unchecked", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_CheckState->tp_dict,"Unchecked", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_CheckState,(long) Qt::PartiallyChecked, "PartiallyChecked");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"PartiallyChecked", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_CheckState->tp_dict,"PartiallyChecked", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_CheckState,(long) Qt::Checked, "Checked");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Checked", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_CheckState->tp_dict,"Checked", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("Qt::CheckState");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::CheckState");
    // end of enum CheckState

    // init enum: FocusPolicy
    PyTypeObject* SbkPySide_QtCore_Qt_FocusPolicy = Shiboken::Enum::newType("FocusPolicy");
    SbkPySide_QtCoreTypes[SBK_QT_FOCUSPOLICY_IDX] = SbkPySide_QtCore_Qt_FocusPolicy;
    if (PyType_Ready(SbkPySide_QtCore_Qt_FocusPolicy) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "FocusPolicy",((PyObject*)SbkPySide_QtCore_Qt_FocusPolicy));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_FocusPolicy,(long) Qt::NoFocus, "NoFocus");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"NoFocus", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_FocusPolicy->tp_dict,"NoFocus", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_FocusPolicy,(long) Qt::TabFocus, "TabFocus");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"TabFocus", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_FocusPolicy->tp_dict,"TabFocus", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_FocusPolicy,(long) Qt::ClickFocus, "ClickFocus");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"ClickFocus", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_FocusPolicy->tp_dict,"ClickFocus", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_FocusPolicy,(long) Qt::StrongFocus, "StrongFocus");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"StrongFocus", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_FocusPolicy->tp_dict,"StrongFocus", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_FocusPolicy,(long) Qt::WheelFocus, "WheelFocus");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WheelFocus", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_FocusPolicy->tp_dict,"WheelFocus", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("Qt::FocusPolicy");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::FocusPolicy");
    // end of enum FocusPolicy

    // init enum: GestureType
    PyTypeObject* SbkPySide_QtCore_Qt_GestureType = Shiboken::Enum::newType("GestureType");
    SbkPySide_QtCoreTypes[SBK_QT_GESTURETYPE_IDX] = SbkPySide_QtCore_Qt_GestureType;
    if (PyType_Ready(SbkPySide_QtCore_Qt_GestureType) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "GestureType",((PyObject*)SbkPySide_QtCore_Qt_GestureType));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_GestureType,(long) Qt::TapGesture, "TapGesture");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"TapGesture", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_GestureType->tp_dict,"TapGesture", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_GestureType,(long) Qt::TapAndHoldGesture, "TapAndHoldGesture");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"TapAndHoldGesture", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_GestureType->tp_dict,"TapAndHoldGesture", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_GestureType,(long) Qt::PanGesture, "PanGesture");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"PanGesture", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_GestureType->tp_dict,"PanGesture", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_GestureType,(long) Qt::PinchGesture, "PinchGesture");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"PinchGesture", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_GestureType->tp_dict,"PinchGesture", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_GestureType,(long) Qt::SwipeGesture, "SwipeGesture");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"SwipeGesture", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_GestureType->tp_dict,"SwipeGesture", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_GestureType,(long) Qt::CustomGesture, "CustomGesture");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"CustomGesture", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_GestureType->tp_dict,"CustomGesture", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_GestureType,(long) Qt::LastGestureType, "LastGestureType");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"LastGestureType", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_GestureType->tp_dict,"LastGestureType", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("Qt::GestureType");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::GestureType");
    // end of enum GestureType

    // init enum: DropAction
    PyTypeObject* SbkPySide_QtCore_Qt_DropAction = Shiboken::Enum::newType("DropAction");
    SbkPySide_QtCore_Qt_DropAction->tp_as_number = &SbkPySide_QtCore_Qt_DropAction_as_number;
    SbkPySide_QtCoreTypes[SBK_QT_DROPACTION_IDX] = SbkPySide_QtCore_Qt_DropAction;
    if (PyType_Ready(SbkPySide_QtCore_Qt_DropAction) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "DropAction",((PyObject*)SbkPySide_QtCore_Qt_DropAction));

    // init flags class: QFlags<Qt::DropAction>
    SbkPySide_QtCoreTypes[SBK_QFLAGS_QT_DROPACTION__IDX] = &SbkPySide_QtCore_Qt_DropActions_Type;
    if (PyType_Ready((PyTypeObject*)&SbkPySide_QtCore_Qt_DropActions_Type) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "DropActions",((PyObject*)&SbkPySide_QtCore_Qt_DropActions_Type));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_DropAction,(long) Qt::CopyAction, "CopyAction");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"CopyAction", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_DropAction->tp_dict,"CopyAction", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_DropAction,(long) Qt::MoveAction, "MoveAction");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"MoveAction", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_DropAction->tp_dict,"MoveAction", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_DropAction,(long) Qt::LinkAction, "LinkAction");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"LinkAction", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_DropAction->tp_dict,"LinkAction", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_DropAction,(long) Qt::ActionMask, "ActionMask");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"ActionMask", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_DropAction->tp_dict,"ActionMask", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_DropAction,(long) Qt::TargetMoveAction, "TargetMoveAction");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"TargetMoveAction", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_DropAction->tp_dict,"TargetMoveAction", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_DropAction,(long) Qt::IgnoreAction, "IgnoreAction");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"IgnoreAction", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_DropAction->tp_dict,"IgnoreAction", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("Qt::DropAction");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::DropAction");
    // end of enum DropAction

    // init enum: WindowType
    PyTypeObject* SbkPySide_QtCore_Qt_WindowType = Shiboken::Enum::newType("WindowType");
    SbkPySide_QtCore_Qt_WindowType->tp_as_number = &SbkPySide_QtCore_Qt_WindowType_as_number;
    SbkPySide_QtCoreTypes[SBK_QT_WINDOWTYPE_IDX] = SbkPySide_QtCore_Qt_WindowType;
    if (PyType_Ready(SbkPySide_QtCore_Qt_WindowType) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "WindowType",((PyObject*)SbkPySide_QtCore_Qt_WindowType));

    // init flags class: QFlags<Qt::WindowType>
    SbkPySide_QtCoreTypes[SBK_QFLAGS_QT_WINDOWTYPE__IDX] = &SbkPySide_QtCore_Qt_WindowFlags_Type;
    if (PyType_Ready((PyTypeObject*)&SbkPySide_QtCore_Qt_WindowFlags_Type) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "WindowFlags",((PyObject*)&SbkPySide_QtCore_Qt_WindowFlags_Type));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WindowType,(long) Qt::Widget, "Widget");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Widget", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WindowType->tp_dict,"Widget", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WindowType,(long) Qt::Window, "Window");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Window", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WindowType->tp_dict,"Window", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WindowType,(long) Qt::Dialog, "Dialog");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Dialog", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WindowType->tp_dict,"Dialog", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WindowType,(long) Qt::Sheet, "Sheet");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Sheet", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WindowType->tp_dict,"Sheet", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WindowType,(long) Qt::Drawer, "Drawer");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Drawer", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WindowType->tp_dict,"Drawer", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WindowType,(long) Qt::Popup, "Popup");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Popup", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WindowType->tp_dict,"Popup", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WindowType,(long) Qt::Tool, "Tool");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Tool", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WindowType->tp_dict,"Tool", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WindowType,(long) Qt::ToolTip, "ToolTip");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"ToolTip", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WindowType->tp_dict,"ToolTip", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WindowType,(long) Qt::SplashScreen, "SplashScreen");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"SplashScreen", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WindowType->tp_dict,"SplashScreen", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WindowType,(long) Qt::Desktop, "Desktop");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Desktop", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WindowType->tp_dict,"Desktop", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WindowType,(long) Qt::SubWindow, "SubWindow");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"SubWindow", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WindowType->tp_dict,"SubWindow", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WindowType,(long) Qt::WindowType_Mask, "WindowType_Mask");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WindowType_Mask", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WindowType->tp_dict,"WindowType_Mask", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WindowType,(long) Qt::MSWindowsFixedSizeDialogHint, "MSWindowsFixedSizeDialogHint");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"MSWindowsFixedSizeDialogHint", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WindowType->tp_dict,"MSWindowsFixedSizeDialogHint", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WindowType,(long) Qt::MSWindowsOwnDC, "MSWindowsOwnDC");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"MSWindowsOwnDC", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WindowType->tp_dict,"MSWindowsOwnDC", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WindowType,(long) Qt::X11BypassWindowManagerHint, "X11BypassWindowManagerHint");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"X11BypassWindowManagerHint", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WindowType->tp_dict,"X11BypassWindowManagerHint", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WindowType,(long) Qt::FramelessWindowHint, "FramelessWindowHint");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"FramelessWindowHint", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WindowType->tp_dict,"FramelessWindowHint", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WindowType,(long) Qt::WindowTitleHint, "WindowTitleHint");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WindowTitleHint", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WindowType->tp_dict,"WindowTitleHint", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WindowType,(long) Qt::WindowSystemMenuHint, "WindowSystemMenuHint");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WindowSystemMenuHint", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WindowType->tp_dict,"WindowSystemMenuHint", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WindowType,(long) Qt::WindowMinimizeButtonHint, "WindowMinimizeButtonHint");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WindowMinimizeButtonHint", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WindowType->tp_dict,"WindowMinimizeButtonHint", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WindowType,(long) Qt::WindowMaximizeButtonHint, "WindowMaximizeButtonHint");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WindowMaximizeButtonHint", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WindowType->tp_dict,"WindowMaximizeButtonHint", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WindowType,(long) Qt::WindowMinMaxButtonsHint, "WindowMinMaxButtonsHint");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WindowMinMaxButtonsHint", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WindowType->tp_dict,"WindowMinMaxButtonsHint", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WindowType,(long) Qt::WindowContextHelpButtonHint, "WindowContextHelpButtonHint");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WindowContextHelpButtonHint", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WindowType->tp_dict,"WindowContextHelpButtonHint", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WindowType,(long) Qt::WindowShadeButtonHint, "WindowShadeButtonHint");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WindowShadeButtonHint", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WindowType->tp_dict,"WindowShadeButtonHint", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WindowType,(long) Qt::WindowStaysOnTopHint, "WindowStaysOnTopHint");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WindowStaysOnTopHint", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WindowType->tp_dict,"WindowStaysOnTopHint", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WindowType,(long) Qt::CustomizeWindowHint, "CustomizeWindowHint");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"CustomizeWindowHint", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WindowType->tp_dict,"CustomizeWindowHint", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WindowType,(long) Qt::WindowStaysOnBottomHint, "WindowStaysOnBottomHint");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WindowStaysOnBottomHint", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WindowType->tp_dict,"WindowStaysOnBottomHint", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WindowType,(long) Qt::WindowCloseButtonHint, "WindowCloseButtonHint");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WindowCloseButtonHint", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WindowType->tp_dict,"WindowCloseButtonHint", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WindowType,(long) Qt::MacWindowToolBarButtonHint, "MacWindowToolBarButtonHint");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"MacWindowToolBarButtonHint", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WindowType->tp_dict,"MacWindowToolBarButtonHint", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WindowType,(long) Qt::BypassGraphicsProxyWidget, "BypassGraphicsProxyWidget");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"BypassGraphicsProxyWidget", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WindowType->tp_dict,"BypassGraphicsProxyWidget", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WindowType,(long) Qt::WindowOkButtonHint, "WindowOkButtonHint");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WindowOkButtonHint", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WindowType->tp_dict,"WindowOkButtonHint", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WindowType,(long) Qt::WindowCancelButtonHint, "WindowCancelButtonHint");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WindowCancelButtonHint", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WindowType->tp_dict,"WindowCancelButtonHint", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WindowType,(long) Qt::WindowSoftkeysVisibleHint, "WindowSoftkeysVisibleHint");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WindowSoftkeysVisibleHint", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WindowType->tp_dict,"WindowSoftkeysVisibleHint", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WindowType,(long) Qt::WindowSoftkeysRespondHint, "WindowSoftkeysRespondHint");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WindowSoftkeysRespondHint", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WindowType->tp_dict,"WindowSoftkeysRespondHint", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("Qt::WindowType");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::WindowType");
    // end of enum WindowType

    // init enum: DateFormat
    PyTypeObject* SbkPySide_QtCore_Qt_DateFormat = Shiboken::Enum::newType("DateFormat");
    SbkPySide_QtCoreTypes[SBK_QT_DATEFORMAT_IDX] = SbkPySide_QtCore_Qt_DateFormat;
    if (PyType_Ready(SbkPySide_QtCore_Qt_DateFormat) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "DateFormat",((PyObject*)SbkPySide_QtCore_Qt_DateFormat));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_DateFormat,(long) Qt::TextDate, "TextDate");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"TextDate", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_DateFormat->tp_dict,"TextDate", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_DateFormat,(long) Qt::ISODate, "ISODate");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"ISODate", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_DateFormat->tp_dict,"ISODate", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_DateFormat,(long) Qt::SystemLocaleDate, "SystemLocaleDate");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"SystemLocaleDate", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_DateFormat->tp_dict,"SystemLocaleDate", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_DateFormat,(long) Qt::LocalDate, "LocalDate");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"LocalDate", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_DateFormat->tp_dict,"LocalDate", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_DateFormat,(long) Qt::LocaleDate, "LocaleDate");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"LocaleDate", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_DateFormat->tp_dict,"LocaleDate", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_DateFormat,(long) Qt::SystemLocaleShortDate, "SystemLocaleShortDate");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"SystemLocaleShortDate", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_DateFormat->tp_dict,"SystemLocaleShortDate", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_DateFormat,(long) Qt::SystemLocaleLongDate, "SystemLocaleLongDate");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"SystemLocaleLongDate", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_DateFormat->tp_dict,"SystemLocaleLongDate", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_DateFormat,(long) Qt::DefaultLocaleShortDate, "DefaultLocaleShortDate");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"DefaultLocaleShortDate", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_DateFormat->tp_dict,"DefaultLocaleShortDate", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_DateFormat,(long) Qt::DefaultLocaleLongDate, "DefaultLocaleLongDate");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"DefaultLocaleLongDate", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_DateFormat->tp_dict,"DefaultLocaleLongDate", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("Qt::DateFormat");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::DateFormat");
    // end of enum DateFormat

    // init enum: TextFormat
    PyTypeObject* SbkPySide_QtCore_Qt_TextFormat = Shiboken::Enum::newType("TextFormat");
    SbkPySide_QtCoreTypes[SBK_QT_TEXTFORMAT_IDX] = SbkPySide_QtCore_Qt_TextFormat;
    if (PyType_Ready(SbkPySide_QtCore_Qt_TextFormat) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "TextFormat",((PyObject*)SbkPySide_QtCore_Qt_TextFormat));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_TextFormat,(long) Qt::PlainText, "PlainText");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"PlainText", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_TextFormat->tp_dict,"PlainText", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_TextFormat,(long) Qt::RichText, "RichText");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"RichText", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_TextFormat->tp_dict,"RichText", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_TextFormat,(long) Qt::AutoText, "AutoText");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"AutoText", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_TextFormat->tp_dict,"AutoText", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_TextFormat,(long) Qt::LogText, "LogText");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"LogText", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_TextFormat->tp_dict,"LogText", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("Qt::TextFormat");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::TextFormat");
    // end of enum TextFormat

    // init enum: PenJoinStyle
    PyTypeObject* SbkPySide_QtCore_Qt_PenJoinStyle = Shiboken::Enum::newType("PenJoinStyle");
    SbkPySide_QtCoreTypes[SBK_QT_PENJOINSTYLE_IDX] = SbkPySide_QtCore_Qt_PenJoinStyle;
    if (PyType_Ready(SbkPySide_QtCore_Qt_PenJoinStyle) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "PenJoinStyle",((PyObject*)SbkPySide_QtCore_Qt_PenJoinStyle));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_PenJoinStyle,(long) Qt::MiterJoin, "MiterJoin");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"MiterJoin", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_PenJoinStyle->tp_dict,"MiterJoin", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_PenJoinStyle,(long) Qt::BevelJoin, "BevelJoin");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"BevelJoin", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_PenJoinStyle->tp_dict,"BevelJoin", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_PenJoinStyle,(long) Qt::RoundJoin, "RoundJoin");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"RoundJoin", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_PenJoinStyle->tp_dict,"RoundJoin", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_PenJoinStyle,(long) Qt::SvgMiterJoin, "SvgMiterJoin");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"SvgMiterJoin", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_PenJoinStyle->tp_dict,"SvgMiterJoin", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_PenJoinStyle,(long) Qt::MPenJoinStyle, "MPenJoinStyle");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"MPenJoinStyle", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_PenJoinStyle->tp_dict,"MPenJoinStyle", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("Qt::PenJoinStyle");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::PenJoinStyle");
    // end of enum PenJoinStyle

    // init enum: GestureFlag
    PyTypeObject* SbkPySide_QtCore_Qt_GestureFlag = Shiboken::Enum::newType("GestureFlag");
    SbkPySide_QtCore_Qt_GestureFlag->tp_as_number = &SbkPySide_QtCore_Qt_GestureFlag_as_number;
    SbkPySide_QtCoreTypes[SBK_QT_GESTUREFLAG_IDX] = SbkPySide_QtCore_Qt_GestureFlag;
    if (PyType_Ready(SbkPySide_QtCore_Qt_GestureFlag) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "GestureFlag",((PyObject*)SbkPySide_QtCore_Qt_GestureFlag));

    // init flags class: QFlags<Qt::GestureFlag>
    SbkPySide_QtCoreTypes[SBK_QFLAGS_QT_GESTUREFLAG__IDX] = &SbkPySide_QtCore_Qt_GestureFlags_Type;
    if (PyType_Ready((PyTypeObject*)&SbkPySide_QtCore_Qt_GestureFlags_Type) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "GestureFlags",((PyObject*)&SbkPySide_QtCore_Qt_GestureFlags_Type));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_GestureFlag,(long) Qt::DontStartGestureOnChildren, "DontStartGestureOnChildren");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"DontStartGestureOnChildren", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_GestureFlag->tp_dict,"DontStartGestureOnChildren", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_GestureFlag,(long) Qt::ReceivePartialGestures, "ReceivePartialGestures");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"ReceivePartialGestures", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_GestureFlag->tp_dict,"ReceivePartialGestures", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_GestureFlag,(long) Qt::IgnoredGesturesPropagateToParent, "IgnoredGesturesPropagateToParent");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"IgnoredGesturesPropagateToParent", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_GestureFlag->tp_dict,"IgnoredGesturesPropagateToParent", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("Qt::GestureFlag");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::GestureFlag");
    // end of enum GestureFlag

    // init enum: CaseSensitivity
    PyTypeObject* SbkPySide_QtCore_Qt_CaseSensitivity = Shiboken::Enum::newType("CaseSensitivity");
    SbkPySide_QtCoreTypes[SBK_QT_CASESENSITIVITY_IDX] = SbkPySide_QtCore_Qt_CaseSensitivity;
    if (PyType_Ready(SbkPySide_QtCore_Qt_CaseSensitivity) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "CaseSensitivity",((PyObject*)SbkPySide_QtCore_Qt_CaseSensitivity));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_CaseSensitivity,(long) Qt::CaseInsensitive, "CaseInsensitive");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"CaseInsensitive", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_CaseSensitivity->tp_dict,"CaseInsensitive", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_CaseSensitivity,(long) Qt::CaseSensitive, "CaseSensitive");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"CaseSensitive", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_CaseSensitivity->tp_dict,"CaseSensitive", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("Qt::CaseSensitivity");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::CaseSensitivity");
    // end of enum CaseSensitivity

    // init enum: EventPriority
    PyTypeObject* SbkPySide_QtCore_Qt_EventPriority = Shiboken::Enum::newType("EventPriority");
    SbkPySide_QtCoreTypes[SBK_QT_EVENTPRIORITY_IDX] = SbkPySide_QtCore_Qt_EventPriority;
    if (PyType_Ready(SbkPySide_QtCore_Qt_EventPriority) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "EventPriority",((PyObject*)SbkPySide_QtCore_Qt_EventPriority));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_EventPriority,(long) Qt::HighEventPriority, "HighEventPriority");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"HighEventPriority", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_EventPriority->tp_dict,"HighEventPriority", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_EventPriority,(long) Qt::NormalEventPriority, "NormalEventPriority");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"NormalEventPriority", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_EventPriority->tp_dict,"NormalEventPriority", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_EventPriority,(long) Qt::LowEventPriority, "LowEventPriority");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"LowEventPriority", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_EventPriority->tp_dict,"LowEventPriority", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("Qt::EventPriority");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::EventPriority");
    // end of enum EventPriority

    // init enum: ImageConversionFlag
    PyTypeObject* SbkPySide_QtCore_Qt_ImageConversionFlag = Shiboken::Enum::newType("ImageConversionFlag");
    SbkPySide_QtCore_Qt_ImageConversionFlag->tp_as_number = &SbkPySide_QtCore_Qt_ImageConversionFlag_as_number;
    SbkPySide_QtCoreTypes[SBK_QT_IMAGECONVERSIONFLAG_IDX] = SbkPySide_QtCore_Qt_ImageConversionFlag;
    if (PyType_Ready(SbkPySide_QtCore_Qt_ImageConversionFlag) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "ImageConversionFlag",((PyObject*)SbkPySide_QtCore_Qt_ImageConversionFlag));

    // init flags class: QFlags<Qt::ImageConversionFlag>
    SbkPySide_QtCoreTypes[SBK_QFLAGS_QT_IMAGECONVERSIONFLAG__IDX] = &SbkPySide_QtCore_Qt_ImageConversionFlags_Type;
    if (PyType_Ready((PyTypeObject*)&SbkPySide_QtCore_Qt_ImageConversionFlags_Type) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "ImageConversionFlags",((PyObject*)&SbkPySide_QtCore_Qt_ImageConversionFlags_Type));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ImageConversionFlag,(long) Qt::ColorMode_Mask, "ColorMode_Mask");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"ColorMode_Mask", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ImageConversionFlag->tp_dict,"ColorMode_Mask", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ImageConversionFlag,(long) Qt::AutoColor, "AutoColor");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"AutoColor", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ImageConversionFlag->tp_dict,"AutoColor", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ImageConversionFlag,(long) Qt::ColorOnly, "ColorOnly");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"ColorOnly", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ImageConversionFlag->tp_dict,"ColorOnly", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ImageConversionFlag,(long) Qt::MonoOnly, "MonoOnly");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"MonoOnly", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ImageConversionFlag->tp_dict,"MonoOnly", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ImageConversionFlag,(long) Qt::AlphaDither_Mask, "AlphaDither_Mask");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"AlphaDither_Mask", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ImageConversionFlag->tp_dict,"AlphaDither_Mask", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ImageConversionFlag,(long) Qt::ThresholdAlphaDither, "ThresholdAlphaDither");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"ThresholdAlphaDither", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ImageConversionFlag->tp_dict,"ThresholdAlphaDither", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ImageConversionFlag,(long) Qt::OrderedAlphaDither, "OrderedAlphaDither");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"OrderedAlphaDither", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ImageConversionFlag->tp_dict,"OrderedAlphaDither", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ImageConversionFlag,(long) Qt::DiffuseAlphaDither, "DiffuseAlphaDither");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"DiffuseAlphaDither", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ImageConversionFlag->tp_dict,"DiffuseAlphaDither", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ImageConversionFlag,(long) Qt::NoAlpha, "NoAlpha");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"NoAlpha", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ImageConversionFlag->tp_dict,"NoAlpha", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ImageConversionFlag,(long) Qt::Dither_Mask, "Dither_Mask");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Dither_Mask", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ImageConversionFlag->tp_dict,"Dither_Mask", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ImageConversionFlag,(long) Qt::DiffuseDither, "DiffuseDither");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"DiffuseDither", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ImageConversionFlag->tp_dict,"DiffuseDither", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ImageConversionFlag,(long) Qt::OrderedDither, "OrderedDither");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"OrderedDither", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ImageConversionFlag->tp_dict,"OrderedDither", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ImageConversionFlag,(long) Qt::ThresholdDither, "ThresholdDither");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"ThresholdDither", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ImageConversionFlag->tp_dict,"ThresholdDither", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ImageConversionFlag,(long) Qt::DitherMode_Mask, "DitherMode_Mask");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"DitherMode_Mask", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ImageConversionFlag->tp_dict,"DitherMode_Mask", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ImageConversionFlag,(long) Qt::AutoDither, "AutoDither");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"AutoDither", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ImageConversionFlag->tp_dict,"AutoDither", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ImageConversionFlag,(long) Qt::PreferDither, "PreferDither");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"PreferDither", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ImageConversionFlag->tp_dict,"PreferDither", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ImageConversionFlag,(long) Qt::AvoidDither, "AvoidDither");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"AvoidDither", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ImageConversionFlag->tp_dict,"AvoidDither", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ImageConversionFlag,(long) Qt::NoOpaqueDetection, "NoOpaqueDetection");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"NoOpaqueDetection", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ImageConversionFlag->tp_dict,"NoOpaqueDetection", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("Qt::ImageConversionFlag");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::ImageConversionFlag");
    // end of enum ImageConversionFlag

    // init enum: GestureState
    PyTypeObject* SbkPySide_QtCore_Qt_GestureState = Shiboken::Enum::newType("GestureState");
    SbkPySide_QtCoreTypes[SBK_QT_GESTURESTATE_IDX] = SbkPySide_QtCore_Qt_GestureState;
    if (PyType_Ready(SbkPySide_QtCore_Qt_GestureState) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "GestureState",((PyObject*)SbkPySide_QtCore_Qt_GestureState));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_GestureState,(long) Qt::NoGesture, "NoGesture");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"NoGesture", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_GestureState->tp_dict,"NoGesture", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_GestureState,(long) Qt::GestureStarted, "GestureStarted");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"GestureStarted", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_GestureState->tp_dict,"GestureStarted", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_GestureState,(long) Qt::GestureUpdated, "GestureUpdated");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"GestureUpdated", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_GestureState->tp_dict,"GestureUpdated", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_GestureState,(long) Qt::GestureFinished, "GestureFinished");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"GestureFinished", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_GestureState->tp_dict,"GestureFinished", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_GestureState,(long) Qt::GestureCanceled, "GestureCanceled");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"GestureCanceled", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_GestureState->tp_dict,"GestureCanceled", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("Qt::GestureState");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::GestureState");
    // end of enum GestureState

    // init enum: BGMode
    PyTypeObject* SbkPySide_QtCore_Qt_BGMode = Shiboken::Enum::newType("BGMode");
    SbkPySide_QtCoreTypes[SBK_QT_BGMODE_IDX] = SbkPySide_QtCore_Qt_BGMode;
    if (PyType_Ready(SbkPySide_QtCore_Qt_BGMode) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "BGMode",((PyObject*)SbkPySide_QtCore_Qt_BGMode));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_BGMode,(long) Qt::TransparentMode, "TransparentMode");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"TransparentMode", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_BGMode->tp_dict,"TransparentMode", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_BGMode,(long) Qt::OpaqueMode, "OpaqueMode");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"OpaqueMode", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_BGMode->tp_dict,"OpaqueMode", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("Qt::BGMode");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::BGMode");
    // end of enum BGMode

    // init enum: ConnectionType
    PyTypeObject* SbkPySide_QtCore_Qt_ConnectionType = Shiboken::Enum::newType("ConnectionType");
    SbkPySide_QtCoreTypes[SBK_QT_CONNECTIONTYPE_IDX] = SbkPySide_QtCore_Qt_ConnectionType;
    if (PyType_Ready(SbkPySide_QtCore_Qt_ConnectionType) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "ConnectionType",((PyObject*)SbkPySide_QtCore_Qt_ConnectionType));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ConnectionType,(long) Qt::AutoConnection, "AutoConnection");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"AutoConnection", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ConnectionType->tp_dict,"AutoConnection", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ConnectionType,(long) Qt::DirectConnection, "DirectConnection");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"DirectConnection", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ConnectionType->tp_dict,"DirectConnection", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ConnectionType,(long) Qt::QueuedConnection, "QueuedConnection");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"QueuedConnection", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ConnectionType->tp_dict,"QueuedConnection", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ConnectionType,(long) Qt::AutoCompatConnection, "AutoCompatConnection");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"AutoCompatConnection", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ConnectionType->tp_dict,"AutoCompatConnection", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ConnectionType,(long) Qt::BlockingQueuedConnection, "BlockingQueuedConnection");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"BlockingQueuedConnection", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ConnectionType->tp_dict,"BlockingQueuedConnection", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ConnectionType,(long) Qt::UniqueConnection, "UniqueConnection");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"UniqueConnection", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ConnectionType->tp_dict,"UniqueConnection", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("Qt::ConnectionType");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::ConnectionType");
    // end of enum ConnectionType

    // init enum: ToolBarArea
    PyTypeObject* SbkPySide_QtCore_Qt_ToolBarArea = Shiboken::Enum::newType("ToolBarArea");
    SbkPySide_QtCore_Qt_ToolBarArea->tp_as_number = &SbkPySide_QtCore_Qt_ToolBarArea_as_number;
    SbkPySide_QtCoreTypes[SBK_QT_TOOLBARAREA_IDX] = SbkPySide_QtCore_Qt_ToolBarArea;
    if (PyType_Ready(SbkPySide_QtCore_Qt_ToolBarArea) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "ToolBarArea",((PyObject*)SbkPySide_QtCore_Qt_ToolBarArea));

    // init flags class: QFlags<Qt::ToolBarArea>
    SbkPySide_QtCoreTypes[SBK_QFLAGS_QT_TOOLBARAREA__IDX] = &SbkPySide_QtCore_Qt_ToolBarAreas_Type;
    if (PyType_Ready((PyTypeObject*)&SbkPySide_QtCore_Qt_ToolBarAreas_Type) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "ToolBarAreas",((PyObject*)&SbkPySide_QtCore_Qt_ToolBarAreas_Type));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ToolBarArea,(long) Qt::LeftToolBarArea, "LeftToolBarArea");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"LeftToolBarArea", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ToolBarArea->tp_dict,"LeftToolBarArea", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ToolBarArea,(long) Qt::RightToolBarArea, "RightToolBarArea");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"RightToolBarArea", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ToolBarArea->tp_dict,"RightToolBarArea", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ToolBarArea,(long) Qt::TopToolBarArea, "TopToolBarArea");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"TopToolBarArea", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ToolBarArea->tp_dict,"TopToolBarArea", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ToolBarArea,(long) Qt::BottomToolBarArea, "BottomToolBarArea");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"BottomToolBarArea", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ToolBarArea->tp_dict,"BottomToolBarArea", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ToolBarArea,(long) Qt::ToolBarArea_Mask, "ToolBarArea_Mask");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"ToolBarArea_Mask", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ToolBarArea->tp_dict,"ToolBarArea_Mask", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ToolBarArea,(long) Qt::AllToolBarAreas, "AllToolBarAreas");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"AllToolBarAreas", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ToolBarArea->tp_dict,"AllToolBarAreas", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ToolBarArea,(long) Qt::NoToolBarArea, "NoToolBarArea");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"NoToolBarArea", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ToolBarArea->tp_dict,"NoToolBarArea", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("Qt::ToolBarArea");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::ToolBarArea");
    // end of enum ToolBarArea

    // init enum: CoordinateSystem
    PyTypeObject* SbkPySide_QtCore_Qt_CoordinateSystem = Shiboken::Enum::newType("CoordinateSystem");
    SbkPySide_QtCoreTypes[SBK_QT_COORDINATESYSTEM_IDX] = SbkPySide_QtCore_Qt_CoordinateSystem;
    if (PyType_Ready(SbkPySide_QtCore_Qt_CoordinateSystem) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "CoordinateSystem",((PyObject*)SbkPySide_QtCore_Qt_CoordinateSystem));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_CoordinateSystem,(long) Qt::DeviceCoordinates, "DeviceCoordinates");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"DeviceCoordinates", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_CoordinateSystem->tp_dict,"DeviceCoordinates", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_CoordinateSystem,(long) Qt::LogicalCoordinates, "LogicalCoordinates");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"LogicalCoordinates", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_CoordinateSystem->tp_dict,"LogicalCoordinates", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("Qt::CoordinateSystem");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::CoordinateSystem");
    // end of enum CoordinateSystem

    // init enum: SizeMode
    PyTypeObject* SbkPySide_QtCore_Qt_SizeMode = Shiboken::Enum::newType("SizeMode");
    SbkPySide_QtCoreTypes[SBK_QT_SIZEMODE_IDX] = SbkPySide_QtCore_Qt_SizeMode;
    if (PyType_Ready(SbkPySide_QtCore_Qt_SizeMode) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "SizeMode",((PyObject*)SbkPySide_QtCore_Qt_SizeMode));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_SizeMode,(long) Qt::AbsoluteSize, "AbsoluteSize");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"AbsoluteSize", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_SizeMode->tp_dict,"AbsoluteSize", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_SizeMode,(long) Qt::RelativeSize, "RelativeSize");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"RelativeSize", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_SizeMode->tp_dict,"RelativeSize", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("Qt::SizeMode");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::SizeMode");
    // end of enum SizeMode

    // init enum: FocusReason
    PyTypeObject* SbkPySide_QtCore_Qt_FocusReason = Shiboken::Enum::newType("FocusReason");
    SbkPySide_QtCoreTypes[SBK_QT_FOCUSREASON_IDX] = SbkPySide_QtCore_Qt_FocusReason;
    if (PyType_Ready(SbkPySide_QtCore_Qt_FocusReason) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "FocusReason",((PyObject*)SbkPySide_QtCore_Qt_FocusReason));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_FocusReason,(long) Qt::MouseFocusReason, "MouseFocusReason");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"MouseFocusReason", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_FocusReason->tp_dict,"MouseFocusReason", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_FocusReason,(long) Qt::TabFocusReason, "TabFocusReason");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"TabFocusReason", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_FocusReason->tp_dict,"TabFocusReason", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_FocusReason,(long) Qt::BacktabFocusReason, "BacktabFocusReason");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"BacktabFocusReason", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_FocusReason->tp_dict,"BacktabFocusReason", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_FocusReason,(long) Qt::ActiveWindowFocusReason, "ActiveWindowFocusReason");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"ActiveWindowFocusReason", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_FocusReason->tp_dict,"ActiveWindowFocusReason", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_FocusReason,(long) Qt::PopupFocusReason, "PopupFocusReason");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"PopupFocusReason", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_FocusReason->tp_dict,"PopupFocusReason", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_FocusReason,(long) Qt::ShortcutFocusReason, "ShortcutFocusReason");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"ShortcutFocusReason", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_FocusReason->tp_dict,"ShortcutFocusReason", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_FocusReason,(long) Qt::MenuBarFocusReason, "MenuBarFocusReason");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"MenuBarFocusReason", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_FocusReason->tp_dict,"MenuBarFocusReason", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_FocusReason,(long) Qt::OtherFocusReason, "OtherFocusReason");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"OtherFocusReason", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_FocusReason->tp_dict,"OtherFocusReason", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_FocusReason,(long) Qt::NoFocusReason, "NoFocusReason");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"NoFocusReason", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_FocusReason->tp_dict,"NoFocusReason", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("Qt::FocusReason");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::FocusReason");
    // end of enum FocusReason

    // init enum: Modifier
    PyTypeObject* SbkPySide_QtCore_Qt_Modifier = Shiboken::Enum::newType("Modifier");
    SbkPySide_QtCoreTypes[SBK_QT_MODIFIER_IDX] = SbkPySide_QtCore_Qt_Modifier;
    if (PyType_Ready(SbkPySide_QtCore_Qt_Modifier) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "Modifier",((PyObject*)SbkPySide_QtCore_Qt_Modifier));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Modifier,(long) Qt::META, "META");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"META", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Modifier->tp_dict,"META", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Modifier,(long) Qt::SHIFT, "SHIFT");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"SHIFT", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Modifier->tp_dict,"SHIFT", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Modifier,(long) Qt::CTRL, "CTRL");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"CTRL", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Modifier->tp_dict,"CTRL", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Modifier,(long) Qt::ALT, "ALT");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"ALT", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Modifier->tp_dict,"ALT", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Modifier,(long) Qt::MODIFIER_MASK, "MODIFIER_MASK");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"MODIFIER_MASK", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Modifier->tp_dict,"MODIFIER_MASK", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Modifier,(long) Qt::UNICODE_ACCEL, "UNICODE_ACCEL");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"UNICODE_ACCEL", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Modifier->tp_dict,"UNICODE_ACCEL", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("Qt::Modifier");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::Modifier");
    // end of enum Modifier

    // init enum: TileRule
    PyTypeObject* SbkPySide_QtCore_Qt_TileRule = Shiboken::Enum::newType("TileRule");
    SbkPySide_QtCoreTypes[SBK_QT_TILERULE_IDX] = SbkPySide_QtCore_Qt_TileRule;
    if (PyType_Ready(SbkPySide_QtCore_Qt_TileRule) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "TileRule",((PyObject*)SbkPySide_QtCore_Qt_TileRule));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_TileRule,(long) Qt::StretchTile, "StretchTile");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"StretchTile", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_TileRule->tp_dict,"StretchTile", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_TileRule,(long) Qt::RepeatTile, "RepeatTile");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"RepeatTile", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_TileRule->tp_dict,"RepeatTile", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_TileRule,(long) Qt::RoundTile, "RoundTile");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"RoundTile", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_TileRule->tp_dict,"RoundTile", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("Qt::TileRule");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::TileRule");
    // end of enum TileRule

    // init enum: WhiteSpaceMode
    PyTypeObject* SbkPySide_QtCore_Qt_WhiteSpaceMode = Shiboken::Enum::newType("WhiteSpaceMode");
    SbkPySide_QtCoreTypes[SBK_QT_WHITESPACEMODE_IDX] = SbkPySide_QtCore_Qt_WhiteSpaceMode;
    if (PyType_Ready(SbkPySide_QtCore_Qt_WhiteSpaceMode) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "WhiteSpaceMode",((PyObject*)SbkPySide_QtCore_Qt_WhiteSpaceMode));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WhiteSpaceMode,(long) Qt::WhiteSpaceNormal, "WhiteSpaceNormal");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WhiteSpaceNormal", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WhiteSpaceMode->tp_dict,"WhiteSpaceNormal", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WhiteSpaceMode,(long) Qt::WhiteSpacePre, "WhiteSpacePre");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WhiteSpacePre", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WhiteSpaceMode->tp_dict,"WhiteSpacePre", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WhiteSpaceMode,(long) Qt::WhiteSpaceNoWrap, "WhiteSpaceNoWrap");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WhiteSpaceNoWrap", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WhiteSpaceMode->tp_dict,"WhiteSpaceNoWrap", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WhiteSpaceMode,(long) Qt::WhiteSpaceModeUndefined, "WhiteSpaceModeUndefined");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WhiteSpaceModeUndefined", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WhiteSpaceMode->tp_dict,"WhiteSpaceModeUndefined", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("Qt::WhiteSpaceMode");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::WhiteSpaceMode");
    // end of enum WhiteSpaceMode

    // init enum: AspectRatioMode
    PyTypeObject* SbkPySide_QtCore_Qt_AspectRatioMode = Shiboken::Enum::newType("AspectRatioMode");
    SbkPySide_QtCoreTypes[SBK_QT_ASPECTRATIOMODE_IDX] = SbkPySide_QtCore_Qt_AspectRatioMode;
    if (PyType_Ready(SbkPySide_QtCore_Qt_AspectRatioMode) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "AspectRatioMode",((PyObject*)SbkPySide_QtCore_Qt_AspectRatioMode));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_AspectRatioMode,(long) Qt::IgnoreAspectRatio, "IgnoreAspectRatio");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"IgnoreAspectRatio", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_AspectRatioMode->tp_dict,"IgnoreAspectRatio", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_AspectRatioMode,(long) Qt::KeepAspectRatio, "KeepAspectRatio");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"KeepAspectRatio", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_AspectRatioMode->tp_dict,"KeepAspectRatio", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_AspectRatioMode,(long) Qt::KeepAspectRatioByExpanding, "KeepAspectRatioByExpanding");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"KeepAspectRatioByExpanding", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_AspectRatioMode->tp_dict,"KeepAspectRatioByExpanding", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("Qt::AspectRatioMode");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::AspectRatioMode");
    // end of enum AspectRatioMode

    // init enum: SizeHint
    PyTypeObject* SbkPySide_QtCore_Qt_SizeHint = Shiboken::Enum::newType("SizeHint");
    SbkPySide_QtCoreTypes[SBK_QT_SIZEHINT_IDX] = SbkPySide_QtCore_Qt_SizeHint;
    if (PyType_Ready(SbkPySide_QtCore_Qt_SizeHint) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "SizeHint",((PyObject*)SbkPySide_QtCore_Qt_SizeHint));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_SizeHint,(long) Qt::MinimumSize, "MinimumSize");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"MinimumSize", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_SizeHint->tp_dict,"MinimumSize", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_SizeHint,(long) Qt::PreferredSize, "PreferredSize");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"PreferredSize", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_SizeHint->tp_dict,"PreferredSize", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_SizeHint,(long) Qt::MaximumSize, "MaximumSize");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"MaximumSize", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_SizeHint->tp_dict,"MaximumSize", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_SizeHint,(long) Qt::MinimumDescent, "MinimumDescent");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"MinimumDescent", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_SizeHint->tp_dict,"MinimumDescent", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_SizeHint,(long) Qt::NSizeHints, "NSizeHints");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"NSizeHints", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_SizeHint->tp_dict,"NSizeHints", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("Qt::SizeHint");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::SizeHint");
    // end of enum SizeHint

    // init enum: AlignmentFlag
    PyTypeObject* SbkPySide_QtCore_Qt_AlignmentFlag = Shiboken::Enum::newType("AlignmentFlag");
    SbkPySide_QtCore_Qt_AlignmentFlag->tp_as_number = &SbkPySide_QtCore_Qt_AlignmentFlag_as_number;
    SbkPySide_QtCoreTypes[SBK_QT_ALIGNMENTFLAG_IDX] = SbkPySide_QtCore_Qt_AlignmentFlag;
    if (PyType_Ready(SbkPySide_QtCore_Qt_AlignmentFlag) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "AlignmentFlag",((PyObject*)SbkPySide_QtCore_Qt_AlignmentFlag));

    // init flags class: QFlags<Qt::AlignmentFlag>
    SbkPySide_QtCoreTypes[SBK_QFLAGS_QT_ALIGNMENTFLAG__IDX] = &SbkPySide_QtCore_Qt_Alignment_Type;
    if (PyType_Ready((PyTypeObject*)&SbkPySide_QtCore_Qt_Alignment_Type) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "Alignment",((PyObject*)&SbkPySide_QtCore_Qt_Alignment_Type));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_AlignmentFlag,(long) Qt::AlignLeft, "AlignLeft");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"AlignLeft", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_AlignmentFlag->tp_dict,"AlignLeft", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_AlignmentFlag,(long) Qt::AlignLeading, "AlignLeading");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"AlignLeading", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_AlignmentFlag->tp_dict,"AlignLeading", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_AlignmentFlag,(long) Qt::AlignRight, "AlignRight");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"AlignRight", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_AlignmentFlag->tp_dict,"AlignRight", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_AlignmentFlag,(long) Qt::AlignTrailing, "AlignTrailing");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"AlignTrailing", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_AlignmentFlag->tp_dict,"AlignTrailing", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_AlignmentFlag,(long) Qt::AlignHCenter, "AlignHCenter");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"AlignHCenter", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_AlignmentFlag->tp_dict,"AlignHCenter", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_AlignmentFlag,(long) Qt::AlignJustify, "AlignJustify");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"AlignJustify", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_AlignmentFlag->tp_dict,"AlignJustify", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_AlignmentFlag,(long) Qt::AlignAbsolute, "AlignAbsolute");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"AlignAbsolute", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_AlignmentFlag->tp_dict,"AlignAbsolute", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_AlignmentFlag,(long) Qt::AlignHorizontal_Mask, "AlignHorizontal_Mask");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"AlignHorizontal_Mask", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_AlignmentFlag->tp_dict,"AlignHorizontal_Mask", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_AlignmentFlag,(long) Qt::AlignTop, "AlignTop");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"AlignTop", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_AlignmentFlag->tp_dict,"AlignTop", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_AlignmentFlag,(long) Qt::AlignBottom, "AlignBottom");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"AlignBottom", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_AlignmentFlag->tp_dict,"AlignBottom", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_AlignmentFlag,(long) Qt::AlignVCenter, "AlignVCenter");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"AlignVCenter", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_AlignmentFlag->tp_dict,"AlignVCenter", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_AlignmentFlag,(long) Qt::AlignVertical_Mask, "AlignVertical_Mask");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"AlignVertical_Mask", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_AlignmentFlag->tp_dict,"AlignVertical_Mask", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_AlignmentFlag,(long) Qt::AlignCenter, "AlignCenter");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"AlignCenter", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_AlignmentFlag->tp_dict,"AlignCenter", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("Qt::AlignmentFlag");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::AlignmentFlag");
    // end of enum AlignmentFlag

    // init enum: ContextMenuPolicy
    PyTypeObject* SbkPySide_QtCore_Qt_ContextMenuPolicy = Shiboken::Enum::newType("ContextMenuPolicy");
    SbkPySide_QtCoreTypes[SBK_QT_CONTEXTMENUPOLICY_IDX] = SbkPySide_QtCore_Qt_ContextMenuPolicy;
    if (PyType_Ready(SbkPySide_QtCore_Qt_ContextMenuPolicy) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "ContextMenuPolicy",((PyObject*)SbkPySide_QtCore_Qt_ContextMenuPolicy));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ContextMenuPolicy,(long) Qt::NoContextMenu, "NoContextMenu");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"NoContextMenu", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ContextMenuPolicy->tp_dict,"NoContextMenu", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ContextMenuPolicy,(long) Qt::DefaultContextMenu, "DefaultContextMenu");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"DefaultContextMenu", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ContextMenuPolicy->tp_dict,"DefaultContextMenu", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ContextMenuPolicy,(long) Qt::ActionsContextMenu, "ActionsContextMenu");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"ActionsContextMenu", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ContextMenuPolicy->tp_dict,"ActionsContextMenu", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ContextMenuPolicy,(long) Qt::CustomContextMenu, "CustomContextMenu");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"CustomContextMenu", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ContextMenuPolicy->tp_dict,"CustomContextMenu", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ContextMenuPolicy,(long) Qt::PreventContextMenu, "PreventContextMenu");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"PreventContextMenu", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ContextMenuPolicy->tp_dict,"PreventContextMenu", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("Qt::ContextMenuPolicy");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::ContextMenuPolicy");
    // end of enum ContextMenuPolicy

    // init enum: DockWidgetArea
    PyTypeObject* SbkPySide_QtCore_Qt_DockWidgetArea = Shiboken::Enum::newType("DockWidgetArea");
    SbkPySide_QtCore_Qt_DockWidgetArea->tp_as_number = &SbkPySide_QtCore_Qt_DockWidgetArea_as_number;
    SbkPySide_QtCoreTypes[SBK_QT_DOCKWIDGETAREA_IDX] = SbkPySide_QtCore_Qt_DockWidgetArea;
    if (PyType_Ready(SbkPySide_QtCore_Qt_DockWidgetArea) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "DockWidgetArea",((PyObject*)SbkPySide_QtCore_Qt_DockWidgetArea));

    // init flags class: QFlags<Qt::DockWidgetArea>
    SbkPySide_QtCoreTypes[SBK_QFLAGS_QT_DOCKWIDGETAREA__IDX] = &SbkPySide_QtCore_Qt_DockWidgetAreas_Type;
    if (PyType_Ready((PyTypeObject*)&SbkPySide_QtCore_Qt_DockWidgetAreas_Type) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "DockWidgetAreas",((PyObject*)&SbkPySide_QtCore_Qt_DockWidgetAreas_Type));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_DockWidgetArea,(long) Qt::LeftDockWidgetArea, "LeftDockWidgetArea");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"LeftDockWidgetArea", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_DockWidgetArea->tp_dict,"LeftDockWidgetArea", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_DockWidgetArea,(long) Qt::RightDockWidgetArea, "RightDockWidgetArea");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"RightDockWidgetArea", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_DockWidgetArea->tp_dict,"RightDockWidgetArea", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_DockWidgetArea,(long) Qt::TopDockWidgetArea, "TopDockWidgetArea");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"TopDockWidgetArea", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_DockWidgetArea->tp_dict,"TopDockWidgetArea", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_DockWidgetArea,(long) Qt::BottomDockWidgetArea, "BottomDockWidgetArea");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"BottomDockWidgetArea", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_DockWidgetArea->tp_dict,"BottomDockWidgetArea", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_DockWidgetArea,(long) Qt::DockWidgetArea_Mask, "DockWidgetArea_Mask");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"DockWidgetArea_Mask", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_DockWidgetArea->tp_dict,"DockWidgetArea_Mask", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_DockWidgetArea,(long) Qt::AllDockWidgetAreas, "AllDockWidgetAreas");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"AllDockWidgetAreas", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_DockWidgetArea->tp_dict,"AllDockWidgetAreas", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_DockWidgetArea,(long) Qt::NoDockWidgetArea, "NoDockWidgetArea");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"NoDockWidgetArea", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_DockWidgetArea->tp_dict,"NoDockWidgetArea", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("Qt::DockWidgetArea");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::DockWidgetArea");
    // end of enum DockWidgetArea

    // init enum: UIEffect
    PyTypeObject* SbkPySide_QtCore_Qt_UIEffect = Shiboken::Enum::newType("UIEffect");
    SbkPySide_QtCoreTypes[SBK_QT_UIEFFECT_IDX] = SbkPySide_QtCore_Qt_UIEffect;
    if (PyType_Ready(SbkPySide_QtCore_Qt_UIEffect) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "UIEffect",((PyObject*)SbkPySide_QtCore_Qt_UIEffect));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_UIEffect,(long) Qt::UI_General, "UI_General");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"UI_General", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_UIEffect->tp_dict,"UI_General", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_UIEffect,(long) Qt::UI_AnimateMenu, "UI_AnimateMenu");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"UI_AnimateMenu", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_UIEffect->tp_dict,"UI_AnimateMenu", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_UIEffect,(long) Qt::UI_FadeMenu, "UI_FadeMenu");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"UI_FadeMenu", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_UIEffect->tp_dict,"UI_FadeMenu", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_UIEffect,(long) Qt::UI_AnimateCombo, "UI_AnimateCombo");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"UI_AnimateCombo", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_UIEffect->tp_dict,"UI_AnimateCombo", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_UIEffect,(long) Qt::UI_AnimateTooltip, "UI_AnimateTooltip");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"UI_AnimateTooltip", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_UIEffect->tp_dict,"UI_AnimateTooltip", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_UIEffect,(long) Qt::UI_FadeTooltip, "UI_FadeTooltip");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"UI_FadeTooltip", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_UIEffect->tp_dict,"UI_FadeTooltip", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_UIEffect,(long) Qt::UI_AnimateToolBox, "UI_AnimateToolBox");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"UI_AnimateToolBox", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_UIEffect->tp_dict,"UI_AnimateToolBox", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("Qt::UIEffect");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::UIEffect");
    // end of enum UIEffect

    // init enum: AnchorPoint
    PyTypeObject* SbkPySide_QtCore_Qt_AnchorPoint = Shiboken::Enum::newType("AnchorPoint");
    SbkPySide_QtCoreTypes[SBK_QT_ANCHORPOINT_IDX] = SbkPySide_QtCore_Qt_AnchorPoint;
    if (PyType_Ready(SbkPySide_QtCore_Qt_AnchorPoint) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "AnchorPoint",((PyObject*)SbkPySide_QtCore_Qt_AnchorPoint));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_AnchorPoint,(long) Qt::AnchorLeft, "AnchorLeft");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"AnchorLeft", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_AnchorPoint->tp_dict,"AnchorLeft", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_AnchorPoint,(long) Qt::AnchorHorizontalCenter, "AnchorHorizontalCenter");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"AnchorHorizontalCenter", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_AnchorPoint->tp_dict,"AnchorHorizontalCenter", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_AnchorPoint,(long) Qt::AnchorRight, "AnchorRight");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"AnchorRight", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_AnchorPoint->tp_dict,"AnchorRight", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_AnchorPoint,(long) Qt::AnchorTop, "AnchorTop");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"AnchorTop", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_AnchorPoint->tp_dict,"AnchorTop", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_AnchorPoint,(long) Qt::AnchorVerticalCenter, "AnchorVerticalCenter");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"AnchorVerticalCenter", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_AnchorPoint->tp_dict,"AnchorVerticalCenter", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_AnchorPoint,(long) Qt::AnchorBottom, "AnchorBottom");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"AnchorBottom", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_AnchorPoint->tp_dict,"AnchorBottom", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("Qt::AnchorPoint");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::AnchorPoint");
    // end of enum AnchorPoint

    // init enum: GlobalColor
    PyTypeObject* SbkPySide_QtCore_Qt_GlobalColor = Shiboken::Enum::newType("GlobalColor");
    SbkPySide_QtCoreTypes[SBK_QT_GLOBALCOLOR_IDX] = SbkPySide_QtCore_Qt_GlobalColor;
    if (PyType_Ready(SbkPySide_QtCore_Qt_GlobalColor) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "GlobalColor",((PyObject*)SbkPySide_QtCore_Qt_GlobalColor));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_GlobalColor,(long) Qt::color0, "color0");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"color0", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_GlobalColor->tp_dict,"color0", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_GlobalColor,(long) Qt::color1, "color1");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"color1", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_GlobalColor->tp_dict,"color1", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_GlobalColor,(long) Qt::black, "black");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"black", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_GlobalColor->tp_dict,"black", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_GlobalColor,(long) Qt::white, "white");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"white", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_GlobalColor->tp_dict,"white", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_GlobalColor,(long) Qt::darkGray, "darkGray");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"darkGray", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_GlobalColor->tp_dict,"darkGray", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_GlobalColor,(long) Qt::gray, "gray");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"gray", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_GlobalColor->tp_dict,"gray", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_GlobalColor,(long) Qt::lightGray, "lightGray");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"lightGray", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_GlobalColor->tp_dict,"lightGray", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_GlobalColor,(long) Qt::red, "red");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"red", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_GlobalColor->tp_dict,"red", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_GlobalColor,(long) Qt::green, "green");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"green", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_GlobalColor->tp_dict,"green", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_GlobalColor,(long) Qt::blue, "blue");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"blue", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_GlobalColor->tp_dict,"blue", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_GlobalColor,(long) Qt::cyan, "cyan");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"cyan", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_GlobalColor->tp_dict,"cyan", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_GlobalColor,(long) Qt::magenta, "magenta");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"magenta", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_GlobalColor->tp_dict,"magenta", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_GlobalColor,(long) Qt::yellow, "yellow");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"yellow", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_GlobalColor->tp_dict,"yellow", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_GlobalColor,(long) Qt::darkRed, "darkRed");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"darkRed", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_GlobalColor->tp_dict,"darkRed", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_GlobalColor,(long) Qt::darkGreen, "darkGreen");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"darkGreen", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_GlobalColor->tp_dict,"darkGreen", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_GlobalColor,(long) Qt::darkBlue, "darkBlue");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"darkBlue", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_GlobalColor->tp_dict,"darkBlue", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_GlobalColor,(long) Qt::darkCyan, "darkCyan");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"darkCyan", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_GlobalColor->tp_dict,"darkCyan", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_GlobalColor,(long) Qt::darkMagenta, "darkMagenta");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"darkMagenta", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_GlobalColor->tp_dict,"darkMagenta", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_GlobalColor,(long) Qt::darkYellow, "darkYellow");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"darkYellow", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_GlobalColor->tp_dict,"darkYellow", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_GlobalColor,(long) Qt::transparent, "transparent");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"transparent", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_GlobalColor->tp_dict,"transparent", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("Qt::GlobalColor");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::GlobalColor");
    // end of enum GlobalColor

    // init enum: KeyboardModifier
    PyTypeObject* SbkPySide_QtCore_Qt_KeyboardModifier = Shiboken::Enum::newType("KeyboardModifier");
    SbkPySide_QtCore_Qt_KeyboardModifier->tp_as_number = &SbkPySide_QtCore_Qt_KeyboardModifier_as_number;
    SbkPySide_QtCoreTypes[SBK_QT_KEYBOARDMODIFIER_IDX] = SbkPySide_QtCore_Qt_KeyboardModifier;
    if (PyType_Ready(SbkPySide_QtCore_Qt_KeyboardModifier) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "KeyboardModifier",((PyObject*)SbkPySide_QtCore_Qt_KeyboardModifier));

    // init flags class: QFlags<Qt::KeyboardModifier>
    SbkPySide_QtCoreTypes[SBK_QFLAGS_QT_KEYBOARDMODIFIER__IDX] = &SbkPySide_QtCore_Qt_KeyboardModifiers_Type;
    if (PyType_Ready((PyTypeObject*)&SbkPySide_QtCore_Qt_KeyboardModifiers_Type) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "KeyboardModifiers",((PyObject*)&SbkPySide_QtCore_Qt_KeyboardModifiers_Type));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_KeyboardModifier,(long) Qt::NoModifier, "NoModifier");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"NoModifier", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_KeyboardModifier->tp_dict,"NoModifier", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_KeyboardModifier,(long) Qt::ShiftModifier, "ShiftModifier");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"ShiftModifier", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_KeyboardModifier->tp_dict,"ShiftModifier", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_KeyboardModifier,(long) Qt::ControlModifier, "ControlModifier");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"ControlModifier", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_KeyboardModifier->tp_dict,"ControlModifier", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_KeyboardModifier,(long) Qt::AltModifier, "AltModifier");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"AltModifier", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_KeyboardModifier->tp_dict,"AltModifier", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_KeyboardModifier,(long) Qt::MetaModifier, "MetaModifier");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"MetaModifier", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_KeyboardModifier->tp_dict,"MetaModifier", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_KeyboardModifier,(long) Qt::KeypadModifier, "KeypadModifier");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"KeypadModifier", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_KeyboardModifier->tp_dict,"KeypadModifier", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_KeyboardModifier,(long) Qt::GroupSwitchModifier, "GroupSwitchModifier");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"GroupSwitchModifier", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_KeyboardModifier->tp_dict,"GroupSwitchModifier", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_KeyboardModifier,(long) Qt::KeyboardModifierMask, "KeyboardModifierMask");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"KeyboardModifierMask", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_KeyboardModifier->tp_dict,"KeyboardModifierMask", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("Qt::KeyboardModifier");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::KeyboardModifier");
    // end of enum KeyboardModifier

    // init enum: NavigationMode
    PyTypeObject* SbkPySide_QtCore_Qt_NavigationMode = Shiboken::Enum::newType("NavigationMode");
    SbkPySide_QtCoreTypes[SBK_QT_NAVIGATIONMODE_IDX] = SbkPySide_QtCore_Qt_NavigationMode;
    if (PyType_Ready(SbkPySide_QtCore_Qt_NavigationMode) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "NavigationMode",((PyObject*)SbkPySide_QtCore_Qt_NavigationMode));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_NavigationMode,(long) Qt::NavigationModeNone, "NavigationModeNone");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"NavigationModeNone", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_NavigationMode->tp_dict,"NavigationModeNone", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_NavigationMode,(long) Qt::NavigationModeKeypadTabOrder, "NavigationModeKeypadTabOrder");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"NavigationModeKeypadTabOrder", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_NavigationMode->tp_dict,"NavigationModeKeypadTabOrder", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_NavigationMode,(long) Qt::NavigationModeKeypadDirectional, "NavigationModeKeypadDirectional");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"NavigationModeKeypadDirectional", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_NavigationMode->tp_dict,"NavigationModeKeypadDirectional", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_NavigationMode,(long) Qt::NavigationModeCursorAuto, "NavigationModeCursorAuto");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"NavigationModeCursorAuto", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_NavigationMode->tp_dict,"NavigationModeCursorAuto", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_NavigationMode,(long) Qt::NavigationModeCursorForceVisible, "NavigationModeCursorForceVisible");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"NavigationModeCursorForceVisible", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_NavigationMode->tp_dict,"NavigationModeCursorForceVisible", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("Qt::NavigationMode");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::NavigationMode");
    // end of enum NavigationMode

    // init enum: ItemDataRole
    PyTypeObject* SbkPySide_QtCore_Qt_ItemDataRole = Shiboken::Enum::newType("ItemDataRole");
    SbkPySide_QtCoreTypes[SBK_QT_ITEMDATAROLE_IDX] = SbkPySide_QtCore_Qt_ItemDataRole;
    if (PyType_Ready(SbkPySide_QtCore_Qt_ItemDataRole) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "ItemDataRole",((PyObject*)SbkPySide_QtCore_Qt_ItemDataRole));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ItemDataRole,(long) Qt::DisplayRole, "DisplayRole");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"DisplayRole", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ItemDataRole->tp_dict,"DisplayRole", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ItemDataRole,(long) Qt::DecorationRole, "DecorationRole");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"DecorationRole", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ItemDataRole->tp_dict,"DecorationRole", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ItemDataRole,(long) Qt::EditRole, "EditRole");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"EditRole", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ItemDataRole->tp_dict,"EditRole", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ItemDataRole,(long) Qt::ToolTipRole, "ToolTipRole");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"ToolTipRole", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ItemDataRole->tp_dict,"ToolTipRole", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ItemDataRole,(long) Qt::StatusTipRole, "StatusTipRole");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"StatusTipRole", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ItemDataRole->tp_dict,"StatusTipRole", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ItemDataRole,(long) Qt::WhatsThisRole, "WhatsThisRole");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WhatsThisRole", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ItemDataRole->tp_dict,"WhatsThisRole", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ItemDataRole,(long) Qt::FontRole, "FontRole");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"FontRole", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ItemDataRole->tp_dict,"FontRole", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ItemDataRole,(long) Qt::TextAlignmentRole, "TextAlignmentRole");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"TextAlignmentRole", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ItemDataRole->tp_dict,"TextAlignmentRole", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ItemDataRole,(long) Qt::BackgroundColorRole, "BackgroundColorRole");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"BackgroundColorRole", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ItemDataRole->tp_dict,"BackgroundColorRole", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ItemDataRole,(long) Qt::BackgroundRole, "BackgroundRole");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"BackgroundRole", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ItemDataRole->tp_dict,"BackgroundRole", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ItemDataRole,(long) Qt::TextColorRole, "TextColorRole");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"TextColorRole", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ItemDataRole->tp_dict,"TextColorRole", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ItemDataRole,(long) Qt::ForegroundRole, "ForegroundRole");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"ForegroundRole", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ItemDataRole->tp_dict,"ForegroundRole", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ItemDataRole,(long) Qt::CheckStateRole, "CheckStateRole");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"CheckStateRole", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ItemDataRole->tp_dict,"CheckStateRole", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ItemDataRole,(long) Qt::AccessibleTextRole, "AccessibleTextRole");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"AccessibleTextRole", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ItemDataRole->tp_dict,"AccessibleTextRole", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ItemDataRole,(long) Qt::AccessibleDescriptionRole, "AccessibleDescriptionRole");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"AccessibleDescriptionRole", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ItemDataRole->tp_dict,"AccessibleDescriptionRole", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ItemDataRole,(long) Qt::SizeHintRole, "SizeHintRole");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"SizeHintRole", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ItemDataRole->tp_dict,"SizeHintRole", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ItemDataRole,(long) Qt::DisplayPropertyRole, "DisplayPropertyRole");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"DisplayPropertyRole", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ItemDataRole->tp_dict,"DisplayPropertyRole", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ItemDataRole,(long) Qt::DecorationPropertyRole, "DecorationPropertyRole");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"DecorationPropertyRole", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ItemDataRole->tp_dict,"DecorationPropertyRole", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ItemDataRole,(long) Qt::ToolTipPropertyRole, "ToolTipPropertyRole");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"ToolTipPropertyRole", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ItemDataRole->tp_dict,"ToolTipPropertyRole", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ItemDataRole,(long) Qt::StatusTipPropertyRole, "StatusTipPropertyRole");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"StatusTipPropertyRole", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ItemDataRole->tp_dict,"StatusTipPropertyRole", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ItemDataRole,(long) Qt::WhatsThisPropertyRole, "WhatsThisPropertyRole");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WhatsThisPropertyRole", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ItemDataRole->tp_dict,"WhatsThisPropertyRole", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ItemDataRole,(long) Qt::UserRole, "UserRole");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"UserRole", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ItemDataRole->tp_dict,"UserRole", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("Qt::ItemDataRole");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::ItemDataRole");
    // end of enum ItemDataRole

    // init enum: ScrollBarPolicy
    PyTypeObject* SbkPySide_QtCore_Qt_ScrollBarPolicy = Shiboken::Enum::newType("ScrollBarPolicy");
    SbkPySide_QtCoreTypes[SBK_QT_SCROLLBARPOLICY_IDX] = SbkPySide_QtCore_Qt_ScrollBarPolicy;
    if (PyType_Ready(SbkPySide_QtCore_Qt_ScrollBarPolicy) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "ScrollBarPolicy",((PyObject*)SbkPySide_QtCore_Qt_ScrollBarPolicy));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ScrollBarPolicy,(long) Qt::ScrollBarAsNeeded, "ScrollBarAsNeeded");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"ScrollBarAsNeeded", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ScrollBarPolicy->tp_dict,"ScrollBarAsNeeded", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ScrollBarPolicy,(long) Qt::ScrollBarAlwaysOff, "ScrollBarAlwaysOff");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"ScrollBarAlwaysOff", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ScrollBarPolicy->tp_dict,"ScrollBarAlwaysOff", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ScrollBarPolicy,(long) Qt::ScrollBarAlwaysOn, "ScrollBarAlwaysOn");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"ScrollBarAlwaysOn", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ScrollBarPolicy->tp_dict,"ScrollBarAlwaysOn", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("Qt::ScrollBarPolicy");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::ScrollBarPolicy");
    // end of enum ScrollBarPolicy

    // init enum: InputMethodHint
    PyTypeObject* SbkPySide_QtCore_Qt_InputMethodHint = Shiboken::Enum::newType("InputMethodHint");
    SbkPySide_QtCore_Qt_InputMethodHint->tp_as_number = &SbkPySide_QtCore_Qt_InputMethodHint_as_number;
    SbkPySide_QtCoreTypes[SBK_QT_INPUTMETHODHINT_IDX] = SbkPySide_QtCore_Qt_InputMethodHint;
    if (PyType_Ready(SbkPySide_QtCore_Qt_InputMethodHint) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "InputMethodHint",((PyObject*)SbkPySide_QtCore_Qt_InputMethodHint));

    // init flags class: QFlags<Qt::InputMethodHint>
    SbkPySide_QtCoreTypes[SBK_QFLAGS_QT_INPUTMETHODHINT__IDX] = &SbkPySide_QtCore_Qt_InputMethodHints_Type;
    if (PyType_Ready((PyTypeObject*)&SbkPySide_QtCore_Qt_InputMethodHints_Type) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "InputMethodHints",((PyObject*)&SbkPySide_QtCore_Qt_InputMethodHints_Type));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_InputMethodHint,(long) Qt::ImhNone, "ImhNone");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"ImhNone", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_InputMethodHint->tp_dict,"ImhNone", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_InputMethodHint,(long) Qt::ImhHiddenText, "ImhHiddenText");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"ImhHiddenText", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_InputMethodHint->tp_dict,"ImhHiddenText", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_InputMethodHint,(long) Qt::ImhNoAutoUppercase, "ImhNoAutoUppercase");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"ImhNoAutoUppercase", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_InputMethodHint->tp_dict,"ImhNoAutoUppercase", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_InputMethodHint,(long) Qt::ImhPreferNumbers, "ImhPreferNumbers");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"ImhPreferNumbers", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_InputMethodHint->tp_dict,"ImhPreferNumbers", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_InputMethodHint,(long) Qt::ImhPreferUppercase, "ImhPreferUppercase");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"ImhPreferUppercase", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_InputMethodHint->tp_dict,"ImhPreferUppercase", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_InputMethodHint,(long) Qt::ImhPreferLowercase, "ImhPreferLowercase");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"ImhPreferLowercase", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_InputMethodHint->tp_dict,"ImhPreferLowercase", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_InputMethodHint,(long) Qt::ImhNoPredictiveText, "ImhNoPredictiveText");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"ImhNoPredictiveText", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_InputMethodHint->tp_dict,"ImhNoPredictiveText", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_InputMethodHint,(long) Qt::ImhDigitsOnly, "ImhDigitsOnly");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"ImhDigitsOnly", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_InputMethodHint->tp_dict,"ImhDigitsOnly", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_InputMethodHint,(long) Qt::ImhFormattedNumbersOnly, "ImhFormattedNumbersOnly");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"ImhFormattedNumbersOnly", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_InputMethodHint->tp_dict,"ImhFormattedNumbersOnly", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_InputMethodHint,(long) Qt::ImhUppercaseOnly, "ImhUppercaseOnly");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"ImhUppercaseOnly", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_InputMethodHint->tp_dict,"ImhUppercaseOnly", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_InputMethodHint,(long) Qt::ImhLowercaseOnly, "ImhLowercaseOnly");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"ImhLowercaseOnly", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_InputMethodHint->tp_dict,"ImhLowercaseOnly", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_InputMethodHint,(long) Qt::ImhDialableCharactersOnly, "ImhDialableCharactersOnly");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"ImhDialableCharactersOnly", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_InputMethodHint->tp_dict,"ImhDialableCharactersOnly", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_InputMethodHint,(long) Qt::ImhEmailCharactersOnly, "ImhEmailCharactersOnly");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"ImhEmailCharactersOnly", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_InputMethodHint->tp_dict,"ImhEmailCharactersOnly", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_InputMethodHint,(long) Qt::ImhUrlCharactersOnly, "ImhUrlCharactersOnly");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"ImhUrlCharactersOnly", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_InputMethodHint->tp_dict,"ImhUrlCharactersOnly", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_InputMethodHint,(long) Qt::ImhExclusiveInputMask, "ImhExclusiveInputMask");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"ImhExclusiveInputMask", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_InputMethodHint->tp_dict,"ImhExclusiveInputMask", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("Qt::InputMethodHint");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::InputMethodHint");
    // end of enum InputMethodHint

    // init enum: AnchorAttribute
    PyTypeObject* SbkPySide_QtCore_Qt_AnchorAttribute = Shiboken::Enum::newType("AnchorAttribute");
    SbkPySide_QtCoreTypes[SBK_QT_ANCHORATTRIBUTE_IDX] = SbkPySide_QtCore_Qt_AnchorAttribute;
    if (PyType_Ready(SbkPySide_QtCore_Qt_AnchorAttribute) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "AnchorAttribute",((PyObject*)SbkPySide_QtCore_Qt_AnchorAttribute));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_AnchorAttribute,(long) Qt::AnchorName, "AnchorName");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"AnchorName", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_AnchorAttribute->tp_dict,"AnchorName", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_AnchorAttribute,(long) Qt::AnchorHref, "AnchorHref");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"AnchorHref", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_AnchorAttribute->tp_dict,"AnchorHref", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("Qt::AnchorAttribute");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::AnchorAttribute");
    // end of enum AnchorAttribute

    // init enum: WindowModality
    PyTypeObject* SbkPySide_QtCore_Qt_WindowModality = Shiboken::Enum::newType("WindowModality");
    SbkPySide_QtCoreTypes[SBK_QT_WINDOWMODALITY_IDX] = SbkPySide_QtCore_Qt_WindowModality;
    if (PyType_Ready(SbkPySide_QtCore_Qt_WindowModality) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "WindowModality",((PyObject*)SbkPySide_QtCore_Qt_WindowModality));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WindowModality,(long) Qt::NonModal, "NonModal");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"NonModal", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WindowModality->tp_dict,"NonModal", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WindowModality,(long) Qt::WindowModal, "WindowModal");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WindowModal", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WindowModality->tp_dict,"WindowModal", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WindowModality,(long) Qt::ApplicationModal, "ApplicationModal");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"ApplicationModal", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WindowModality->tp_dict,"ApplicationModal", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("Qt::WindowModality");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::WindowModality");
    // end of enum WindowModality

    // init enum: SortOrder
    PyTypeObject* SbkPySide_QtCore_Qt_SortOrder = Shiboken::Enum::newType("SortOrder");
    SbkPySide_QtCoreTypes[SBK_QT_SORTORDER_IDX] = SbkPySide_QtCore_Qt_SortOrder;
    if (PyType_Ready(SbkPySide_QtCore_Qt_SortOrder) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "SortOrder",((PyObject*)SbkPySide_QtCore_Qt_SortOrder));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_SortOrder,(long) Qt::AscendingOrder, "AscendingOrder");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"AscendingOrder", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_SortOrder->tp_dict,"AscendingOrder", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_SortOrder,(long) Qt::DescendingOrder, "DescendingOrder");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"DescendingOrder", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_SortOrder->tp_dict,"DescendingOrder", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("Qt::SortOrder");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::SortOrder");
    // end of enum SortOrder

    // init enum: PenStyle
    PyTypeObject* SbkPySide_QtCore_Qt_PenStyle = Shiboken::Enum::newType("PenStyle");
    SbkPySide_QtCoreTypes[SBK_QT_PENSTYLE_IDX] = SbkPySide_QtCore_Qt_PenStyle;
    if (PyType_Ready(SbkPySide_QtCore_Qt_PenStyle) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "PenStyle",((PyObject*)SbkPySide_QtCore_Qt_PenStyle));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_PenStyle,(long) Qt::NoPen, "NoPen");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"NoPen", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_PenStyle->tp_dict,"NoPen", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_PenStyle,(long) Qt::SolidLine, "SolidLine");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"SolidLine", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_PenStyle->tp_dict,"SolidLine", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_PenStyle,(long) Qt::DashLine, "DashLine");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"DashLine", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_PenStyle->tp_dict,"DashLine", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_PenStyle,(long) Qt::DotLine, "DotLine");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"DotLine", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_PenStyle->tp_dict,"DotLine", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_PenStyle,(long) Qt::DashDotLine, "DashDotLine");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"DashDotLine", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_PenStyle->tp_dict,"DashDotLine", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_PenStyle,(long) Qt::DashDotDotLine, "DashDotDotLine");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"DashDotDotLine", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_PenStyle->tp_dict,"DashDotDotLine", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_PenStyle,(long) Qt::CustomDashLine, "CustomDashLine");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"CustomDashLine", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_PenStyle->tp_dict,"CustomDashLine", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_PenStyle,(long) Qt::MPenStyle, "MPenStyle");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"MPenStyle", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_PenStyle->tp_dict,"MPenStyle", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("Qt::PenStyle");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::PenStyle");
    // end of enum PenStyle

    // init enum: ItemFlag
    PyTypeObject* SbkPySide_QtCore_Qt_ItemFlag = Shiboken::Enum::newType("ItemFlag");
    SbkPySide_QtCore_Qt_ItemFlag->tp_as_number = &SbkPySide_QtCore_Qt_ItemFlag_as_number;
    SbkPySide_QtCoreTypes[SBK_QT_ITEMFLAG_IDX] = SbkPySide_QtCore_Qt_ItemFlag;
    if (PyType_Ready(SbkPySide_QtCore_Qt_ItemFlag) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "ItemFlag",((PyObject*)SbkPySide_QtCore_Qt_ItemFlag));

    // init flags class: QFlags<Qt::ItemFlag>
    SbkPySide_QtCoreTypes[SBK_QFLAGS_QT_ITEMFLAG__IDX] = &SbkPySide_QtCore_Qt_ItemFlags_Type;
    if (PyType_Ready((PyTypeObject*)&SbkPySide_QtCore_Qt_ItemFlags_Type) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "ItemFlags",((PyObject*)&SbkPySide_QtCore_Qt_ItemFlags_Type));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ItemFlag,(long) Qt::NoItemFlags, "NoItemFlags");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"NoItemFlags", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ItemFlag->tp_dict,"NoItemFlags", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ItemFlag,(long) Qt::ItemIsSelectable, "ItemIsSelectable");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"ItemIsSelectable", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ItemFlag->tp_dict,"ItemIsSelectable", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ItemFlag,(long) Qt::ItemIsEditable, "ItemIsEditable");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"ItemIsEditable", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ItemFlag->tp_dict,"ItemIsEditable", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ItemFlag,(long) Qt::ItemIsDragEnabled, "ItemIsDragEnabled");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"ItemIsDragEnabled", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ItemFlag->tp_dict,"ItemIsDragEnabled", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ItemFlag,(long) Qt::ItemIsDropEnabled, "ItemIsDropEnabled");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"ItemIsDropEnabled", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ItemFlag->tp_dict,"ItemIsDropEnabled", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ItemFlag,(long) Qt::ItemIsUserCheckable, "ItemIsUserCheckable");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"ItemIsUserCheckable", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ItemFlag->tp_dict,"ItemIsUserCheckable", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ItemFlag,(long) Qt::ItemIsEnabled, "ItemIsEnabled");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"ItemIsEnabled", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ItemFlag->tp_dict,"ItemIsEnabled", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ItemFlag,(long) Qt::ItemIsTristate, "ItemIsTristate");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"ItemIsTristate", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ItemFlag->tp_dict,"ItemIsTristate", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("Qt::ItemFlag");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::ItemFlag");
    // end of enum ItemFlag

    // init enum: Axis
    PyTypeObject* SbkPySide_QtCore_Qt_Axis = Shiboken::Enum::newType("Axis");
    SbkPySide_QtCoreTypes[SBK_QT_AXIS_IDX] = SbkPySide_QtCore_Qt_Axis;
    if (PyType_Ready(SbkPySide_QtCore_Qt_Axis) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "Axis",((PyObject*)SbkPySide_QtCore_Qt_Axis));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Axis,(long) Qt::XAxis, "XAxis");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"XAxis", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Axis->tp_dict,"XAxis", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Axis,(long) Qt::YAxis, "YAxis");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"YAxis", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Axis->tp_dict,"YAxis", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Axis,(long) Qt::ZAxis, "ZAxis");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"ZAxis", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Axis->tp_dict,"ZAxis", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("Qt::Axis");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::Axis");
    // end of enum Axis

    // init enum: TransformationMode
    PyTypeObject* SbkPySide_QtCore_Qt_TransformationMode = Shiboken::Enum::newType("TransformationMode");
    SbkPySide_QtCoreTypes[SBK_QT_TRANSFORMATIONMODE_IDX] = SbkPySide_QtCore_Qt_TransformationMode;
    if (PyType_Ready(SbkPySide_QtCore_Qt_TransformationMode) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "TransformationMode",((PyObject*)SbkPySide_QtCore_Qt_TransformationMode));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_TransformationMode,(long) Qt::FastTransformation, "FastTransformation");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"FastTransformation", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_TransformationMode->tp_dict,"FastTransformation", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_TransformationMode,(long) Qt::SmoothTransformation, "SmoothTransformation");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"SmoothTransformation", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_TransformationMode->tp_dict,"SmoothTransformation", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("Qt::TransformationMode");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::TransformationMode");
    // end of enum TransformationMode

    // init enum: WindowFrameSection
    PyTypeObject* SbkPySide_QtCore_Qt_WindowFrameSection = Shiboken::Enum::newType("WindowFrameSection");
    SbkPySide_QtCoreTypes[SBK_QT_WINDOWFRAMESECTION_IDX] = SbkPySide_QtCore_Qt_WindowFrameSection;
    if (PyType_Ready(SbkPySide_QtCore_Qt_WindowFrameSection) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "WindowFrameSection",((PyObject*)SbkPySide_QtCore_Qt_WindowFrameSection));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WindowFrameSection,(long) Qt::NoSection, "NoSection");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"NoSection", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WindowFrameSection->tp_dict,"NoSection", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WindowFrameSection,(long) Qt::LeftSection, "LeftSection");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"LeftSection", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WindowFrameSection->tp_dict,"LeftSection", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WindowFrameSection,(long) Qt::TopLeftSection, "TopLeftSection");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"TopLeftSection", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WindowFrameSection->tp_dict,"TopLeftSection", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WindowFrameSection,(long) Qt::TopSection, "TopSection");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"TopSection", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WindowFrameSection->tp_dict,"TopSection", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WindowFrameSection,(long) Qt::TopRightSection, "TopRightSection");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"TopRightSection", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WindowFrameSection->tp_dict,"TopRightSection", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WindowFrameSection,(long) Qt::RightSection, "RightSection");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"RightSection", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WindowFrameSection->tp_dict,"RightSection", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WindowFrameSection,(long) Qt::BottomRightSection, "BottomRightSection");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"BottomRightSection", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WindowFrameSection->tp_dict,"BottomRightSection", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WindowFrameSection,(long) Qt::BottomSection, "BottomSection");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"BottomSection", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WindowFrameSection->tp_dict,"BottomSection", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WindowFrameSection,(long) Qt::BottomLeftSection, "BottomLeftSection");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"BottomLeftSection", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WindowFrameSection->tp_dict,"BottomLeftSection", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WindowFrameSection,(long) Qt::TitleBarArea, "TitleBarArea");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"TitleBarArea", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WindowFrameSection->tp_dict,"TitleBarArea", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("Qt::WindowFrameSection");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::WindowFrameSection");
    // end of enum WindowFrameSection

    // init enum: HitTestAccuracy
    PyTypeObject* SbkPySide_QtCore_Qt_HitTestAccuracy = Shiboken::Enum::newType("HitTestAccuracy");
    SbkPySide_QtCoreTypes[SBK_QT_HITTESTACCURACY_IDX] = SbkPySide_QtCore_Qt_HitTestAccuracy;
    if (PyType_Ready(SbkPySide_QtCore_Qt_HitTestAccuracy) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "HitTestAccuracy",((PyObject*)SbkPySide_QtCore_Qt_HitTestAccuracy));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_HitTestAccuracy,(long) Qt::ExactHit, "ExactHit");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"ExactHit", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_HitTestAccuracy->tp_dict,"ExactHit", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_HitTestAccuracy,(long) Qt::FuzzyHit, "FuzzyHit");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"FuzzyHit", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_HitTestAccuracy->tp_dict,"FuzzyHit", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("Qt::HitTestAccuracy");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::HitTestAccuracy");
    // end of enum HitTestAccuracy

    // init enum: CursorShape
    PyTypeObject* SbkPySide_QtCore_Qt_CursorShape = Shiboken::Enum::newType("CursorShape");
    SbkPySide_QtCoreTypes[SBK_QT_CURSORSHAPE_IDX] = SbkPySide_QtCore_Qt_CursorShape;
    if (PyType_Ready(SbkPySide_QtCore_Qt_CursorShape) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "CursorShape",((PyObject*)SbkPySide_QtCore_Qt_CursorShape));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_CursorShape,(long) Qt::ArrowCursor, "ArrowCursor");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"ArrowCursor", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_CursorShape->tp_dict,"ArrowCursor", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_CursorShape,(long) Qt::UpArrowCursor, "UpArrowCursor");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"UpArrowCursor", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_CursorShape->tp_dict,"UpArrowCursor", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_CursorShape,(long) Qt::CrossCursor, "CrossCursor");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"CrossCursor", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_CursorShape->tp_dict,"CrossCursor", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_CursorShape,(long) Qt::WaitCursor, "WaitCursor");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WaitCursor", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_CursorShape->tp_dict,"WaitCursor", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_CursorShape,(long) Qt::IBeamCursor, "IBeamCursor");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"IBeamCursor", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_CursorShape->tp_dict,"IBeamCursor", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_CursorShape,(long) Qt::SizeVerCursor, "SizeVerCursor");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"SizeVerCursor", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_CursorShape->tp_dict,"SizeVerCursor", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_CursorShape,(long) Qt::SizeHorCursor, "SizeHorCursor");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"SizeHorCursor", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_CursorShape->tp_dict,"SizeHorCursor", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_CursorShape,(long) Qt::SizeBDiagCursor, "SizeBDiagCursor");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"SizeBDiagCursor", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_CursorShape->tp_dict,"SizeBDiagCursor", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_CursorShape,(long) Qt::SizeFDiagCursor, "SizeFDiagCursor");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"SizeFDiagCursor", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_CursorShape->tp_dict,"SizeFDiagCursor", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_CursorShape,(long) Qt::SizeAllCursor, "SizeAllCursor");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"SizeAllCursor", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_CursorShape->tp_dict,"SizeAllCursor", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_CursorShape,(long) Qt::BlankCursor, "BlankCursor");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"BlankCursor", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_CursorShape->tp_dict,"BlankCursor", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_CursorShape,(long) Qt::SplitVCursor, "SplitVCursor");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"SplitVCursor", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_CursorShape->tp_dict,"SplitVCursor", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_CursorShape,(long) Qt::SplitHCursor, "SplitHCursor");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"SplitHCursor", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_CursorShape->tp_dict,"SplitHCursor", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_CursorShape,(long) Qt::PointingHandCursor, "PointingHandCursor");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"PointingHandCursor", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_CursorShape->tp_dict,"PointingHandCursor", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_CursorShape,(long) Qt::ForbiddenCursor, "ForbiddenCursor");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"ForbiddenCursor", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_CursorShape->tp_dict,"ForbiddenCursor", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_CursorShape,(long) Qt::WhatsThisCursor, "WhatsThisCursor");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WhatsThisCursor", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_CursorShape->tp_dict,"WhatsThisCursor", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_CursorShape,(long) Qt::BusyCursor, "BusyCursor");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"BusyCursor", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_CursorShape->tp_dict,"BusyCursor", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_CursorShape,(long) Qt::OpenHandCursor, "OpenHandCursor");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"OpenHandCursor", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_CursorShape->tp_dict,"OpenHandCursor", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_CursorShape,(long) Qt::ClosedHandCursor, "ClosedHandCursor");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"ClosedHandCursor", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_CursorShape->tp_dict,"ClosedHandCursor", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_CursorShape,(long) Qt::DragCopyCursor, "DragCopyCursor");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"DragCopyCursor", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_CursorShape->tp_dict,"DragCopyCursor", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_CursorShape,(long) Qt::DragMoveCursor, "DragMoveCursor");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"DragMoveCursor", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_CursorShape->tp_dict,"DragMoveCursor", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_CursorShape,(long) Qt::DragLinkCursor, "DragLinkCursor");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"DragLinkCursor", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_CursorShape->tp_dict,"DragLinkCursor", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_CursorShape,(long) Qt::LastCursor, "LastCursor");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"LastCursor", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_CursorShape->tp_dict,"LastCursor", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_CursorShape,(long) Qt::BitmapCursor, "BitmapCursor");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"BitmapCursor", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_CursorShape->tp_dict,"BitmapCursor", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_CursorShape,(long) Qt::CustomCursor, "CustomCursor");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"CustomCursor", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_CursorShape->tp_dict,"CustomCursor", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("Qt::CursorShape");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::CursorShape");
    // end of enum CursorShape

    // init enum: ItemSelectionMode
    PyTypeObject* SbkPySide_QtCore_Qt_ItemSelectionMode = Shiboken::Enum::newType("ItemSelectionMode");
    SbkPySide_QtCoreTypes[SBK_QT_ITEMSELECTIONMODE_IDX] = SbkPySide_QtCore_Qt_ItemSelectionMode;
    if (PyType_Ready(SbkPySide_QtCore_Qt_ItemSelectionMode) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "ItemSelectionMode",((PyObject*)SbkPySide_QtCore_Qt_ItemSelectionMode));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ItemSelectionMode,(long) Qt::ContainsItemShape, "ContainsItemShape");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"ContainsItemShape", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ItemSelectionMode->tp_dict,"ContainsItemShape", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ItemSelectionMode,(long) Qt::IntersectsItemShape, "IntersectsItemShape");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"IntersectsItemShape", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ItemSelectionMode->tp_dict,"IntersectsItemShape", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ItemSelectionMode,(long) Qt::ContainsItemBoundingRect, "ContainsItemBoundingRect");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"ContainsItemBoundingRect", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ItemSelectionMode->tp_dict,"ContainsItemBoundingRect", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ItemSelectionMode,(long) Qt::IntersectsItemBoundingRect, "IntersectsItemBoundingRect");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"IntersectsItemBoundingRect", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ItemSelectionMode->tp_dict,"IntersectsItemBoundingRect", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("Qt::ItemSelectionMode");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::ItemSelectionMode");
    // end of enum ItemSelectionMode

    // init enum: Orientation
    PyTypeObject* SbkPySide_QtCore_Qt_Orientation = Shiboken::Enum::newType("Orientation");
    SbkPySide_QtCore_Qt_Orientation->tp_as_number = &SbkPySide_QtCore_Qt_Orientation_as_number;
    SbkPySide_QtCoreTypes[SBK_QT_ORIENTATION_IDX] = SbkPySide_QtCore_Qt_Orientation;
    if (PyType_Ready(SbkPySide_QtCore_Qt_Orientation) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "Orientation",((PyObject*)SbkPySide_QtCore_Qt_Orientation));

    // init flags class: QFlags<Qt::Orientation>
    SbkPySide_QtCoreTypes[SBK_QFLAGS_QT_ORIENTATION__IDX] = &SbkPySide_QtCore_Qt_Orientations_Type;
    if (PyType_Ready((PyTypeObject*)&SbkPySide_QtCore_Qt_Orientations_Type) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "Orientations",((PyObject*)&SbkPySide_QtCore_Qt_Orientations_Type));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Orientation,(long) Qt::Horizontal, "Horizontal");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Horizontal", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Orientation->tp_dict,"Horizontal", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Orientation,(long) Qt::Vertical, "Vertical");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Vertical", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Orientation->tp_dict,"Vertical", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("Qt::Orientation");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::Orientation");
    // end of enum Orientation

    // init enum: InputMethodQuery
    PyTypeObject* SbkPySide_QtCore_Qt_InputMethodQuery = Shiboken::Enum::newType("InputMethodQuery");
    SbkPySide_QtCoreTypes[SBK_QT_INPUTMETHODQUERY_IDX] = SbkPySide_QtCore_Qt_InputMethodQuery;
    if (PyType_Ready(SbkPySide_QtCore_Qt_InputMethodQuery) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "InputMethodQuery",((PyObject*)SbkPySide_QtCore_Qt_InputMethodQuery));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_InputMethodQuery,(long) Qt::ImMicroFocus, "ImMicroFocus");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"ImMicroFocus", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_InputMethodQuery->tp_dict,"ImMicroFocus", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_InputMethodQuery,(long) Qt::ImFont, "ImFont");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"ImFont", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_InputMethodQuery->tp_dict,"ImFont", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_InputMethodQuery,(long) Qt::ImCursorPosition, "ImCursorPosition");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"ImCursorPosition", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_InputMethodQuery->tp_dict,"ImCursorPosition", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_InputMethodQuery,(long) Qt::ImSurroundingText, "ImSurroundingText");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"ImSurroundingText", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_InputMethodQuery->tp_dict,"ImSurroundingText", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_InputMethodQuery,(long) Qt::ImCurrentSelection, "ImCurrentSelection");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"ImCurrentSelection", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_InputMethodQuery->tp_dict,"ImCurrentSelection", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_InputMethodQuery,(long) Qt::ImMaximumTextLength, "ImMaximumTextLength");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"ImMaximumTextLength", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_InputMethodQuery->tp_dict,"ImMaximumTextLength", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_InputMethodQuery,(long) Qt::ImAnchorPosition, "ImAnchorPosition");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"ImAnchorPosition", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_InputMethodQuery->tp_dict,"ImAnchorPosition", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("Qt::InputMethodQuery");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::InputMethodQuery");
    // end of enum InputMethodQuery

    // init enum: TimeSpec
    PyTypeObject* SbkPySide_QtCore_Qt_TimeSpec = Shiboken::Enum::newType("TimeSpec");
    SbkPySide_QtCoreTypes[SBK_QT_TIMESPEC_IDX] = SbkPySide_QtCore_Qt_TimeSpec;
    if (PyType_Ready(SbkPySide_QtCore_Qt_TimeSpec) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "TimeSpec",((PyObject*)SbkPySide_QtCore_Qt_TimeSpec));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_TimeSpec,(long) Qt::LocalTime, "LocalTime");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"LocalTime", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_TimeSpec->tp_dict,"LocalTime", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_TimeSpec,(long) Qt::UTC, "UTC");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"UTC", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_TimeSpec->tp_dict,"UTC", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_TimeSpec,(long) Qt::OffsetFromUTC, "OffsetFromUTC");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"OffsetFromUTC", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_TimeSpec->tp_dict,"OffsetFromUTC", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("Qt::TimeSpec");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::TimeSpec");
    // end of enum TimeSpec

    // init enum: ArrowType
    PyTypeObject* SbkPySide_QtCore_Qt_ArrowType = Shiboken::Enum::newType("ArrowType");
    SbkPySide_QtCoreTypes[SBK_QT_ARROWTYPE_IDX] = SbkPySide_QtCore_Qt_ArrowType;
    if (PyType_Ready(SbkPySide_QtCore_Qt_ArrowType) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "ArrowType",((PyObject*)SbkPySide_QtCore_Qt_ArrowType));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ArrowType,(long) Qt::NoArrow, "NoArrow");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"NoArrow", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ArrowType->tp_dict,"NoArrow", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ArrowType,(long) Qt::UpArrow, "UpArrow");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"UpArrow", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ArrowType->tp_dict,"UpArrow", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ArrowType,(long) Qt::DownArrow, "DownArrow");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"DownArrow", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ArrowType->tp_dict,"DownArrow", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ArrowType,(long) Qt::LeftArrow, "LeftArrow");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"LeftArrow", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ArrowType->tp_dict,"LeftArrow", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ArrowType,(long) Qt::RightArrow, "RightArrow");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"RightArrow", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ArrowType->tp_dict,"RightArrow", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("Qt::ArrowType");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::ArrowType");
    // end of enum ArrowType

    // init enum: FillRule
    PyTypeObject* SbkPySide_QtCore_Qt_FillRule = Shiboken::Enum::newType("FillRule");
    SbkPySide_QtCoreTypes[SBK_QT_FILLRULE_IDX] = SbkPySide_QtCore_Qt_FillRule;
    if (PyType_Ready(SbkPySide_QtCore_Qt_FillRule) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "FillRule",((PyObject*)SbkPySide_QtCore_Qt_FillRule));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_FillRule,(long) Qt::OddEvenFill, "OddEvenFill");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"OddEvenFill", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_FillRule->tp_dict,"OddEvenFill", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_FillRule,(long) Qt::WindingFill, "WindingFill");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WindingFill", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_FillRule->tp_dict,"WindingFill", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("Qt::FillRule");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::FillRule");
    // end of enum FillRule

    // init enum: MaskMode
    PyTypeObject* SbkPySide_QtCore_Qt_MaskMode = Shiboken::Enum::newType("MaskMode");
    SbkPySide_QtCoreTypes[SBK_QT_MASKMODE_IDX] = SbkPySide_QtCore_Qt_MaskMode;
    if (PyType_Ready(SbkPySide_QtCore_Qt_MaskMode) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "MaskMode",((PyObject*)SbkPySide_QtCore_Qt_MaskMode));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_MaskMode,(long) Qt::MaskInColor, "MaskInColor");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"MaskInColor", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_MaskMode->tp_dict,"MaskInColor", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_MaskMode,(long) Qt::MaskOutColor, "MaskOutColor");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"MaskOutColor", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_MaskMode->tp_dict,"MaskOutColor", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("Qt::MaskMode");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::MaskMode");
    // end of enum MaskMode

    // init enum: WindowState
    PyTypeObject* SbkPySide_QtCore_Qt_WindowState = Shiboken::Enum::newType("WindowState");
    SbkPySide_QtCore_Qt_WindowState->tp_as_number = &SbkPySide_QtCore_Qt_WindowState_as_number;
    SbkPySide_QtCoreTypes[SBK_QT_WINDOWSTATE_IDX] = SbkPySide_QtCore_Qt_WindowState;
    if (PyType_Ready(SbkPySide_QtCore_Qt_WindowState) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "WindowState",((PyObject*)SbkPySide_QtCore_Qt_WindowState));

    // init flags class: QFlags<Qt::WindowState>
    SbkPySide_QtCoreTypes[SBK_QFLAGS_QT_WINDOWSTATE__IDX] = &SbkPySide_QtCore_Qt_WindowStates_Type;
    if (PyType_Ready((PyTypeObject*)&SbkPySide_QtCore_Qt_WindowStates_Type) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "WindowStates",((PyObject*)&SbkPySide_QtCore_Qt_WindowStates_Type));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WindowState,(long) Qt::WindowNoState, "WindowNoState");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WindowNoState", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WindowState->tp_dict,"WindowNoState", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WindowState,(long) Qt::WindowMinimized, "WindowMinimized");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WindowMinimized", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WindowState->tp_dict,"WindowMinimized", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WindowState,(long) Qt::WindowMaximized, "WindowMaximized");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WindowMaximized", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WindowState->tp_dict,"WindowMaximized", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WindowState,(long) Qt::WindowFullScreen, "WindowFullScreen");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WindowFullScreen", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WindowState->tp_dict,"WindowFullScreen", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WindowState,(long) Qt::WindowActive, "WindowActive");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WindowActive", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WindowState->tp_dict,"WindowActive", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("Qt::WindowState");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::WindowState");
    // end of enum WindowState

    // init enum: ToolBarAreaSizes
    PyTypeObject* SbkPySide_QtCore_Qt_ToolBarAreaSizes = Shiboken::Enum::newType("ToolBarAreaSizes");
    SbkPySide_QtCoreTypes[SBK_QT_TOOLBARAREASIZES_IDX] = SbkPySide_QtCore_Qt_ToolBarAreaSizes;
    if (PyType_Ready(SbkPySide_QtCore_Qt_ToolBarAreaSizes) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "ToolBarAreaSizes",((PyObject*)SbkPySide_QtCore_Qt_ToolBarAreaSizes));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ToolBarAreaSizes,(long) Qt::NToolBarAreas, "NToolBarAreas");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"NToolBarAreas", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ToolBarAreaSizes->tp_dict,"NToolBarAreas", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("Qt::ToolBarAreaSizes");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::ToolBarAreaSizes");
    // end of enum ToolBarAreaSizes

    // init enum: Corner
    PyTypeObject* SbkPySide_QtCore_Qt_Corner = Shiboken::Enum::newType("Corner");
    SbkPySide_QtCoreTypes[SBK_QT_CORNER_IDX] = SbkPySide_QtCore_Qt_Corner;
    if (PyType_Ready(SbkPySide_QtCore_Qt_Corner) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "Corner",((PyObject*)SbkPySide_QtCore_Qt_Corner));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Corner,(long) Qt::TopLeftCorner, "TopLeftCorner");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"TopLeftCorner", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Corner->tp_dict,"TopLeftCorner", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Corner,(long) Qt::TopRightCorner, "TopRightCorner");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"TopRightCorner", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Corner->tp_dict,"TopRightCorner", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Corner,(long) Qt::BottomLeftCorner, "BottomLeftCorner");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"BottomLeftCorner", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Corner->tp_dict,"BottomLeftCorner", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Corner,(long) Qt::BottomRightCorner, "BottomRightCorner");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"BottomRightCorner", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Corner->tp_dict,"BottomRightCorner", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("Qt::Corner");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::Corner");
    // end of enum Corner

    // init enum: DayOfWeek
    PyTypeObject* SbkPySide_QtCore_Qt_DayOfWeek = Shiboken::Enum::newType("DayOfWeek");
    SbkPySide_QtCoreTypes[SBK_QT_DAYOFWEEK_IDX] = SbkPySide_QtCore_Qt_DayOfWeek;
    if (PyType_Ready(SbkPySide_QtCore_Qt_DayOfWeek) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "DayOfWeek",((PyObject*)SbkPySide_QtCore_Qt_DayOfWeek));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_DayOfWeek,(long) Qt::Monday, "Monday");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Monday", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_DayOfWeek->tp_dict,"Monday", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_DayOfWeek,(long) Qt::Tuesday, "Tuesday");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Tuesday", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_DayOfWeek->tp_dict,"Tuesday", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_DayOfWeek,(long) Qt::Wednesday, "Wednesday");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Wednesday", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_DayOfWeek->tp_dict,"Wednesday", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_DayOfWeek,(long) Qt::Thursday, "Thursday");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Thursday", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_DayOfWeek->tp_dict,"Thursday", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_DayOfWeek,(long) Qt::Friday, "Friday");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Friday", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_DayOfWeek->tp_dict,"Friday", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_DayOfWeek,(long) Qt::Saturday, "Saturday");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Saturday", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_DayOfWeek->tp_dict,"Saturday", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_DayOfWeek,(long) Qt::Sunday, "Sunday");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Sunday", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_DayOfWeek->tp_dict,"Sunday", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("Qt::DayOfWeek");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::DayOfWeek");
    // end of enum DayOfWeek

    // init enum: ClipOperation
    PyTypeObject* SbkPySide_QtCore_Qt_ClipOperation = Shiboken::Enum::newType("ClipOperation");
    SbkPySide_QtCoreTypes[SBK_QT_CLIPOPERATION_IDX] = SbkPySide_QtCore_Qt_ClipOperation;
    if (PyType_Ready(SbkPySide_QtCore_Qt_ClipOperation) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "ClipOperation",((PyObject*)SbkPySide_QtCore_Qt_ClipOperation));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ClipOperation,(long) Qt::NoClip, "NoClip");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"NoClip", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ClipOperation->tp_dict,"NoClip", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ClipOperation,(long) Qt::ReplaceClip, "ReplaceClip");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"ReplaceClip", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ClipOperation->tp_dict,"ReplaceClip", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ClipOperation,(long) Qt::IntersectClip, "IntersectClip");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"IntersectClip", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ClipOperation->tp_dict,"IntersectClip", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ClipOperation,(long) Qt::UniteClip, "UniteClip");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"UniteClip", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ClipOperation->tp_dict,"UniteClip", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("Qt::ClipOperation");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::ClipOperation");
    // end of enum ClipOperation

    // init enum: LayoutDirection
    PyTypeObject* SbkPySide_QtCore_Qt_LayoutDirection = Shiboken::Enum::newType("LayoutDirection");
    SbkPySide_QtCoreTypes[SBK_QT_LAYOUTDIRECTION_IDX] = SbkPySide_QtCore_Qt_LayoutDirection;
    if (PyType_Ready(SbkPySide_QtCore_Qt_LayoutDirection) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "LayoutDirection",((PyObject*)SbkPySide_QtCore_Qt_LayoutDirection));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_LayoutDirection,(long) Qt::LeftToRight, "LeftToRight");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"LeftToRight", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_LayoutDirection->tp_dict,"LeftToRight", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_LayoutDirection,(long) Qt::RightToLeft, "RightToLeft");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"RightToLeft", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_LayoutDirection->tp_dict,"RightToLeft", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_LayoutDirection,(long) Qt::LayoutDirectionAuto, "LayoutDirectionAuto");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"LayoutDirectionAuto", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_LayoutDirection->tp_dict,"LayoutDirectionAuto", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("Qt::LayoutDirection");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::LayoutDirection");
    // end of enum LayoutDirection

    // init enum: ToolButtonStyle
    PyTypeObject* SbkPySide_QtCore_Qt_ToolButtonStyle = Shiboken::Enum::newType("ToolButtonStyle");
    SbkPySide_QtCoreTypes[SBK_QT_TOOLBUTTONSTYLE_IDX] = SbkPySide_QtCore_Qt_ToolButtonStyle;
    if (PyType_Ready(SbkPySide_QtCore_Qt_ToolButtonStyle) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "ToolButtonStyle",((PyObject*)SbkPySide_QtCore_Qt_ToolButtonStyle));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ToolButtonStyle,(long) Qt::ToolButtonIconOnly, "ToolButtonIconOnly");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"ToolButtonIconOnly", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ToolButtonStyle->tp_dict,"ToolButtonIconOnly", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ToolButtonStyle,(long) Qt::ToolButtonTextOnly, "ToolButtonTextOnly");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"ToolButtonTextOnly", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ToolButtonStyle->tp_dict,"ToolButtonTextOnly", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ToolButtonStyle,(long) Qt::ToolButtonTextBesideIcon, "ToolButtonTextBesideIcon");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"ToolButtonTextBesideIcon", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ToolButtonStyle->tp_dict,"ToolButtonTextBesideIcon", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ToolButtonStyle,(long) Qt::ToolButtonTextUnderIcon, "ToolButtonTextUnderIcon");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"ToolButtonTextUnderIcon", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ToolButtonStyle->tp_dict,"ToolButtonTextUnderIcon", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ToolButtonStyle,(long) Qt::ToolButtonFollowStyle, "ToolButtonFollowStyle");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"ToolButtonFollowStyle", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ToolButtonStyle->tp_dict,"ToolButtonFollowStyle", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("Qt::ToolButtonStyle");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::ToolButtonStyle");
    // end of enum ToolButtonStyle

    // init enum: DockWidgetAreaSizes
    PyTypeObject* SbkPySide_QtCore_Qt_DockWidgetAreaSizes = Shiboken::Enum::newType("DockWidgetAreaSizes");
    SbkPySide_QtCoreTypes[SBK_QT_DOCKWIDGETAREASIZES_IDX] = SbkPySide_QtCore_Qt_DockWidgetAreaSizes;
    if (PyType_Ready(SbkPySide_QtCore_Qt_DockWidgetAreaSizes) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "DockWidgetAreaSizes",((PyObject*)SbkPySide_QtCore_Qt_DockWidgetAreaSizes));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_DockWidgetAreaSizes,(long) Qt::NDockWidgetAreas, "NDockWidgetAreas");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"NDockWidgetAreas", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_DockWidgetAreaSizes->tp_dict,"NDockWidgetAreas", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("Qt::DockWidgetAreaSizes");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::DockWidgetAreaSizes");
    // end of enum DockWidgetAreaSizes

    // init enum: Key
    PyTypeObject* SbkPySide_QtCore_Qt_Key = Shiboken::Enum::newType("Key");
    SbkPySide_QtCoreTypes[SBK_QT_KEY_IDX] = SbkPySide_QtCore_Qt_Key;
    if (PyType_Ready(SbkPySide_QtCore_Qt_Key) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "Key",((PyObject*)SbkPySide_QtCore_Qt_Key));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Escape, "Key_Escape");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Escape", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Escape", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Tab, "Key_Tab");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Tab", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Tab", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Backtab, "Key_Backtab");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Backtab", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Backtab", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Backspace, "Key_Backspace");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Backspace", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Backspace", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Return, "Key_Return");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Return", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Return", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Enter, "Key_Enter");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Enter", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Enter", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Insert, "Key_Insert");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Insert", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Insert", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Delete, "Key_Delete");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Delete", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Delete", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Pause, "Key_Pause");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Pause", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Pause", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Print, "Key_Print");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Print", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Print", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_SysReq, "Key_SysReq");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_SysReq", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_SysReq", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Clear, "Key_Clear");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Clear", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Clear", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Home, "Key_Home");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Home", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Home", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_End, "Key_End");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_End", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_End", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Left, "Key_Left");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Left", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Left", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Up, "Key_Up");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Up", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Up", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Right, "Key_Right");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Right", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Right", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Down, "Key_Down");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Down", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Down", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_PageUp, "Key_PageUp");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_PageUp", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_PageUp", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_PageDown, "Key_PageDown");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_PageDown", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_PageDown", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Shift, "Key_Shift");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Shift", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Shift", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Control, "Key_Control");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Control", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Control", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Meta, "Key_Meta");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Meta", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Meta", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Alt, "Key_Alt");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Alt", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Alt", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_CapsLock, "Key_CapsLock");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_CapsLock", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_CapsLock", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_NumLock, "Key_NumLock");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_NumLock", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_NumLock", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_ScrollLock, "Key_ScrollLock");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_ScrollLock", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_ScrollLock", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_F1, "Key_F1");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_F1", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_F1", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_F2, "Key_F2");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_F2", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_F2", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_F3, "Key_F3");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_F3", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_F3", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_F4, "Key_F4");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_F4", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_F4", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_F5, "Key_F5");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_F5", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_F5", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_F6, "Key_F6");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_F6", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_F6", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_F7, "Key_F7");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_F7", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_F7", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_F8, "Key_F8");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_F8", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_F8", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_F9, "Key_F9");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_F9", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_F9", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_F10, "Key_F10");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_F10", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_F10", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_F11, "Key_F11");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_F11", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_F11", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_F12, "Key_F12");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_F12", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_F12", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_F13, "Key_F13");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_F13", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_F13", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_F14, "Key_F14");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_F14", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_F14", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_F15, "Key_F15");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_F15", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_F15", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_F16, "Key_F16");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_F16", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_F16", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_F17, "Key_F17");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_F17", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_F17", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_F18, "Key_F18");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_F18", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_F18", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_F19, "Key_F19");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_F19", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_F19", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_F20, "Key_F20");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_F20", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_F20", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_F21, "Key_F21");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_F21", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_F21", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_F22, "Key_F22");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_F22", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_F22", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_F23, "Key_F23");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_F23", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_F23", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_F24, "Key_F24");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_F24", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_F24", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_F25, "Key_F25");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_F25", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_F25", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_F26, "Key_F26");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_F26", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_F26", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_F27, "Key_F27");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_F27", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_F27", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_F28, "Key_F28");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_F28", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_F28", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_F29, "Key_F29");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_F29", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_F29", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_F30, "Key_F30");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_F30", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_F30", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_F31, "Key_F31");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_F31", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_F31", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_F32, "Key_F32");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_F32", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_F32", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_F33, "Key_F33");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_F33", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_F33", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_F34, "Key_F34");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_F34", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_F34", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_F35, "Key_F35");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_F35", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_F35", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Super_L, "Key_Super_L");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Super_L", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Super_L", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Super_R, "Key_Super_R");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Super_R", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Super_R", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Menu, "Key_Menu");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Menu", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Menu", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Hyper_L, "Key_Hyper_L");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Hyper_L", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Hyper_L", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Hyper_R, "Key_Hyper_R");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Hyper_R", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Hyper_R", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Help, "Key_Help");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Help", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Help", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Direction_L, "Key_Direction_L");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Direction_L", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Direction_L", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Direction_R, "Key_Direction_R");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Direction_R", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Direction_R", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Space, "Key_Space");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Space", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Space", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Any, "Key_Any");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Any", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Any", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Exclam, "Key_Exclam");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Exclam", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Exclam", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_QuoteDbl, "Key_QuoteDbl");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_QuoteDbl", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_QuoteDbl", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_NumberSign, "Key_NumberSign");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_NumberSign", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_NumberSign", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Dollar, "Key_Dollar");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Dollar", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Dollar", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Percent, "Key_Percent");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Percent", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Percent", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Ampersand, "Key_Ampersand");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Ampersand", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Ampersand", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Apostrophe, "Key_Apostrophe");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Apostrophe", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Apostrophe", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_ParenLeft, "Key_ParenLeft");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_ParenLeft", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_ParenLeft", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_ParenRight, "Key_ParenRight");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_ParenRight", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_ParenRight", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Asterisk, "Key_Asterisk");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Asterisk", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Asterisk", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Plus, "Key_Plus");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Plus", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Plus", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Comma, "Key_Comma");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Comma", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Comma", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Minus, "Key_Minus");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Minus", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Minus", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Period, "Key_Period");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Period", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Period", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Slash, "Key_Slash");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Slash", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Slash", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_0, "Key_0");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_0", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_0", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_1, "Key_1");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_1", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_1", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_2, "Key_2");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_2", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_2", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_3, "Key_3");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_3", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_3", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_4, "Key_4");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_4", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_4", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_5, "Key_5");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_5", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_5", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_6, "Key_6");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_6", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_6", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_7, "Key_7");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_7", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_7", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_8, "Key_8");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_8", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_8", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_9, "Key_9");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_9", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_9", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Colon, "Key_Colon");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Colon", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Colon", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Semicolon, "Key_Semicolon");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Semicolon", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Semicolon", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Less, "Key_Less");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Less", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Less", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Equal, "Key_Equal");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Equal", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Equal", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Greater, "Key_Greater");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Greater", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Greater", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Question, "Key_Question");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Question", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Question", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_At, "Key_At");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_At", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_At", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_A, "Key_A");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_A", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_A", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_B, "Key_B");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_B", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_B", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_C, "Key_C");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_C", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_C", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_D, "Key_D");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_D", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_D", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_E, "Key_E");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_E", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_E", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_F, "Key_F");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_F", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_F", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_G, "Key_G");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_G", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_G", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_H, "Key_H");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_H", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_H", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_I, "Key_I");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_I", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_I", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_J, "Key_J");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_J", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_J", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_K, "Key_K");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_K", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_K", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_L, "Key_L");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_L", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_L", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_M, "Key_M");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_M", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_M", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_N, "Key_N");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_N", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_N", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_O, "Key_O");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_O", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_O", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_P, "Key_P");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_P", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_P", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Q, "Key_Q");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Q", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Q", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_R, "Key_R");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_R", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_R", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_S, "Key_S");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_S", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_S", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_T, "Key_T");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_T", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_T", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_U, "Key_U");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_U", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_U", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_V, "Key_V");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_V", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_V", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_W, "Key_W");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_W", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_W", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_X, "Key_X");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_X", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_X", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Y, "Key_Y");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Y", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Y", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Z, "Key_Z");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Z", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Z", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_BracketLeft, "Key_BracketLeft");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_BracketLeft", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_BracketLeft", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Backslash, "Key_Backslash");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Backslash", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Backslash", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_BracketRight, "Key_BracketRight");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_BracketRight", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_BracketRight", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_AsciiCircum, "Key_AsciiCircum");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_AsciiCircum", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_AsciiCircum", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Underscore, "Key_Underscore");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Underscore", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Underscore", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_QuoteLeft, "Key_QuoteLeft");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_QuoteLeft", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_QuoteLeft", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_BraceLeft, "Key_BraceLeft");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_BraceLeft", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_BraceLeft", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Bar, "Key_Bar");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Bar", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Bar", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_BraceRight, "Key_BraceRight");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_BraceRight", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_BraceRight", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_AsciiTilde, "Key_AsciiTilde");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_AsciiTilde", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_AsciiTilde", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_nobreakspace, "Key_nobreakspace");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_nobreakspace", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_nobreakspace", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_exclamdown, "Key_exclamdown");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_exclamdown", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_exclamdown", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_cent, "Key_cent");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_cent", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_cent", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_sterling, "Key_sterling");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_sterling", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_sterling", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_currency, "Key_currency");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_currency", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_currency", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_yen, "Key_yen");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_yen", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_yen", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_brokenbar, "Key_brokenbar");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_brokenbar", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_brokenbar", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_section, "Key_section");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_section", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_section", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_diaeresis, "Key_diaeresis");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_diaeresis", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_diaeresis", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_copyright, "Key_copyright");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_copyright", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_copyright", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_ordfeminine, "Key_ordfeminine");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_ordfeminine", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_ordfeminine", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_guillemotleft, "Key_guillemotleft");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_guillemotleft", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_guillemotleft", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_notsign, "Key_notsign");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_notsign", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_notsign", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_hyphen, "Key_hyphen");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_hyphen", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_hyphen", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_registered, "Key_registered");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_registered", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_registered", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_macron, "Key_macron");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_macron", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_macron", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_degree, "Key_degree");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_degree", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_degree", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_plusminus, "Key_plusminus");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_plusminus", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_plusminus", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_twosuperior, "Key_twosuperior");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_twosuperior", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_twosuperior", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_threesuperior, "Key_threesuperior");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_threesuperior", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_threesuperior", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_acute, "Key_acute");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_acute", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_acute", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_mu, "Key_mu");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_mu", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_mu", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_paragraph, "Key_paragraph");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_paragraph", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_paragraph", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_periodcentered, "Key_periodcentered");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_periodcentered", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_periodcentered", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_cedilla, "Key_cedilla");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_cedilla", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_cedilla", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_onesuperior, "Key_onesuperior");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_onesuperior", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_onesuperior", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_masculine, "Key_masculine");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_masculine", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_masculine", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_guillemotright, "Key_guillemotright");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_guillemotright", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_guillemotright", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_onequarter, "Key_onequarter");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_onequarter", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_onequarter", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_onehalf, "Key_onehalf");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_onehalf", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_onehalf", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_threequarters, "Key_threequarters");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_threequarters", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_threequarters", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_questiondown, "Key_questiondown");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_questiondown", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_questiondown", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Agrave, "Key_Agrave");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Agrave", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Agrave", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Aacute, "Key_Aacute");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Aacute", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Aacute", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Acircumflex, "Key_Acircumflex");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Acircumflex", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Acircumflex", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Atilde, "Key_Atilde");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Atilde", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Atilde", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Adiaeresis, "Key_Adiaeresis");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Adiaeresis", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Adiaeresis", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Aring, "Key_Aring");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Aring", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Aring", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_AE, "Key_AE");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_AE", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_AE", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Ccedilla, "Key_Ccedilla");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Ccedilla", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Ccedilla", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Egrave, "Key_Egrave");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Egrave", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Egrave", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Eacute, "Key_Eacute");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Eacute", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Eacute", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Ecircumflex, "Key_Ecircumflex");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Ecircumflex", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Ecircumflex", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Ediaeresis, "Key_Ediaeresis");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Ediaeresis", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Ediaeresis", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Igrave, "Key_Igrave");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Igrave", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Igrave", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Iacute, "Key_Iacute");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Iacute", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Iacute", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Icircumflex, "Key_Icircumflex");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Icircumflex", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Icircumflex", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Idiaeresis, "Key_Idiaeresis");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Idiaeresis", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Idiaeresis", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_ETH, "Key_ETH");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_ETH", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_ETH", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Ntilde, "Key_Ntilde");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Ntilde", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Ntilde", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Ograve, "Key_Ograve");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Ograve", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Ograve", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Oacute, "Key_Oacute");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Oacute", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Oacute", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Ocircumflex, "Key_Ocircumflex");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Ocircumflex", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Ocircumflex", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Otilde, "Key_Otilde");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Otilde", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Otilde", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Odiaeresis, "Key_Odiaeresis");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Odiaeresis", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Odiaeresis", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_multiply, "Key_multiply");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_multiply", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_multiply", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Ooblique, "Key_Ooblique");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Ooblique", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Ooblique", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Ugrave, "Key_Ugrave");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Ugrave", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Ugrave", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Uacute, "Key_Uacute");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Uacute", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Uacute", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Ucircumflex, "Key_Ucircumflex");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Ucircumflex", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Ucircumflex", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Udiaeresis, "Key_Udiaeresis");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Udiaeresis", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Udiaeresis", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Yacute, "Key_Yacute");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Yacute", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Yacute", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_THORN, "Key_THORN");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_THORN", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_THORN", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_ssharp, "Key_ssharp");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_ssharp", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_ssharp", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_division, "Key_division");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_division", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_division", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_ydiaeresis, "Key_ydiaeresis");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_ydiaeresis", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_ydiaeresis", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_AltGr, "Key_AltGr");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_AltGr", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_AltGr", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Multi_key, "Key_Multi_key");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Multi_key", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Multi_key", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Codeinput, "Key_Codeinput");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Codeinput", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Codeinput", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_SingleCandidate, "Key_SingleCandidate");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_SingleCandidate", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_SingleCandidate", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_MultipleCandidate, "Key_MultipleCandidate");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_MultipleCandidate", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_MultipleCandidate", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_PreviousCandidate, "Key_PreviousCandidate");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_PreviousCandidate", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_PreviousCandidate", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Mode_switch, "Key_Mode_switch");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Mode_switch", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Mode_switch", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Kanji, "Key_Kanji");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Kanji", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Kanji", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Muhenkan, "Key_Muhenkan");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Muhenkan", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Muhenkan", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Henkan, "Key_Henkan");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Henkan", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Henkan", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Romaji, "Key_Romaji");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Romaji", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Romaji", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Hiragana, "Key_Hiragana");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Hiragana", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Hiragana", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Katakana, "Key_Katakana");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Katakana", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Katakana", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Hiragana_Katakana, "Key_Hiragana_Katakana");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Hiragana_Katakana", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Hiragana_Katakana", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Zenkaku, "Key_Zenkaku");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Zenkaku", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Zenkaku", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Hankaku, "Key_Hankaku");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Hankaku", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Hankaku", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Zenkaku_Hankaku, "Key_Zenkaku_Hankaku");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Zenkaku_Hankaku", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Zenkaku_Hankaku", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Touroku, "Key_Touroku");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Touroku", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Touroku", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Massyo, "Key_Massyo");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Massyo", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Massyo", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Kana_Lock, "Key_Kana_Lock");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Kana_Lock", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Kana_Lock", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Kana_Shift, "Key_Kana_Shift");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Kana_Shift", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Kana_Shift", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Eisu_Shift, "Key_Eisu_Shift");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Eisu_Shift", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Eisu_Shift", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Eisu_toggle, "Key_Eisu_toggle");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Eisu_toggle", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Eisu_toggle", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Hangul, "Key_Hangul");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Hangul", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Hangul", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Hangul_Start, "Key_Hangul_Start");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Hangul_Start", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Hangul_Start", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Hangul_End, "Key_Hangul_End");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Hangul_End", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Hangul_End", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Hangul_Hanja, "Key_Hangul_Hanja");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Hangul_Hanja", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Hangul_Hanja", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Hangul_Jamo, "Key_Hangul_Jamo");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Hangul_Jamo", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Hangul_Jamo", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Hangul_Romaja, "Key_Hangul_Romaja");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Hangul_Romaja", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Hangul_Romaja", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Hangul_Jeonja, "Key_Hangul_Jeonja");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Hangul_Jeonja", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Hangul_Jeonja", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Hangul_Banja, "Key_Hangul_Banja");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Hangul_Banja", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Hangul_Banja", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Hangul_PreHanja, "Key_Hangul_PreHanja");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Hangul_PreHanja", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Hangul_PreHanja", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Hangul_PostHanja, "Key_Hangul_PostHanja");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Hangul_PostHanja", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Hangul_PostHanja", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Hangul_Special, "Key_Hangul_Special");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Hangul_Special", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Hangul_Special", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Dead_Grave, "Key_Dead_Grave");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Dead_Grave", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Dead_Grave", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Dead_Acute, "Key_Dead_Acute");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Dead_Acute", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Dead_Acute", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Dead_Circumflex, "Key_Dead_Circumflex");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Dead_Circumflex", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Dead_Circumflex", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Dead_Tilde, "Key_Dead_Tilde");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Dead_Tilde", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Dead_Tilde", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Dead_Macron, "Key_Dead_Macron");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Dead_Macron", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Dead_Macron", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Dead_Breve, "Key_Dead_Breve");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Dead_Breve", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Dead_Breve", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Dead_Abovedot, "Key_Dead_Abovedot");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Dead_Abovedot", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Dead_Abovedot", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Dead_Diaeresis, "Key_Dead_Diaeresis");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Dead_Diaeresis", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Dead_Diaeresis", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Dead_Abovering, "Key_Dead_Abovering");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Dead_Abovering", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Dead_Abovering", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Dead_Doubleacute, "Key_Dead_Doubleacute");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Dead_Doubleacute", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Dead_Doubleacute", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Dead_Caron, "Key_Dead_Caron");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Dead_Caron", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Dead_Caron", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Dead_Cedilla, "Key_Dead_Cedilla");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Dead_Cedilla", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Dead_Cedilla", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Dead_Ogonek, "Key_Dead_Ogonek");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Dead_Ogonek", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Dead_Ogonek", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Dead_Iota, "Key_Dead_Iota");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Dead_Iota", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Dead_Iota", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Dead_Voiced_Sound, "Key_Dead_Voiced_Sound");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Dead_Voiced_Sound", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Dead_Voiced_Sound", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Dead_Semivoiced_Sound, "Key_Dead_Semivoiced_Sound");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Dead_Semivoiced_Sound", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Dead_Semivoiced_Sound", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Dead_Belowdot, "Key_Dead_Belowdot");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Dead_Belowdot", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Dead_Belowdot", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Dead_Hook, "Key_Dead_Hook");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Dead_Hook", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Dead_Hook", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Dead_Horn, "Key_Dead_Horn");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Dead_Horn", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Dead_Horn", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Back, "Key_Back");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Back", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Back", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Forward, "Key_Forward");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Forward", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Forward", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Stop, "Key_Stop");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Stop", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Stop", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Refresh, "Key_Refresh");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Refresh", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Refresh", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_VolumeDown, "Key_VolumeDown");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_VolumeDown", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_VolumeDown", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_VolumeMute, "Key_VolumeMute");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_VolumeMute", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_VolumeMute", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_VolumeUp, "Key_VolumeUp");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_VolumeUp", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_VolumeUp", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_BassBoost, "Key_BassBoost");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_BassBoost", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_BassBoost", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_BassUp, "Key_BassUp");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_BassUp", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_BassUp", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_BassDown, "Key_BassDown");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_BassDown", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_BassDown", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_TrebleUp, "Key_TrebleUp");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_TrebleUp", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_TrebleUp", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_TrebleDown, "Key_TrebleDown");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_TrebleDown", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_TrebleDown", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_MediaPlay, "Key_MediaPlay");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_MediaPlay", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_MediaPlay", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_MediaStop, "Key_MediaStop");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_MediaStop", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_MediaStop", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_MediaPrevious, "Key_MediaPrevious");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_MediaPrevious", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_MediaPrevious", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_MediaNext, "Key_MediaNext");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_MediaNext", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_MediaNext", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_MediaRecord, "Key_MediaRecord");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_MediaRecord", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_MediaRecord", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_MediaPause, "Key_MediaPause");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_MediaPause", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_MediaPause", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_MediaTogglePlayPause, "Key_MediaTogglePlayPause");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_MediaTogglePlayPause", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_MediaTogglePlayPause", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_HomePage, "Key_HomePage");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_HomePage", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_HomePage", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Favorites, "Key_Favorites");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Favorites", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Favorites", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Search, "Key_Search");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Search", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Search", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Standby, "Key_Standby");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Standby", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Standby", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_OpenUrl, "Key_OpenUrl");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_OpenUrl", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_OpenUrl", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_LaunchMail, "Key_LaunchMail");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_LaunchMail", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_LaunchMail", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_LaunchMedia, "Key_LaunchMedia");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_LaunchMedia", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_LaunchMedia", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Launch0, "Key_Launch0");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Launch0", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Launch0", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Launch1, "Key_Launch1");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Launch1", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Launch1", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Launch2, "Key_Launch2");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Launch2", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Launch2", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Launch3, "Key_Launch3");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Launch3", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Launch3", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Launch4, "Key_Launch4");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Launch4", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Launch4", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Launch5, "Key_Launch5");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Launch5", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Launch5", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Launch6, "Key_Launch6");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Launch6", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Launch6", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Launch7, "Key_Launch7");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Launch7", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Launch7", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Launch8, "Key_Launch8");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Launch8", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Launch8", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Launch9, "Key_Launch9");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Launch9", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Launch9", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_LaunchA, "Key_LaunchA");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_LaunchA", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_LaunchA", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_LaunchB, "Key_LaunchB");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_LaunchB", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_LaunchB", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_LaunchC, "Key_LaunchC");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_LaunchC", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_LaunchC", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_LaunchD, "Key_LaunchD");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_LaunchD", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_LaunchD", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_LaunchE, "Key_LaunchE");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_LaunchE", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_LaunchE", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_LaunchF, "Key_LaunchF");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_LaunchF", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_LaunchF", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_MonBrightnessUp, "Key_MonBrightnessUp");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_MonBrightnessUp", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_MonBrightnessUp", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_MonBrightnessDown, "Key_MonBrightnessDown");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_MonBrightnessDown", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_MonBrightnessDown", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_KeyboardLightOnOff, "Key_KeyboardLightOnOff");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_KeyboardLightOnOff", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_KeyboardLightOnOff", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_KeyboardBrightnessUp, "Key_KeyboardBrightnessUp");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_KeyboardBrightnessUp", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_KeyboardBrightnessUp", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_KeyboardBrightnessDown, "Key_KeyboardBrightnessDown");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_KeyboardBrightnessDown", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_KeyboardBrightnessDown", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_PowerOff, "Key_PowerOff");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_PowerOff", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_PowerOff", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_WakeUp, "Key_WakeUp");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_WakeUp", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_WakeUp", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Eject, "Key_Eject");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Eject", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Eject", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_ScreenSaver, "Key_ScreenSaver");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_ScreenSaver", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_ScreenSaver", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_WWW, "Key_WWW");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_WWW", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_WWW", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Memo, "Key_Memo");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Memo", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Memo", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_LightBulb, "Key_LightBulb");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_LightBulb", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_LightBulb", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Shop, "Key_Shop");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Shop", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Shop", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_History, "Key_History");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_History", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_History", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_AddFavorite, "Key_AddFavorite");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_AddFavorite", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_AddFavorite", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_HotLinks, "Key_HotLinks");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_HotLinks", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_HotLinks", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_BrightnessAdjust, "Key_BrightnessAdjust");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_BrightnessAdjust", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_BrightnessAdjust", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Finance, "Key_Finance");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Finance", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Finance", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Community, "Key_Community");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Community", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Community", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_AudioRewind, "Key_AudioRewind");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_AudioRewind", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_AudioRewind", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_BackForward, "Key_BackForward");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_BackForward", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_BackForward", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_ApplicationLeft, "Key_ApplicationLeft");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_ApplicationLeft", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_ApplicationLeft", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_ApplicationRight, "Key_ApplicationRight");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_ApplicationRight", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_ApplicationRight", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Book, "Key_Book");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Book", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Book", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_CD, "Key_CD");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_CD", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_CD", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Calculator, "Key_Calculator");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Calculator", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Calculator", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_ToDoList, "Key_ToDoList");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_ToDoList", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_ToDoList", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_ClearGrab, "Key_ClearGrab");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_ClearGrab", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_ClearGrab", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Close, "Key_Close");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Close", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Close", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Copy, "Key_Copy");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Copy", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Copy", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Cut, "Key_Cut");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Cut", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Cut", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Display, "Key_Display");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Display", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Display", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_DOS, "Key_DOS");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_DOS", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_DOS", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Documents, "Key_Documents");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Documents", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Documents", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Excel, "Key_Excel");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Excel", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Excel", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Explorer, "Key_Explorer");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Explorer", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Explorer", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Game, "Key_Game");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Game", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Game", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Go, "Key_Go");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Go", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Go", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_iTouch, "Key_iTouch");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_iTouch", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_iTouch", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_LogOff, "Key_LogOff");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_LogOff", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_LogOff", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Market, "Key_Market");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Market", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Market", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Meeting, "Key_Meeting");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Meeting", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Meeting", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_MenuKB, "Key_MenuKB");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_MenuKB", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_MenuKB", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_MenuPB, "Key_MenuPB");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_MenuPB", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_MenuPB", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_MySites, "Key_MySites");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_MySites", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_MySites", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_News, "Key_News");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_News", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_News", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_OfficeHome, "Key_OfficeHome");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_OfficeHome", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_OfficeHome", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Option, "Key_Option");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Option", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Option", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Paste, "Key_Paste");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Paste", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Paste", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Phone, "Key_Phone");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Phone", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Phone", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Calendar, "Key_Calendar");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Calendar", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Calendar", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Reply, "Key_Reply");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Reply", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Reply", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Reload, "Key_Reload");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Reload", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Reload", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_RotateWindows, "Key_RotateWindows");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_RotateWindows", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_RotateWindows", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_RotationPB, "Key_RotationPB");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_RotationPB", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_RotationPB", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_RotationKB, "Key_RotationKB");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_RotationKB", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_RotationKB", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Save, "Key_Save");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Save", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Save", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Send, "Key_Send");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Send", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Send", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Spell, "Key_Spell");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Spell", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Spell", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_SplitScreen, "Key_SplitScreen");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_SplitScreen", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_SplitScreen", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Support, "Key_Support");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Support", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Support", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_TaskPane, "Key_TaskPane");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_TaskPane", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_TaskPane", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Terminal, "Key_Terminal");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Terminal", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Terminal", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Tools, "Key_Tools");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Tools", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Tools", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Travel, "Key_Travel");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Travel", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Travel", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Video, "Key_Video");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Video", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Video", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Word, "Key_Word");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Word", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Word", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Xfer, "Key_Xfer");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Xfer", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Xfer", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_ZoomIn, "Key_ZoomIn");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_ZoomIn", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_ZoomIn", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_ZoomOut, "Key_ZoomOut");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_ZoomOut", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_ZoomOut", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Away, "Key_Away");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Away", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Away", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Messenger, "Key_Messenger");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Messenger", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Messenger", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_WebCam, "Key_WebCam");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_WebCam", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_WebCam", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_MailForward, "Key_MailForward");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_MailForward", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_MailForward", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Pictures, "Key_Pictures");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Pictures", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Pictures", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Music, "Key_Music");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Music", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Music", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Battery, "Key_Battery");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Battery", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Battery", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Bluetooth, "Key_Bluetooth");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Bluetooth", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Bluetooth", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_WLAN, "Key_WLAN");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_WLAN", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_WLAN", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_UWB, "Key_UWB");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_UWB", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_UWB", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_AudioForward, "Key_AudioForward");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_AudioForward", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_AudioForward", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_AudioRepeat, "Key_AudioRepeat");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_AudioRepeat", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_AudioRepeat", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_AudioRandomPlay, "Key_AudioRandomPlay");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_AudioRandomPlay", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_AudioRandomPlay", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Subtitle, "Key_Subtitle");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Subtitle", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Subtitle", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_AudioCycleTrack, "Key_AudioCycleTrack");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_AudioCycleTrack", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_AudioCycleTrack", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Time, "Key_Time");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Time", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Time", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Hibernate, "Key_Hibernate");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Hibernate", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Hibernate", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_View, "Key_View");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_View", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_View", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_TopMenu, "Key_TopMenu");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_TopMenu", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_TopMenu", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_PowerDown, "Key_PowerDown");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_PowerDown", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_PowerDown", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Suspend, "Key_Suspend");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Suspend", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Suspend", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_ContrastAdjust, "Key_ContrastAdjust");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_ContrastAdjust", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_ContrastAdjust", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_LaunchG, "Key_LaunchG");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_LaunchG", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_LaunchG", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_LaunchH, "Key_LaunchH");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_LaunchH", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_LaunchH", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_MediaLast, "Key_MediaLast");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_MediaLast", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_MediaLast", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Select, "Key_Select");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Select", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Select", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Yes, "Key_Yes");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Yes", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Yes", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_No, "Key_No");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_No", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_No", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Cancel, "Key_Cancel");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Cancel", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Cancel", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Printer, "Key_Printer");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Printer", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Printer", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Execute, "Key_Execute");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Execute", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Execute", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Sleep, "Key_Sleep");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Sleep", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Sleep", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Play, "Key_Play");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Play", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Play", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Zoom, "Key_Zoom");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Zoom", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Zoom", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Context1, "Key_Context1");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Context1", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Context1", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Context2, "Key_Context2");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Context2", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Context2", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Context3, "Key_Context3");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Context3", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Context3", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Context4, "Key_Context4");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Context4", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Context4", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Call, "Key_Call");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Call", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Call", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Hangup, "Key_Hangup");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Hangup", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Hangup", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Flip, "Key_Flip");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Flip", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Flip", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_ToggleCallHangup, "Key_ToggleCallHangup");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_ToggleCallHangup", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_ToggleCallHangup", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_VoiceDial, "Key_VoiceDial");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_VoiceDial", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_VoiceDial", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_LastNumberRedial, "Key_LastNumberRedial");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_LastNumberRedial", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_LastNumberRedial", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_Camera, "Key_Camera");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_Camera", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_Camera", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_CameraFocus, "Key_CameraFocus");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_CameraFocus", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_CameraFocus", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_Key,(long) Qt::Key_unknown, "Key_unknown");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Key_unknown", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_Key->tp_dict,"Key_unknown", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("Qt::Key");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::Key");
    // end of enum Key

    // init enum: ApplicationAttribute
    PyTypeObject* SbkPySide_QtCore_Qt_ApplicationAttribute = Shiboken::Enum::newType("ApplicationAttribute");
    SbkPySide_QtCoreTypes[SBK_QT_APPLICATIONATTRIBUTE_IDX] = SbkPySide_QtCore_Qt_ApplicationAttribute;
    if (PyType_Ready(SbkPySide_QtCore_Qt_ApplicationAttribute) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "ApplicationAttribute",((PyObject*)SbkPySide_QtCore_Qt_ApplicationAttribute));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ApplicationAttribute,(long) Qt::AA_ImmediateWidgetCreation, "AA_ImmediateWidgetCreation");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"AA_ImmediateWidgetCreation", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ApplicationAttribute->tp_dict,"AA_ImmediateWidgetCreation", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ApplicationAttribute,(long) Qt::AA_MSWindowsUseDirect3DByDefault, "AA_MSWindowsUseDirect3DByDefault");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"AA_MSWindowsUseDirect3DByDefault", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ApplicationAttribute->tp_dict,"AA_MSWindowsUseDirect3DByDefault", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ApplicationAttribute,(long) Qt::AA_DontShowIconsInMenus, "AA_DontShowIconsInMenus");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"AA_DontShowIconsInMenus", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ApplicationAttribute->tp_dict,"AA_DontShowIconsInMenus", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ApplicationAttribute,(long) Qt::AA_NativeWindows, "AA_NativeWindows");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"AA_NativeWindows", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ApplicationAttribute->tp_dict,"AA_NativeWindows", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ApplicationAttribute,(long) Qt::AA_DontCreateNativeWidgetSiblings, "AA_DontCreateNativeWidgetSiblings");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"AA_DontCreateNativeWidgetSiblings", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ApplicationAttribute->tp_dict,"AA_DontCreateNativeWidgetSiblings", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ApplicationAttribute,(long) Qt::AA_MacPluginApplication, "AA_MacPluginApplication");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"AA_MacPluginApplication", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ApplicationAttribute->tp_dict,"AA_MacPluginApplication", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ApplicationAttribute,(long) Qt::AA_DontUseNativeMenuBar, "AA_DontUseNativeMenuBar");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"AA_DontUseNativeMenuBar", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ApplicationAttribute->tp_dict,"AA_DontUseNativeMenuBar", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ApplicationAttribute,(long) Qt::AA_MacDontSwapCtrlAndMeta, "AA_MacDontSwapCtrlAndMeta");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"AA_MacDontSwapCtrlAndMeta", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ApplicationAttribute->tp_dict,"AA_MacDontSwapCtrlAndMeta", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ApplicationAttribute,(long) Qt::AA_S60DontConstructApplicationPanes, "AA_S60DontConstructApplicationPanes");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"AA_S60DontConstructApplicationPanes", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ApplicationAttribute->tp_dict,"AA_S60DontConstructApplicationPanes", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_ApplicationAttribute,(long) Qt::AA_AttributeCount, "AA_AttributeCount");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"AA_AttributeCount", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_ApplicationAttribute->tp_dict,"AA_AttributeCount", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("Qt::ApplicationAttribute");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::ApplicationAttribute");
    // end of enum ApplicationAttribute

    // init enum: TextFlag
    PyTypeObject* SbkPySide_QtCore_Qt_TextFlag = Shiboken::Enum::newType("TextFlag");
    SbkPySide_QtCoreTypes[SBK_QT_TEXTFLAG_IDX] = SbkPySide_QtCore_Qt_TextFlag;
    if (PyType_Ready(SbkPySide_QtCore_Qt_TextFlag) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "TextFlag",((PyObject*)SbkPySide_QtCore_Qt_TextFlag));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_TextFlag,(long) Qt::TextSingleLine, "TextSingleLine");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"TextSingleLine", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_TextFlag->tp_dict,"TextSingleLine", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_TextFlag,(long) Qt::TextDontClip, "TextDontClip");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"TextDontClip", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_TextFlag->tp_dict,"TextDontClip", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_TextFlag,(long) Qt::TextExpandTabs, "TextExpandTabs");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"TextExpandTabs", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_TextFlag->tp_dict,"TextExpandTabs", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_TextFlag,(long) Qt::TextShowMnemonic, "TextShowMnemonic");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"TextShowMnemonic", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_TextFlag->tp_dict,"TextShowMnemonic", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_TextFlag,(long) Qt::TextWordWrap, "TextWordWrap");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"TextWordWrap", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_TextFlag->tp_dict,"TextWordWrap", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_TextFlag,(long) Qt::TextWrapAnywhere, "TextWrapAnywhere");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"TextWrapAnywhere", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_TextFlag->tp_dict,"TextWrapAnywhere", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_TextFlag,(long) Qt::TextDontPrint, "TextDontPrint");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"TextDontPrint", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_TextFlag->tp_dict,"TextDontPrint", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_TextFlag,(long) Qt::TextIncludeTrailingSpaces, "TextIncludeTrailingSpaces");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"TextIncludeTrailingSpaces", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_TextFlag->tp_dict,"TextIncludeTrailingSpaces", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_TextFlag,(long) Qt::TextHideMnemonic, "TextHideMnemonic");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"TextHideMnemonic", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_TextFlag->tp_dict,"TextHideMnemonic", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_TextFlag,(long) Qt::TextJustificationForced, "TextJustificationForced");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"TextJustificationForced", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_TextFlag->tp_dict,"TextJustificationForced", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_TextFlag,(long) Qt::TextForceLeftToRight, "TextForceLeftToRight");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"TextForceLeftToRight", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_TextFlag->tp_dict,"TextForceLeftToRight", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_TextFlag,(long) Qt::TextForceRightToLeft, "TextForceRightToLeft");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"TextForceRightToLeft", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_TextFlag->tp_dict,"TextForceRightToLeft", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_TextFlag,(long) Qt::TextLongestVariant, "TextLongestVariant");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"TextLongestVariant", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_TextFlag->tp_dict,"TextLongestVariant", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_TextFlag,(long) Qt::TextBypassShaping, "TextBypassShaping");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"TextBypassShaping", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_TextFlag->tp_dict,"TextBypassShaping", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("Qt::TextFlag");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::TextFlag");
    // end of enum TextFlag

    // init enum: BrushStyle
    PyTypeObject* SbkPySide_QtCore_Qt_BrushStyle = Shiboken::Enum::newType("BrushStyle");
    SbkPySide_QtCoreTypes[SBK_QT_BRUSHSTYLE_IDX] = SbkPySide_QtCore_Qt_BrushStyle;
    if (PyType_Ready(SbkPySide_QtCore_Qt_BrushStyle) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "BrushStyle",((PyObject*)SbkPySide_QtCore_Qt_BrushStyle));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_BrushStyle,(long) Qt::NoBrush, "NoBrush");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"NoBrush", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_BrushStyle->tp_dict,"NoBrush", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_BrushStyle,(long) Qt::SolidPattern, "SolidPattern");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"SolidPattern", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_BrushStyle->tp_dict,"SolidPattern", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_BrushStyle,(long) Qt::Dense1Pattern, "Dense1Pattern");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Dense1Pattern", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_BrushStyle->tp_dict,"Dense1Pattern", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_BrushStyle,(long) Qt::Dense2Pattern, "Dense2Pattern");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Dense2Pattern", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_BrushStyle->tp_dict,"Dense2Pattern", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_BrushStyle,(long) Qt::Dense3Pattern, "Dense3Pattern");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Dense3Pattern", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_BrushStyle->tp_dict,"Dense3Pattern", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_BrushStyle,(long) Qt::Dense4Pattern, "Dense4Pattern");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Dense4Pattern", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_BrushStyle->tp_dict,"Dense4Pattern", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_BrushStyle,(long) Qt::Dense5Pattern, "Dense5Pattern");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Dense5Pattern", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_BrushStyle->tp_dict,"Dense5Pattern", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_BrushStyle,(long) Qt::Dense6Pattern, "Dense6Pattern");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Dense6Pattern", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_BrushStyle->tp_dict,"Dense6Pattern", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_BrushStyle,(long) Qt::Dense7Pattern, "Dense7Pattern");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"Dense7Pattern", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_BrushStyle->tp_dict,"Dense7Pattern", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_BrushStyle,(long) Qt::HorPattern, "HorPattern");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"HorPattern", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_BrushStyle->tp_dict,"HorPattern", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_BrushStyle,(long) Qt::VerPattern, "VerPattern");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"VerPattern", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_BrushStyle->tp_dict,"VerPattern", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_BrushStyle,(long) Qt::CrossPattern, "CrossPattern");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"CrossPattern", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_BrushStyle->tp_dict,"CrossPattern", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_BrushStyle,(long) Qt::BDiagPattern, "BDiagPattern");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"BDiagPattern", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_BrushStyle->tp_dict,"BDiagPattern", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_BrushStyle,(long) Qt::FDiagPattern, "FDiagPattern");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"FDiagPattern", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_BrushStyle->tp_dict,"FDiagPattern", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_BrushStyle,(long) Qt::DiagCrossPattern, "DiagCrossPattern");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"DiagCrossPattern", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_BrushStyle->tp_dict,"DiagCrossPattern", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_BrushStyle,(long) Qt::LinearGradientPattern, "LinearGradientPattern");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"LinearGradientPattern", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_BrushStyle->tp_dict,"LinearGradientPattern", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_BrushStyle,(long) Qt::RadialGradientPattern, "RadialGradientPattern");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"RadialGradientPattern", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_BrushStyle->tp_dict,"RadialGradientPattern", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_BrushStyle,(long) Qt::ConicalGradientPattern, "ConicalGradientPattern");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"ConicalGradientPattern", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_BrushStyle->tp_dict,"ConicalGradientPattern", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_BrushStyle,(long) Qt::TexturePattern, "TexturePattern");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"TexturePattern", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_BrushStyle->tp_dict,"TexturePattern", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("Qt::BrushStyle");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::BrushStyle");
    // end of enum BrushStyle

    // init enum: WidgetAttribute
    PyTypeObject* SbkPySide_QtCore_Qt_WidgetAttribute = Shiboken::Enum::newType("WidgetAttribute");
    SbkPySide_QtCoreTypes[SBK_QT_WIDGETATTRIBUTE_IDX] = SbkPySide_QtCore_Qt_WidgetAttribute;
    if (PyType_Ready(SbkPySide_QtCore_Qt_WidgetAttribute) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "WidgetAttribute",((PyObject*)SbkPySide_QtCore_Qt_WidgetAttribute));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_Disabled, "WA_Disabled");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_Disabled", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_Disabled", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_UnderMouse, "WA_UnderMouse");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_UnderMouse", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_UnderMouse", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_MouseTracking, "WA_MouseTracking");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_MouseTracking", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_MouseTracking", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_ContentsPropagated, "WA_ContentsPropagated");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_ContentsPropagated", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_ContentsPropagated", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_OpaquePaintEvent, "WA_OpaquePaintEvent");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_OpaquePaintEvent", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_OpaquePaintEvent", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_NoBackground, "WA_NoBackground");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_NoBackground", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_NoBackground", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_StaticContents, "WA_StaticContents");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_StaticContents", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_StaticContents", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_LaidOut, "WA_LaidOut");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_LaidOut", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_LaidOut", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_PaintOnScreen, "WA_PaintOnScreen");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_PaintOnScreen", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_PaintOnScreen", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_NoSystemBackground, "WA_NoSystemBackground");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_NoSystemBackground", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_NoSystemBackground", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_UpdatesDisabled, "WA_UpdatesDisabled");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_UpdatesDisabled", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_UpdatesDisabled", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_Mapped, "WA_Mapped");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_Mapped", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_Mapped", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_MacNoClickThrough, "WA_MacNoClickThrough");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_MacNoClickThrough", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_MacNoClickThrough", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_PaintOutsidePaintEvent, "WA_PaintOutsidePaintEvent");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_PaintOutsidePaintEvent", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_PaintOutsidePaintEvent", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_InputMethodEnabled, "WA_InputMethodEnabled");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_InputMethodEnabled", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_InputMethodEnabled", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_WState_Visible, "WA_WState_Visible");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_WState_Visible", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_WState_Visible", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_WState_Hidden, "WA_WState_Hidden");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_WState_Hidden", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_WState_Hidden", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_ForceDisabled, "WA_ForceDisabled");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_ForceDisabled", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_ForceDisabled", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_KeyCompression, "WA_KeyCompression");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_KeyCompression", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_KeyCompression", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_PendingMoveEvent, "WA_PendingMoveEvent");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_PendingMoveEvent", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_PendingMoveEvent", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_PendingResizeEvent, "WA_PendingResizeEvent");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_PendingResizeEvent", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_PendingResizeEvent", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_SetPalette, "WA_SetPalette");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_SetPalette", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_SetPalette", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_SetFont, "WA_SetFont");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_SetFont", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_SetFont", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_SetCursor, "WA_SetCursor");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_SetCursor", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_SetCursor", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_NoChildEventsFromChildren, "WA_NoChildEventsFromChildren");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_NoChildEventsFromChildren", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_NoChildEventsFromChildren", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_WindowModified, "WA_WindowModified");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_WindowModified", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_WindowModified", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_Resized, "WA_Resized");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_Resized", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_Resized", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_Moved, "WA_Moved");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_Moved", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_Moved", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_PendingUpdate, "WA_PendingUpdate");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_PendingUpdate", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_PendingUpdate", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_InvalidSize, "WA_InvalidSize");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_InvalidSize", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_InvalidSize", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_MacBrushedMetal, "WA_MacBrushedMetal");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_MacBrushedMetal", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_MacBrushedMetal", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_MacMetalStyle, "WA_MacMetalStyle");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_MacMetalStyle", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_MacMetalStyle", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_CustomWhatsThis, "WA_CustomWhatsThis");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_CustomWhatsThis", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_CustomWhatsThis", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_LayoutOnEntireRect, "WA_LayoutOnEntireRect");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_LayoutOnEntireRect", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_LayoutOnEntireRect", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_OutsideWSRange, "WA_OutsideWSRange");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_OutsideWSRange", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_OutsideWSRange", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_GrabbedShortcut, "WA_GrabbedShortcut");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_GrabbedShortcut", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_GrabbedShortcut", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_TransparentForMouseEvents, "WA_TransparentForMouseEvents");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_TransparentForMouseEvents", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_TransparentForMouseEvents", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_PaintUnclipped, "WA_PaintUnclipped");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_PaintUnclipped", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_PaintUnclipped", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_SetWindowIcon, "WA_SetWindowIcon");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_SetWindowIcon", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_SetWindowIcon", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_NoMouseReplay, "WA_NoMouseReplay");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_NoMouseReplay", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_NoMouseReplay", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_DeleteOnClose, "WA_DeleteOnClose");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_DeleteOnClose", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_DeleteOnClose", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_RightToLeft, "WA_RightToLeft");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_RightToLeft", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_RightToLeft", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_SetLayoutDirection, "WA_SetLayoutDirection");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_SetLayoutDirection", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_SetLayoutDirection", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_NoChildEventsForParent, "WA_NoChildEventsForParent");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_NoChildEventsForParent", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_NoChildEventsForParent", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_ForceUpdatesDisabled, "WA_ForceUpdatesDisabled");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_ForceUpdatesDisabled", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_ForceUpdatesDisabled", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_WState_Created, "WA_WState_Created");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_WState_Created", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_WState_Created", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_WState_CompressKeys, "WA_WState_CompressKeys");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_WState_CompressKeys", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_WState_CompressKeys", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_WState_InPaintEvent, "WA_WState_InPaintEvent");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_WState_InPaintEvent", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_WState_InPaintEvent", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_WState_Reparented, "WA_WState_Reparented");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_WState_Reparented", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_WState_Reparented", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_WState_ConfigPending, "WA_WState_ConfigPending");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_WState_ConfigPending", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_WState_ConfigPending", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_WState_Polished, "WA_WState_Polished");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_WState_Polished", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_WState_Polished", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_WState_DND, "WA_WState_DND");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_WState_DND", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_WState_DND", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_WState_OwnSizePolicy, "WA_WState_OwnSizePolicy");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_WState_OwnSizePolicy", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_WState_OwnSizePolicy", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_WState_ExplicitShowHide, "WA_WState_ExplicitShowHide");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_WState_ExplicitShowHide", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_WState_ExplicitShowHide", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_ShowModal, "WA_ShowModal");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_ShowModal", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_ShowModal", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_MouseNoMask, "WA_MouseNoMask");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_MouseNoMask", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_MouseNoMask", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_GroupLeader, "WA_GroupLeader");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_GroupLeader", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_GroupLeader", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_NoMousePropagation, "WA_NoMousePropagation");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_NoMousePropagation", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_NoMousePropagation", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_Hover, "WA_Hover");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_Hover", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_Hover", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_InputMethodTransparent, "WA_InputMethodTransparent");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_InputMethodTransparent", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_InputMethodTransparent", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_QuitOnClose, "WA_QuitOnClose");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_QuitOnClose", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_QuitOnClose", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_KeyboardFocusChange, "WA_KeyboardFocusChange");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_KeyboardFocusChange", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_KeyboardFocusChange", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_AcceptDrops, "WA_AcceptDrops");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_AcceptDrops", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_AcceptDrops", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_DropSiteRegistered, "WA_DropSiteRegistered");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_DropSiteRegistered", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_DropSiteRegistered", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_ForceAcceptDrops, "WA_ForceAcceptDrops");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_ForceAcceptDrops", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_ForceAcceptDrops", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_WindowPropagation, "WA_WindowPropagation");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_WindowPropagation", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_WindowPropagation", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_NoX11EventCompression, "WA_NoX11EventCompression");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_NoX11EventCompression", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_NoX11EventCompression", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_TintedBackground, "WA_TintedBackground");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_TintedBackground", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_TintedBackground", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_X11OpenGLOverlay, "WA_X11OpenGLOverlay");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_X11OpenGLOverlay", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_X11OpenGLOverlay", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_AlwaysShowToolTips, "WA_AlwaysShowToolTips");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_AlwaysShowToolTips", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_AlwaysShowToolTips", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_MacOpaqueSizeGrip, "WA_MacOpaqueSizeGrip");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_MacOpaqueSizeGrip", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_MacOpaqueSizeGrip", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_SetStyle, "WA_SetStyle");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_SetStyle", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_SetStyle", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_SetLocale, "WA_SetLocale");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_SetLocale", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_SetLocale", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_MacShowFocusRect, "WA_MacShowFocusRect");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_MacShowFocusRect", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_MacShowFocusRect", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_MacNormalSize, "WA_MacNormalSize");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_MacNormalSize", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_MacNormalSize", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_MacSmallSize, "WA_MacSmallSize");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_MacSmallSize", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_MacSmallSize", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_MacMiniSize, "WA_MacMiniSize");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_MacMiniSize", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_MacMiniSize", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_LayoutUsesWidgetRect, "WA_LayoutUsesWidgetRect");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_LayoutUsesWidgetRect", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_LayoutUsesWidgetRect", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_StyledBackground, "WA_StyledBackground");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_StyledBackground", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_StyledBackground", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_MSWindowsUseDirect3D, "WA_MSWindowsUseDirect3D");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_MSWindowsUseDirect3D", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_MSWindowsUseDirect3D", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_CanHostQMdiSubWindowTitleBar, "WA_CanHostQMdiSubWindowTitleBar");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_CanHostQMdiSubWindowTitleBar", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_CanHostQMdiSubWindowTitleBar", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_MacAlwaysShowToolWindow, "WA_MacAlwaysShowToolWindow");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_MacAlwaysShowToolWindow", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_MacAlwaysShowToolWindow", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_StyleSheet, "WA_StyleSheet");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_StyleSheet", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_StyleSheet", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_ShowWithoutActivating, "WA_ShowWithoutActivating");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_ShowWithoutActivating", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_ShowWithoutActivating", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_X11BypassTransientForHint, "WA_X11BypassTransientForHint");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_X11BypassTransientForHint", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_X11BypassTransientForHint", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_NativeWindow, "WA_NativeWindow");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_NativeWindow", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_NativeWindow", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_DontCreateNativeAncestors, "WA_DontCreateNativeAncestors");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_DontCreateNativeAncestors", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_DontCreateNativeAncestors", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_MacVariableSize, "WA_MacVariableSize");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_MacVariableSize", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_MacVariableSize", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_DontShowOnScreen, "WA_DontShowOnScreen");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_DontShowOnScreen", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_DontShowOnScreen", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_X11NetWmWindowTypeDesktop, "WA_X11NetWmWindowTypeDesktop");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_X11NetWmWindowTypeDesktop", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_X11NetWmWindowTypeDesktop", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_X11NetWmWindowTypeDock, "WA_X11NetWmWindowTypeDock");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_X11NetWmWindowTypeDock", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_X11NetWmWindowTypeDock", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_X11NetWmWindowTypeToolBar, "WA_X11NetWmWindowTypeToolBar");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_X11NetWmWindowTypeToolBar", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_X11NetWmWindowTypeToolBar", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_X11NetWmWindowTypeMenu, "WA_X11NetWmWindowTypeMenu");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_X11NetWmWindowTypeMenu", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_X11NetWmWindowTypeMenu", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_X11NetWmWindowTypeUtility, "WA_X11NetWmWindowTypeUtility");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_X11NetWmWindowTypeUtility", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_X11NetWmWindowTypeUtility", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_X11NetWmWindowTypeSplash, "WA_X11NetWmWindowTypeSplash");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_X11NetWmWindowTypeSplash", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_X11NetWmWindowTypeSplash", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_X11NetWmWindowTypeDialog, "WA_X11NetWmWindowTypeDialog");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_X11NetWmWindowTypeDialog", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_X11NetWmWindowTypeDialog", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_X11NetWmWindowTypeDropDownMenu, "WA_X11NetWmWindowTypeDropDownMenu");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_X11NetWmWindowTypeDropDownMenu", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_X11NetWmWindowTypeDropDownMenu", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_X11NetWmWindowTypePopupMenu, "WA_X11NetWmWindowTypePopupMenu");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_X11NetWmWindowTypePopupMenu", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_X11NetWmWindowTypePopupMenu", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_X11NetWmWindowTypeToolTip, "WA_X11NetWmWindowTypeToolTip");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_X11NetWmWindowTypeToolTip", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_X11NetWmWindowTypeToolTip", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_X11NetWmWindowTypeNotification, "WA_X11NetWmWindowTypeNotification");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_X11NetWmWindowTypeNotification", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_X11NetWmWindowTypeNotification", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_X11NetWmWindowTypeCombo, "WA_X11NetWmWindowTypeCombo");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_X11NetWmWindowTypeCombo", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_X11NetWmWindowTypeCombo", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_X11NetWmWindowTypeDND, "WA_X11NetWmWindowTypeDND");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_X11NetWmWindowTypeDND", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_X11NetWmWindowTypeDND", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_MacFrameworkScaled, "WA_MacFrameworkScaled");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_MacFrameworkScaled", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_MacFrameworkScaled", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_SetWindowModality, "WA_SetWindowModality");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_SetWindowModality", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_SetWindowModality", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_WState_WindowOpacitySet, "WA_WState_WindowOpacitySet");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_WState_WindowOpacitySet", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_WState_WindowOpacitySet", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_TranslucentBackground, "WA_TranslucentBackground");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_TranslucentBackground", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_TranslucentBackground", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_AcceptTouchEvents, "WA_AcceptTouchEvents");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_AcceptTouchEvents", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_AcceptTouchEvents", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_WState_AcceptedTouchBeginEvent, "WA_WState_AcceptedTouchBeginEvent");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_WState_AcceptedTouchBeginEvent", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_WState_AcceptedTouchBeginEvent", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_TouchPadAcceptSingleTouchEvents, "WA_TouchPadAcceptSingleTouchEvents");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_TouchPadAcceptSingleTouchEvents", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_TouchPadAcceptSingleTouchEvents", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_MergeSoftkeys, "WA_MergeSoftkeys");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_MergeSoftkeys", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_MergeSoftkeys", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_MergeSoftkeysRecursively, "WA_MergeSoftkeysRecursively");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_MergeSoftkeysRecursively", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_MergeSoftkeysRecursively", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_X11DoNotAcceptFocus, "WA_X11DoNotAcceptFocus");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_X11DoNotAcceptFocus", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_X11DoNotAcceptFocus", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_WidgetAttribute,(long) Qt::WA_AttributeCount, "WA_AttributeCount");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"WA_AttributeCount", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_WidgetAttribute->tp_dict,"WA_AttributeCount", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("Qt::WidgetAttribute");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::WidgetAttribute");
    // end of enum WidgetAttribute

    // init enum: TouchPointState
    PyTypeObject* SbkPySide_QtCore_Qt_TouchPointState = Shiboken::Enum::newType("TouchPointState");
    SbkPySide_QtCoreTypes[SBK_QT_TOUCHPOINTSTATE_IDX] = SbkPySide_QtCore_Qt_TouchPointState;
    if (PyType_Ready(SbkPySide_QtCore_Qt_TouchPointState) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "TouchPointState",((PyObject*)SbkPySide_QtCore_Qt_TouchPointState));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_TouchPointState,(long) Qt::TouchPointPressed, "TouchPointPressed");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"TouchPointPressed", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_TouchPointState->tp_dict,"TouchPointPressed", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_TouchPointState,(long) Qt::TouchPointMoved, "TouchPointMoved");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"TouchPointMoved", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_TouchPointState->tp_dict,"TouchPointMoved", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_TouchPointState,(long) Qt::TouchPointStationary, "TouchPointStationary");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"TouchPointStationary", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_TouchPointState->tp_dict,"TouchPointStationary", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_TouchPointState,(long) Qt::TouchPointReleased, "TouchPointReleased");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"TouchPointReleased", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_TouchPointState->tp_dict,"TouchPointReleased", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_TouchPointState,(long) Qt::TouchPointStateMask, "TouchPointStateMask");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"TouchPointStateMask", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_TouchPointState->tp_dict,"TouchPointStateMask", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_TouchPointState,(long) Qt::TouchPointPrimary, "TouchPointPrimary");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"TouchPointPrimary", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_TouchPointState->tp_dict,"TouchPointPrimary", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("Qt::TouchPointState");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::TouchPointState");
    // end of enum TouchPointState

    // init enum: TextInteractionFlag
    PyTypeObject* SbkPySide_QtCore_Qt_TextInteractionFlag = Shiboken::Enum::newType("TextInteractionFlag");
    SbkPySide_QtCore_Qt_TextInteractionFlag->tp_as_number = &SbkPySide_QtCore_Qt_TextInteractionFlag_as_number;
    SbkPySide_QtCoreTypes[SBK_QT_TEXTINTERACTIONFLAG_IDX] = SbkPySide_QtCore_Qt_TextInteractionFlag;
    if (PyType_Ready(SbkPySide_QtCore_Qt_TextInteractionFlag) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "TextInteractionFlag",((PyObject*)SbkPySide_QtCore_Qt_TextInteractionFlag));

    // init flags class: QFlags<Qt::TextInteractionFlag>
    SbkPySide_QtCoreTypes[SBK_QFLAGS_QT_TEXTINTERACTIONFLAG__IDX] = &SbkPySide_QtCore_Qt_TextInteractionFlags_Type;
    if (PyType_Ready((PyTypeObject*)&SbkPySide_QtCore_Qt_TextInteractionFlags_Type) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "TextInteractionFlags",((PyObject*)&SbkPySide_QtCore_Qt_TextInteractionFlags_Type));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_TextInteractionFlag,(long) Qt::NoTextInteraction, "NoTextInteraction");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"NoTextInteraction", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_TextInteractionFlag->tp_dict,"NoTextInteraction", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_TextInteractionFlag,(long) Qt::TextSelectableByMouse, "TextSelectableByMouse");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"TextSelectableByMouse", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_TextInteractionFlag->tp_dict,"TextSelectableByMouse", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_TextInteractionFlag,(long) Qt::TextSelectableByKeyboard, "TextSelectableByKeyboard");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"TextSelectableByKeyboard", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_TextInteractionFlag->tp_dict,"TextSelectableByKeyboard", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_TextInteractionFlag,(long) Qt::LinksAccessibleByMouse, "LinksAccessibleByMouse");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"LinksAccessibleByMouse", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_TextInteractionFlag->tp_dict,"LinksAccessibleByMouse", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_TextInteractionFlag,(long) Qt::LinksAccessibleByKeyboard, "LinksAccessibleByKeyboard");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"LinksAccessibleByKeyboard", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_TextInteractionFlag->tp_dict,"LinksAccessibleByKeyboard", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_TextInteractionFlag,(long) Qt::TextEditable, "TextEditable");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"TextEditable", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_TextInteractionFlag->tp_dict,"TextEditable", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_TextInteractionFlag,(long) Qt::TextEditorInteraction, "TextEditorInteraction");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"TextEditorInteraction", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_TextInteractionFlag->tp_dict,"TextEditorInteraction", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_TextInteractionFlag,(long) Qt::TextBrowserInteraction, "TextBrowserInteraction");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"TextBrowserInteraction", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_TextInteractionFlag->tp_dict,"TextBrowserInteraction", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("Qt::TextInteractionFlag");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::TextInteractionFlag");
    // end of enum TextInteractionFlag

    // init enum: MouseButton
    PyTypeObject* SbkPySide_QtCore_Qt_MouseButton = Shiboken::Enum::newType("MouseButton");
    SbkPySide_QtCore_Qt_MouseButton->tp_as_number = &SbkPySide_QtCore_Qt_MouseButton_as_number;
    SbkPySide_QtCoreTypes[SBK_QT_MOUSEBUTTON_IDX] = SbkPySide_QtCore_Qt_MouseButton;
    if (PyType_Ready(SbkPySide_QtCore_Qt_MouseButton) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "MouseButton",((PyObject*)SbkPySide_QtCore_Qt_MouseButton));

    // init flags class: QFlags<Qt::MouseButton>
    SbkPySide_QtCoreTypes[SBK_QFLAGS_QT_MOUSEBUTTON__IDX] = &SbkPySide_QtCore_Qt_MouseButtons_Type;
    if (PyType_Ready((PyTypeObject*)&SbkPySide_QtCore_Qt_MouseButtons_Type) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "MouseButtons",((PyObject*)&SbkPySide_QtCore_Qt_MouseButtons_Type));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_MouseButton,(long) Qt::NoButton, "NoButton");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"NoButton", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_MouseButton->tp_dict,"NoButton", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_MouseButton,(long) Qt::LeftButton, "LeftButton");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"LeftButton", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_MouseButton->tp_dict,"LeftButton", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_MouseButton,(long) Qt::RightButton, "RightButton");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"RightButton", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_MouseButton->tp_dict,"RightButton", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_MouseButton,(long) Qt::MidButton, "MidButton");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"MidButton", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_MouseButton->tp_dict,"MidButton", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_MouseButton,(long) Qt::MiddleButton, "MiddleButton");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"MiddleButton", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_MouseButton->tp_dict,"MiddleButton", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_MouseButton,(long) Qt::XButton1, "XButton1");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"XButton1", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_MouseButton->tp_dict,"XButton1", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_MouseButton,(long) Qt::XButton2, "XButton2");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"XButton2", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_MouseButton->tp_dict,"XButton2", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_MouseButton,(long) Qt::MouseButtonMask, "MouseButtonMask");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"MouseButtonMask", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_MouseButton->tp_dict,"MouseButtonMask", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("Qt::MouseButton");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::MouseButton");
    // end of enum MouseButton

    // init enum: MatchFlag
    PyTypeObject* SbkPySide_QtCore_Qt_MatchFlag = Shiboken::Enum::newType("MatchFlag");
    SbkPySide_QtCore_Qt_MatchFlag->tp_as_number = &SbkPySide_QtCore_Qt_MatchFlag_as_number;
    SbkPySide_QtCoreTypes[SBK_QT_MATCHFLAG_IDX] = SbkPySide_QtCore_Qt_MatchFlag;
    if (PyType_Ready(SbkPySide_QtCore_Qt_MatchFlag) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "MatchFlag",((PyObject*)SbkPySide_QtCore_Qt_MatchFlag));

    // init flags class: QFlags<Qt::MatchFlag>
    SbkPySide_QtCoreTypes[SBK_QFLAGS_QT_MATCHFLAG__IDX] = &SbkPySide_QtCore_Qt_MatchFlags_Type;
    if (PyType_Ready((PyTypeObject*)&SbkPySide_QtCore_Qt_MatchFlags_Type) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "MatchFlags",((PyObject*)&SbkPySide_QtCore_Qt_MatchFlags_Type));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_MatchFlag,(long) Qt::MatchExactly, "MatchExactly");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"MatchExactly", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_MatchFlag->tp_dict,"MatchExactly", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_MatchFlag,(long) Qt::MatchContains, "MatchContains");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"MatchContains", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_MatchFlag->tp_dict,"MatchContains", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_MatchFlag,(long) Qt::MatchStartsWith, "MatchStartsWith");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"MatchStartsWith", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_MatchFlag->tp_dict,"MatchStartsWith", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_MatchFlag,(long) Qt::MatchEndsWith, "MatchEndsWith");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"MatchEndsWith", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_MatchFlag->tp_dict,"MatchEndsWith", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_MatchFlag,(long) Qt::MatchRegExp, "MatchRegExp");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"MatchRegExp", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_MatchFlag->tp_dict,"MatchRegExp", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_MatchFlag,(long) Qt::MatchWildcard, "MatchWildcard");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"MatchWildcard", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_MatchFlag->tp_dict,"MatchWildcard", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_MatchFlag,(long) Qt::MatchFixedString, "MatchFixedString");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"MatchFixedString", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_MatchFlag->tp_dict,"MatchFixedString", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_MatchFlag,(long) Qt::MatchCaseSensitive, "MatchCaseSensitive");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"MatchCaseSensitive", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_MatchFlag->tp_dict,"MatchCaseSensitive", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_MatchFlag,(long) Qt::MatchWrap, "MatchWrap");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"MatchWrap", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_MatchFlag->tp_dict,"MatchWrap", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_MatchFlag,(long) Qt::MatchRecursive, "MatchRecursive");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"MatchRecursive", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_MatchFlag->tp_dict,"MatchRecursive", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("Qt::MatchFlag");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::MatchFlag");
    // end of enum MatchFlag

    // init enum: PenCapStyle
    PyTypeObject* SbkPySide_QtCore_Qt_PenCapStyle = Shiboken::Enum::newType("PenCapStyle");
    SbkPySide_QtCoreTypes[SBK_QT_PENCAPSTYLE_IDX] = SbkPySide_QtCore_Qt_PenCapStyle;
    if (PyType_Ready(SbkPySide_QtCore_Qt_PenCapStyle) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "PenCapStyle",((PyObject*)SbkPySide_QtCore_Qt_PenCapStyle));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_PenCapStyle,(long) Qt::FlatCap, "FlatCap");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"FlatCap", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_PenCapStyle->tp_dict,"FlatCap", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_PenCapStyle,(long) Qt::SquareCap, "SquareCap");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"SquareCap", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_PenCapStyle->tp_dict,"SquareCap", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_PenCapStyle,(long) Qt::RoundCap, "RoundCap");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"RoundCap", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_PenCapStyle->tp_dict,"RoundCap", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_PenCapStyle,(long) Qt::MPenCapStyle, "MPenCapStyle");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"MPenCapStyle", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_PenCapStyle->tp_dict,"MPenCapStyle", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("Qt::PenCapStyle");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::PenCapStyle");
    // end of enum PenCapStyle

    // init enum: TextElideMode
    PyTypeObject* SbkPySide_QtCore_Qt_TextElideMode = Shiboken::Enum::newType("TextElideMode");
    SbkPySide_QtCoreTypes[SBK_QT_TEXTELIDEMODE_IDX] = SbkPySide_QtCore_Qt_TextElideMode;
    if (PyType_Ready(SbkPySide_QtCore_Qt_TextElideMode) < 0)
        return;
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,
            "TextElideMode",((PyObject*)SbkPySide_QtCore_Qt_TextElideMode));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_TextElideMode,(long) Qt::ElideLeft, "ElideLeft");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"ElideLeft", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_TextElideMode->tp_dict,"ElideLeft", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_TextElideMode,(long) Qt::ElideRight, "ElideRight");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"ElideRight", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_TextElideMode->tp_dict,"ElideRight", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_TextElideMode,(long) Qt::ElideMiddle, "ElideMiddle");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"ElideMiddle", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_TextElideMode->tp_dict,"ElideMiddle", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtCore_Qt_TextElideMode,(long) Qt::ElideNone, "ElideNone");
    PyDict_SetItemString(Sbk_Qt_Type.super.ht_type.tp_dict,"ElideNone", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtCore_Qt_TextElideMode->tp_dict,"ElideNone", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("Qt::TextElideMode");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::TextElideMode");
    // end of enum TextElideMode


}

